/*
 * (C) Copyright 2013
 * DSPG Technologies GmbH
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __COMMAND_H__
#define __COMMAND_H__

typedef unsigned char (*CommandFunction)(unsigned char argc, char * argv[]);  

typedef struct 
{
	const char * command;
	CommandFunction function;  
	const char * description;
} Command;

unsigned char cmdVersion(unsigned char argc , char * argv[]);
unsigned char cmdHelp(unsigned char argc, char * argv[]);
unsigned char cmdExit(unsigned char argc, char * argv[]);

#define COMMAND_BASE \
	{"ver",		cmdVersion,	"display version information"}, \
	{"help",	cmdHelp,	"display this help information"}, \
	{"exit",	cmdExit,	"exit moniter"}, \

/*!
*****************************************************************************

 \fn void monitor (Command * commands, int commandsCount);

 <b>Description:</b>\n
 main loop of monitor will be started and run until exit command is input

 \param[in] commands		array of Command

******************************************************************************/
void monitor(Command * commandsList );

#endif /* __COMMAND_H__ */
