/*
 * (C) Copyright 2013
 * DSPG Technologies GmbH
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include "tools.h"
#include "io.h"
#include "dvf9a.h"

/*************************************************************************************
 *  commands functions
 *************************************************************************************/
unsigned char cmdDaifRead (unsigned char argc, char * argv[] )
{
	unsigned int address;
	unsigned int data;
	unsigned char status = -1;

	if ( argc == 2 ) {
		address  = hex2int(argv[1]);
		data     = daif_read(address);
		printf("Write Address : 0x%x, Value=0x%x\n", address, data );
		status = 0;
	} else {
		printf( "usage : %s [daif address in hex] - read from daif address\n", argv[0]);
	}

	return status;
}


unsigned char cmdDaifWrite (unsigned char argc, char * argv[] )
{
	unsigned int address;
	unsigned int data;
	unsigned char status = -1;

	if ( argc == 3 ) {
		address  = hex2int(argv[1]);
		data     = hex2int(argv[2]);
		daif_write(address,data);
		printf("Write Address : 0x%x, Value=0x%x\n", address, data );
		status = 0;
	} else {
		printf( "usage : %s [daif address in hex] [data in hex]- write unsigned int to daif address\n", argv[0]);
	}

	return status;
}


