/*
 * (C) Copyright 2013
 * DSPG Technologies GmbH
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

struct cryptohw_desc {
	uint32_t desc_ctl;		/* Descriptor control */
	uint32_t link_ptr;		/* 32-bit pointer to next descriptor */
	uint32_t data_in_phys;		/* 32-bit pointer to input data */
	uint32_t data_out_phys;		/* 32-bit pointer to output data */
	uint32_t data_in_len;		/* 31-bit length of input data */
	uint32_t data_out_len; 		/* 31-bit length of output data */
	uint32_t iv[8];			/* Initialization vector */
	uint32_t state_index;
	uint32_t data_in_total_len;	/* Full packet data length if last descriptor */
					/* of multiple-descriptor packet of HASH/HMAC */
};

#define DVF99_CRYPTO_BASE	0x06c00000	/* crypto accelerators */
#define DESC_CTL_DESC_OWNER_HW 	0x80000000
#define DESC_CTL_MODE_SHA2_256 	0x22
#define REG_CHANNEL_HEADPTR 	0x0200
#define REG_HEADPTR_SET 	0x0284

int cryptohw_sha256(const unsigned char *message, unsigned int len,
		unsigned char *digest);


/* memset and memcmp functions below (taken from string.c)   */
/* TODO: move to a separate place if someone else needs them */

int cryptohw_memcmp(const void * cs,const void * ct,size_t count);
void * cryptohw_memset(void * s,int c,size_t count);


