#ifndef __HARDWARE_H
#define __HARDWARE_H

/* memory map */
#define DVF99_SDC_BASE		0x00100000
#define DVF99_MPMC_BASE		0x01000000
#define DVF99_ROM_BASE		0x01200000
#define DVF99_GPIO_BASE		0x05000000
#define DVF99_SCON_BASE		0x05200000
#define DVF99_CMU_BASE		0x05300000
#define DVF99_UART1_BASE	0x05a00000
#define DVF99_UART2_BASE	0x05b00000
#define DVF99_DAIF_BASE		0x06300000

/* gpio definitions */
#define DVF99_GPIO_BANKOFF	0x60

#define DVF99_AGPIO_BASE	(DVF99_GPIO_BASE + DVF99_GPIO_BANKOFF * 0)
#define DVF99_BGPIO_BASE	(DVF99_GPIO_BASE + DVF99_GPIO_BANKOFF * 1)
#define DVF99_CGPIO_BASE	(DVF99_GPIO_BASE + DVF99_GPIO_BANKOFF * 2)
#define DVF99_DGPIO_BASE	(DWM96_GPIO_BASE + DVF99_GPIO_BANKOFF * 3)
#define DVF99_EGPIO_BASE	(DVF99_GPIO_BASE + DVF99_GPIO_BANKOFF * 4)

#define DVF99_GPIO_DATA		0x00
#define DVF99_GPIO_DATA_SET	0x04
#define DVF99_GPIO_DATA_CLR	0x08
#define DVF99_GPIO_DIR		0x0c
#define DVF99_GPIO_DIR_OUT	0x10
#define DVF99_GPIO_DIR_IN	0x14
#define DVF99_GPIO_EN		0x18
#define DVF99_GPIO_EN_SET	0x1c
#define DVF99_GPIO_EN_CLR	0x20
#define DVF99_GPIO_PULL_CTRL	0x24
#define DVF99_GPIO_PULL_EN	0x28
#define DVF99_GPIO_PULL_DIS	0x2c
#define DVF99_GPIO_PULL_TYPE	0x30
#define DVF99_GPIO_PULL_UP	0x34
#define DVF99_GPIO_PULL_DN	0x38
#define DVF99_GPIO_KEEP		0x3c
#define DVF99_GPIO_KEEP_EN	0x40
#define DVF99_GPIO_KEEP_DIS	0x44
#define DVF99_GPIO_OD		0x48
#define DVF99_GPIO_OD_SET	0x4c
#define DVF99_GPIO_OD_CLR	0x50
#define DVF99_GPIO_IN		0x54

/* system configuration definitions */
#define DVF99_SCON_GCR0		0x00
#define DVF99_SCON_GCR1		0x04
#define DVF99_SCON_GCR2		0x08
#define DVF99_SCON_CORTEX_IR	0x0c
#define DVF99_SCON_CHIP_ID	0x1c
#define DVF99_SCON_CHIP_REV	0x20
#define DVF99_SCON_TEST_CTRL_EN	0x40
#define DVF99_SCON_TEST_CTRL1	0x44
#define DVF99_SCON_SPCR1	0x54
#define DVF99_SCON_SPCR2	0x58
#define DVF99_SCON_USBOTG1_GCR1	0x5c
#define DVF99_SCON_USB11_GCR	0x60
#define DVF99_SCON_DRAMCTL_GCR1	0x6c
#define DVF99_SCON_DRAMCTL_GCR2	0x70
#define DVF99_SCON_MEMCFG	0x74
#define DVF99_SCON_DRAMCTL_CFG0	0x130

/* clock management unit definitions */
#define CMU_PLL1		0x00
#define CMU_PLL2		0x04
#define CMU_PLL3		0x08
#define CMU_CPUCLKCTL		0x14
#define CMU_COMCLKSEL		0x18
#define CMU_CLKSWCTL		0x1c
#define CMU_CLKDIV1		0x20
#define CMU_CLKDIV2		0x24
#define CMU_CLKDIV3		0x28
#define CMU_CLKDIV4		0x2c
#define CMU_CLKDIV5		0x30
#define CMU_CLKOSC		0x3c
#define CMU_SWSYSRST		0x40
#define CMU_SWWRMRST		0x44
#define CMU_RSTSR		0x48
#define CMU_SWRST1		0x50
#define CMU_SWRST2		0x54
#define CMU_SWCLKEN1		0x58
#define CMU_SWCLKEN2		0x5c
#define CMU_CUSTATR		0x60
#define CMU_TEST		0x68

#endif /* __HARDWARE_H */
