/*
 * (C) Copyright 2013
 * DSPG Technologies GmbH
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __IO_H__
#define __IO_H__

/*!
*****************************************************************************

 \fn int printf(const char* format, ...);

 <b>Description:</b>\n
 Print a string to the terminal

 \param[in] format	The format string to use

 \return :: length of the print string

******************************************************************************/
int printf(const char* format, ...);

/*!
*****************************************************************************

 \fn int read(char* input);

 <b>Description:</b>\n
 read string input from the terminal
 - support arrow up to retrieve previous buffer
 - back space

 \param[in] input	input buffer to hold the string

 \return :: length of the input string

******************************************************************************/
int read(char* input);

#endif /* __IO_H__ */

