#!/bin/bash
filelist=`ls ddrconf/*.h`

[ -f configs.c ] && rm configs.c
printf "#include \"configs.h\"\n\n" >> configs.c

for file in $filelist
do
	if [ ! x"`grep 'static uint32_t denali_setup' $file`" = x -a  ! x"`grep 'uint32_t ddrconf_speed' $file`" = x ]
	then
		base=`basename $file .h`
		denali=$base"_denali_setup"
		ddrspeedfunc=$base"_ddrconf_speed"
		sed -e "s/ddrconf_speed/$ddrspeedfunc/" -e "s/denali_setup/$denali/" $file | grep -v '#include' >> configs.c
	fi
done

printf "\n\nMemoryConfig memoryConfigs[] = {\n" >> configs.c
for file in $filelist
do
	if [ ! x"`grep 'static uint32_t denali_setup' $file`" = x -a  ! x"`grep 'uint32_t ddrconf_speed' $file`" = x ]
	then
		base=`basename $file .h`
		denali=$base"_denali_setup"
		ddrspeedfunc=$base"_ddrconf_speed"
		listfile="config_"$file
		printf "\t{ \"%s\", %s, %s },\n" $base $ddrspeedfunc $denali >> configs.c
	fi
done
printf "};\n" >> configs.c

printf "\nconst int memoryConfigsCount = sizeof(memoryConfigs)/sizeof(MemoryConfig);" >> configs.c

