uint32_t ddrconf_speed(void) { return 375000000; }

/*
 * CAS latency = 3, RAS latency = 3
 */
static uint32_t mpmc_ras_cas_setup = 0x303;

/*
 * SDR-SDRAM RBC, 16bit, 256Mb (16Mx16)
 * 4 banks, row length = 13, column length = 9
 */
static uint32_t mpmc_config_setup = 0x680;

/*
 * SDRAM Addr[8:0] = 0x31
 * RBC 8Mx16: SDRAM Addr[8:0] translates to HADDR [20:12]
 */
static uint32_t mpmc_mode_setup = 0x31UL << 12;

static uint32_t mpmc_timing_setup[10] = {
	0xf, /* MPMCDynamictRP: precharge command period */
	0xf, /* MPMCDynamictRAS: active to precharge command period */
	0xf, /* MPMCDynamictSREX: self-refresh exit time */
	0xf, /* MPMCDynamictWR: write recovery time */
	0xf, /* MPMCDynamictRC: active to active command period */
	0xf, /* MPMCDynamictRFC: auto-refresh period and auto-refresh to active command period */
	0xf, /* MPMCDynamictXSR: exit self-refresh to active command time */
	0xf, /* MPMCDynamictRRD: active bank A to active bank B latency */
	0xf, /* MPMCDynamictMRD: load mode register to active command time */
	0xf, /* MPMCDynamictCDLR: last data in to read command time */
};

