uint32_t ddrconf_speed(void) { return 375000000; }

/*
 * CAS latency = 2, RAS latency = 2
 */
static uint32_t mpmc_ras_cas_setup = 0x202;

/*
 * SDR-SDRAM RBC, 16bit, 512Mb (32Mx16)
 * 4 banks, row length = 13, column length = 10
 */
static uint32_t mpmc_config_setup = 0x880;

/*
 * SDRAM Addr[9:0] = 0x21
 * RBC 32Mx16: SDRAM Addr[9:0] translates to HADDR [22:13]
 */
static uint32_t mpmc_mode_setup = 0x21UL << 13;

static uint32_t mpmc_timing_setup[10] = {
	0xf, /* MPMCDynamictRP: precharge command period */
	0xf, /* MPMCDynamictRAS: active to precharge command period */
	0xf, /* MPMCDynamictSREX: self-refresh exit time */
	0xf, /* MPMCDynamictWR: write recovery time */
	0xf, /* MPMCDynamictRC: active to active command period */
	0xf, /* MPMCDynamictRFC: auto-refresh period and auto-refresh to active command period */
	0xf, /* MPMCDynamictXSR: exit self-refresh to active command time */
	0xf, /* MPMCDynamictRRD: active bank A to active bank B latency */
	0xf, /* MPMCDynamictMRD: load mode register to active command time */
	0xf, /* MPMCDynamictCDLR: last data in to read command time */
};

