/*
 * (C) Copyright 2013
 * DSPG Technologies GmbH
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __VSNPRINTF_H__
#define __VSNPRINTF_H__

/*!
*****************************************************************************

 \fn int vsnprintf(char *buf, int size, const char *fmt, va_list args);

 <b>Description:</b>\n
 Format a string and place it in a buffer
 This emulation does not implement the conversions : %e, %E, %g, %G, %wc, %ws, %f

 \param[in] buf		The buffer to place the result into
 \param[in] size	The size of the buffer, including the trailing null space
 \param[in] fmt		The format string to use

 \return :: integer value of length of string

******************************************************************************/
int vsnprintf(char *buf, int size, const char *fmt, va_list args);

#endif /* __VSNPRINTF_H__ */
