/*
 * (C) Copyright 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <asm/io.h>
#include <asm/arch/clock.h>
#include <asm/arch/hardware.h>

DECLARE_GLOBAL_DATA_PTR;

/* denali parameter fields */
#define param_address_mirroring_addr         13
#define param_address_mirroring_offset       24
#define param_address_mirroring_width        2
#define param_addr_cmp_en_addr               37
#define param_addr_cmp_en_offset             0
#define param_addr_cmp_en_width              1
#define param_add_odt_clk_difftype_diffcs_addr 51
#define param_add_odt_clk_difftype_diffcs_offset 0
#define param_add_odt_clk_difftype_diffcs_width 6
#define param_add_odt_clk_r2w_samecs_addr    50
#define param_add_odt_clk_r2w_samecs_offset  16
#define param_add_odt_clk_r2w_samecs_width   4
#define param_add_odt_clk_sametype_diffcs_addr 51
#define param_add_odt_clk_sametype_diffcs_offset 8
#define param_add_odt_clk_sametype_diffcs_width 4
#define param_add_odt_clk_w2r_samecs_addr    50
#define param_add_odt_clk_w2r_samecs_offset  24
#define param_add_odt_clk_w2r_samecs_width   4
#define param_age_count_addr                 36
#define param_age_count_offset               16
#define param_age_count_width                8
#define param_ahb1_rdlen_addr                68
#define param_ahb1_rdlen_offset              24
#define param_ahb1_rdlen_width               4
#define param_ahb1_wrlen_addr                68
#define param_ahb1_wrlen_offset              16
#define param_ahb1_wrlen_width               4
#define param_ahb2_rdlen_addr                69
#define param_ahb2_rdlen_offset              8
#define param_ahb2_rdlen_width               4
#define param_ahb2_wrlen_addr                69
#define param_ahb2_wrlen_offset              0
#define param_ahb2_wrlen_width               4
#define param_ahb3_rdlen_addr                69
#define param_ahb3_rdlen_offset              24
#define param_ahb3_rdlen_width               4
#define param_ahb3_wrlen_addr                69
#define param_ahb3_wrlen_offset              16
#define param_ahb3_wrlen_width               4
#define param_ahb4_rdlen_addr                70
#define param_ahb4_rdlen_offset              8
#define param_ahb4_rdlen_width               4
#define param_ahb4_wrlen_addr                70
#define param_ahb4_wrlen_offset              0
#define param_ahb4_wrlen_width               4
#define param_ahb5_rdlen_addr                70
#define param_ahb5_rdlen_offset              24
#define param_ahb5_rdlen_width               4
#define param_ahb5_wrlen_addr                70
#define param_ahb5_wrlen_offset              16
#define param_ahb5_wrlen_width               4
#define param_ahb6_rdlen_addr                71
#define param_ahb6_rdlen_offset              8
#define param_ahb6_rdlen_width               4
#define param_ahb6_wrlen_addr                71
#define param_ahb6_wrlen_offset              0
#define param_ahb6_wrlen_width               4
#define param_ap_addr                        12
#define param_ap_offset                      0
#define param_ap_width                       1
#define param_aprebit_addr                   36
#define param_aprebit_offset                 8
#define param_aprebit_width                  4
#define param_arb_cmd_q_threshold_addr       77
#define param_arb_cmd_q_threshold_offset     0
#define param_arb_cmd_q_threshold_width      3
#define param_arefresh_addr                  14
#define param_arefresh_offset                0
#define param_arefresh_width                 1
#define param_auto_refresh_mode_addr         14
#define param_auto_refresh_mode_offset       8
#define param_auto_refresh_mode_width        1
#define param_axi0_bdw_addr                  77
#define param_axi0_bdw_offset                8
#define param_axi0_bdw_width                 7
#define param_axi0_bdw_ovflow_addr           77
#define param_axi0_bdw_ovflow_offset         16
#define param_axi0_bdw_ovflow_width          1
#define param_axi0_current_bdw_addr          77
#define param_axi0_current_bdw_offset        24
#define param_axi0_current_bdw_width         7
#define param_axi0_fifo_type_reg_addr        72
#define param_axi0_fifo_type_reg_offset      0
#define param_axi0_fifo_type_reg_width       2
#define param_axi0_r_priority_addr           71
#define param_axi0_r_priority_offset         16
#define param_axi0_r_priority_width          3
#define param_axi0_w_priority_addr           71
#define param_axi0_w_priority_offset         24
#define param_axi0_w_priority_width          3
#define param_axi1_bdw_addr                  78
#define param_axi1_bdw_offset                0
#define param_axi1_bdw_width                 7
#define param_axi1_bdw_ovflow_addr           78
#define param_axi1_bdw_ovflow_offset         8
#define param_axi1_bdw_ovflow_width          1
#define param_axi1_current_bdw_addr          78
#define param_axi1_current_bdw_offset        16
#define param_axi1_current_bdw_width         7
#define param_axi1_fifo_type_reg_addr        72
#define param_axi1_fifo_type_reg_offset      24
#define param_axi1_fifo_type_reg_width       2
#define param_axi1_r_priority_addr           72
#define param_axi1_r_priority_offset         8
#define param_axi1_r_priority_width          3
#define param_axi1_w_priority_addr           72
#define param_axi1_w_priority_offset         16
#define param_axi1_w_priority_width          3
#define param_axi2_bdw_addr                  78
#define param_axi2_bdw_offset                24
#define param_axi2_bdw_width                 7
#define param_axi2_bdw_ovflow_addr           79
#define param_axi2_bdw_ovflow_offset         0
#define param_axi2_bdw_ovflow_width          1
#define param_axi2_current_bdw_addr          79
#define param_axi2_current_bdw_offset        8
#define param_axi2_current_bdw_width         7
#define param_axi2_fifo_type_reg_addr        73
#define param_axi2_fifo_type_reg_offset      16
#define param_axi2_fifo_type_reg_width       2
#define param_axi2_r_priority_addr           73
#define param_axi2_r_priority_offset         0
#define param_axi2_r_priority_width          3
#define param_axi2_w_priority_addr           73
#define param_axi2_w_priority_offset         8
#define param_axi2_w_priority_width          3
#define param_axi3_bdw_addr                  79
#define param_axi3_bdw_offset                16
#define param_axi3_bdw_width                 7
#define param_axi3_bdw_ovflow_addr           79
#define param_axi3_bdw_ovflow_offset         24
#define param_axi3_bdw_ovflow_width          1
#define param_axi3_current_bdw_addr          80
#define param_axi3_current_bdw_offset        0
#define param_axi3_current_bdw_width         7
#define param_axi3_fifo_type_reg_addr        74
#define param_axi3_fifo_type_reg_offset      8
#define param_axi3_fifo_type_reg_width       2
#define param_axi3_r_priority_addr           73
#define param_axi3_r_priority_offset         24
#define param_axi3_r_priority_width          3
#define param_axi3_w_priority_addr           74
#define param_axi3_w_priority_offset         0
#define param_axi3_w_priority_width          3
#define param_axi4_bdw_addr                  80
#define param_axi4_bdw_offset                8
#define param_axi4_bdw_width                 7
#define param_axi4_bdw_ovflow_addr           80
#define param_axi4_bdw_ovflow_offset         16
#define param_axi4_bdw_ovflow_width          1
#define param_axi4_current_bdw_addr          80
#define param_axi4_current_bdw_offset        24
#define param_axi4_current_bdw_width         7
#define param_axi4_fifo_type_reg_addr        75
#define param_axi4_fifo_type_reg_offset      0
#define param_axi4_fifo_type_reg_width       2
#define param_axi4_r_priority_addr           74
#define param_axi4_r_priority_offset         16
#define param_axi4_r_priority_width          3
#define param_axi4_w_priority_addr           74
#define param_axi4_w_priority_offset         24
#define param_axi4_w_priority_width          3
#define param_axi5_bdw_addr                  81
#define param_axi5_bdw_offset                0
#define param_axi5_bdw_width                 7
#define param_axi5_bdw_ovflow_addr           81
#define param_axi5_bdw_ovflow_offset         8
#define param_axi5_bdw_ovflow_width          1
#define param_axi5_current_bdw_addr          81
#define param_axi5_current_bdw_offset        16
#define param_axi5_current_bdw_width         7
#define param_axi5_fifo_type_reg_addr        75
#define param_axi5_fifo_type_reg_offset      24
#define param_axi5_fifo_type_reg_width       2
#define param_axi5_r_priority_addr           75
#define param_axi5_r_priority_offset         8
#define param_axi5_r_priority_width          3
#define param_axi5_w_priority_addr           75
#define param_axi5_w_priority_offset         16
#define param_axi5_w_priority_width          3
#define param_axi6_bdw_addr                  81
#define param_axi6_bdw_offset                24
#define param_axi6_bdw_width                 7
#define param_axi6_bdw_ovflow_addr           82
#define param_axi6_bdw_ovflow_offset         0
#define param_axi6_bdw_ovflow_width          1
#define param_axi6_current_bdw_addr          82
#define param_axi6_current_bdw_offset        8
#define param_axi6_current_bdw_width         7
#define param_axi6_fifo_type_reg_addr        76
#define param_axi6_fifo_type_reg_offset      16
#define param_axi6_fifo_type_reg_width       2
#define param_axi6_r_priority_addr           76
#define param_axi6_r_priority_offset         0
#define param_axi6_r_priority_width          3
#define param_axi6_w_priority_addr           76
#define param_axi6_w_priority_offset         8
#define param_axi6_w_priority_width          3
#define param_bank_diff_addr                 35
#define param_bank_diff_offset               16
#define param_bank_diff_width                2
#define param_bank_split_en_addr             37
#define param_bank_split_en_offset           8
#define param_bank_split_en_width            1
#define param_bstlen_addr                    13
#define param_bstlen_offset                  0
#define param_bstlen_width                   3
#define param_burst_on_fly_bit_addr          40
#define param_burst_on_fly_bit_offset        16
#define param_burst_on_fly_bit_width         4
#define param_caslat_lin_addr                6
#define param_caslat_lin_offset              24
#define param_caslat_lin_width               6
#define param_cke_delay_addr                 20
#define param_cke_delay_offset               24
#define param_cke_delay_width                3
#define param_cke_inactive_addr              4
#define param_cke_inactive_offset            0
#define param_cke_inactive_width             32
#define param_cke_status_addr                82
#define param_cke_status_offset              16
#define param_cke_status_width               2
#define param_cksre_addr                     21
#define param_cksre_offset                   8
#define param_cksre_width                    4
#define param_cksrx_addr                     21
#define param_cksrx_offset                   16
#define param_cksrx_width                    4
#define param_col_diff_addr                  36
#define param_col_diff_offset                0
#define param_col_diff_width                 3
#define param_command_age_count_addr         36
#define param_command_age_count_offset       24
#define param_command_age_count_width        8
#define param_concurrentap_addr              12
#define param_concurrentap_offset            8
#define param_concurrentap_width             1
#define param_controller_busy_addr           41
#define param_controller_busy_offset         16
#define param_controller_busy_width          1
#define param_cs_map_addr                    40
#define param_cs_map_offset                  8
#define param_cs_map_width                   2
#define param_cs_same_en_addr                38
#define param_cs_same_en_offset              16
#define param_cs_same_en_width               1
#define param_ctrlupd_req_addr               41
#define param_ctrlupd_req_offset             24
#define param_ctrlupd_req_width              1
#define param_ctrlupd_req_per_aref_en_addr   42
#define param_ctrlupd_req_per_aref_en_offset 0
#define param_ctrlupd_req_per_aref_en_width  1
#define param_dfi_wrlvl_max_delay_addr       91
#define param_dfi_wrlvl_max_delay_offset     8
#define param_dfi_wrlvl_max_delay_width      16
#define param_disable_narrow_wrap_addr       76
#define param_disable_narrow_wrap_offset     24
#define param_disable_narrow_wrap_width      1
#define param_disable_rd_interleave_addr     39
#define param_disable_rd_interleave_offset   24
#define param_disable_rd_interleave_width    1
#define param_disable_rw_group_w_bnk_conflict_addr 39
#define param_disable_rw_group_w_bnk_conflict_offset 0
#define param_disable_rw_group_w_bnk_conflict_width 2
#define param_dll_rst_adj_dly_addr           83
#define param_dll_rst_adj_dly_offset         16
#define param_dll_rst_adj_dly_width          8
#define param_dll_rst_delay_addr             83
#define param_dll_rst_delay_offset           0
#define param_dll_rst_delay_width            16
#define param_dram_class_addr                0
#define param_dram_class_offset              8
#define param_dram_class_width               4
#define param_dram_clk_disable_addr          84
#define param_dram_clk_disable_offset        24
#define param_dram_clk_disable_width         2
#define param_enable_quick_srefresh_addr     20
#define param_enable_quick_srefresh_offset   16
#define param_enable_quick_srefresh_width    1
#define param_en_1t_timing_addr              128
#define param_en_1t_timing_offset            0
#define param_en_1t_timing_width             1
#define param_inhibit_dram_cmd_addr          40
#define param_inhibit_dram_cmd_offset        0
#define param_inhibit_dram_cmd_width         1
#define param_initaref_addr                  5
#define param_initaref_offset                0
#define param_initaref_width                 4
#define param_int_ack_addr                   43
#define param_int_ack_offset                 0
#define param_int_ack_width                  18
#define param_int_mask_addr                  44
#define param_int_mask_offset                0
#define param_int_mask_width                 19
#define param_int_status_addr                42
#define param_int_status_offset              8
#define param_int_status_width               19
#define param_in_order_accept_addr           41
#define param_in_order_accept_offset         8
#define param_in_order_accept_width          1
#define param_lowpower_refresh_enable_addr   21
#define param_lowpower_refresh_enable_offset 0
#define param_lowpower_refresh_enable_width  2
#define param_lp_arb_state_addr              22
#define param_lp_arb_state_offset            8
#define param_lp_arb_state_width             4
#define param_lp_auto_entry_en_addr          22
#define param_lp_auto_entry_en_offset        16
#define param_lp_auto_entry_en_width         3
#define param_lp_auto_exit_en_addr           22
#define param_lp_auto_exit_en_offset         24
#define param_lp_auto_exit_en_width          3
#define param_lp_auto_mem_gate_en_addr       23
#define param_lp_auto_mem_gate_en_offset     0
#define param_lp_auto_mem_gate_en_width      2
#define param_lp_auto_pd_idle_addr           23
#define param_lp_auto_pd_idle_offset         8
#define param_lp_auto_pd_idle_width          12
#define param_lp_auto_sr_idle_addr           23
#define param_lp_auto_sr_idle_offset         24
#define param_lp_auto_sr_idle_width          8
#define param_lp_auto_sr_mc_gate_idle_addr   24
#define param_lp_auto_sr_mc_gate_idle_offset 0
#define param_lp_auto_sr_mc_gate_idle_width  8
#define param_lp_cmd_addr                    21
#define param_lp_cmd_offset                  24
#define param_lp_cmd_width                   8
#define param_lp_state_addr                  22
#define param_lp_state_offset                0
#define param_lp_state_width                 6
#define param_lvl_status_addr                55
#define param_lvl_status_offset              8
#define param_lvl_status_width               3
#define param_max_col_reg_addr               1
#define param_max_col_reg_offset             8
#define param_max_col_reg_width              4
#define param_max_cs_reg_addr                1
#define param_max_cs_reg_offset              16
#define param_max_cs_reg_width               2
#define param_max_row_reg_addr               1
#define param_max_row_reg_offset             0
#define param_max_row_reg_width              5
#define param_mem_rst_valid_addr             82
#define param_mem_rst_valid_offset           24
#define param_mem_rst_valid_width            1
#define param_mr0_data_0_addr                26
#define param_mr0_data_0_offset              8
#define param_mr0_data_0_width               16
#define param_mr0_data_1_addr                29
#define param_mr0_data_1_offset              0
#define param_mr0_data_1_width               16
#define param_mr1_data_0_addr                27
#define param_mr1_data_0_offset              0
#define param_mr1_data_0_width               16
#define param_mr1_data_1_addr                29
#define param_mr1_data_1_offset              16
#define param_mr1_data_1_width               16
#define param_mr2_data_0_addr                27
#define param_mr2_data_0_offset              16
#define param_mr2_data_0_width               16
#define param_mr2_data_1_addr                30
#define param_mr2_data_1_offset              0
#define param_mr2_data_1_width               16
#define param_mr3_data_0_addr                28
#define param_mr3_data_0_offset              16
#define param_mr3_data_0_width               16
#define param_mr3_data_1_addr                31
#define param_mr3_data_1_offset              0
#define param_mr3_data_1_width               16
#define param_mrsingle_data_0_addr           28
#define param_mrsingle_data_0_offset         0
#define param_mrsingle_data_0_width          16
#define param_mrsingle_data_1_addr           30
#define param_mrsingle_data_1_offset         16
#define param_mrsingle_data_1_width          16
#define param_mrw_status_addr                26
#define param_mrw_status_offset              0
#define param_mrw_status_width               8
#define param_no_cmd_init_addr               6
#define param_no_cmd_init_offset             16
#define param_no_cmd_init_width              1
#define param_num_q_entries_act_disable_addr 39
#define param_num_q_entries_act_disable_offset 8
#define param_num_q_entries_act_disable_width 3
#define param_ocd_adjust_pdn_cs_0_addr       53
#define param_ocd_adjust_pdn_cs_0_offset     16
#define param_ocd_adjust_pdn_cs_0_width      5
#define param_ocd_adjust_pup_cs_0_addr       53
#define param_ocd_adjust_pup_cs_0_offset     24
#define param_ocd_adjust_pup_cs_0_width      5
#define param_odt_alt_en_addr                105
#define param_odt_alt_en_offset              0
#define param_odt_alt_en_width               1
#define param_odt_en_addr                    50
#define param_odt_en_offset                  8
#define param_odt_en_width                   1
#define param_odt_rd_map_cs0_addr            48
#define param_odt_rd_map_cs0_offset          16
#define param_odt_rd_map_cs0_width           2
#define param_odt_rd_map_cs1_addr            49
#define param_odt_rd_map_cs1_offset          0
#define param_odt_rd_map_cs1_width           2
#define param_odt_wr_map_cs0_addr            48
#define param_odt_wr_map_cs0_offset          24
#define param_odt_wr_map_cs0_width           2
#define param_odt_wr_map_cs1_addr            49
#define param_odt_wr_map_cs1_offset          8
#define param_odt_wr_map_cs1_width           2
#define param_out_of_range_addr_addr         45
#define param_out_of_range_addr_offset       0
#define param_out_of_range_addr_width        32
#define param_out_of_range_length_addr       46
#define param_out_of_range_length_offset     0
#define param_out_of_range_length_width      7
#define param_out_of_range_source_id_addr    46
#define param_out_of_range_source_id_offset  16
#define param_out_of_range_source_id_width   7
#define param_out_of_range_type_addr         46
#define param_out_of_range_type_offset       8
#define param_out_of_range_type_width        6
#define param_placement_en_addr              37
#define param_placement_en_offset            16
#define param_placement_en_width             1
#define param_port_cmd_error_addr_addr       47
#define param_port_cmd_error_addr_offset     0
#define param_port_cmd_error_addr_width      32
#define param_port_cmd_error_id_addr         48
#define param_port_cmd_error_id_offset       0
#define param_port_cmd_error_id_width        7
#define param_port_cmd_error_type_addr       48
#define param_port_cmd_error_type_offset     8
#define param_port_cmd_error_type_width      2
#define param_priority_en_addr               37
#define param_priority_en_offset             24
#define param_priority_en_width              1
#define param_pwrdn_shift_delay_addr         24
#define param_pwrdn_shift_delay_offset       8
#define param_pwrdn_shift_delay_width        6
#define param_pwrup_srefresh_exit_addr       20
#define param_pwrup_srefresh_exit_offset     0
#define param_pwrup_srefresh_exit_width      1
#define param_q_fullness_addr                41
#define param_q_fullness_offset              0
#define param_q_fullness_width               3
#define param_r2r_diffcs_dly_addr            51
#define param_r2r_diffcs_dly_offset          16
#define param_r2r_diffcs_dly_width           3
#define param_r2r_samecs_dly_addr            52
#define param_r2r_samecs_dly_offset          16
#define param_r2r_samecs_dly_width           3
#define param_r2w_diffcs_dly_addr            51
#define param_r2w_diffcs_dly_offset          24
#define param_r2w_diffcs_dly_width           3
#define param_r2w_samecs_dly_addr            52
#define param_r2w_samecs_dly_offset          24
#define param_r2w_samecs_dly_width           3
#define param_rdlat_adj_addr                 90
#define param_rdlat_adj_offset               0
#define param_rdlat_adj_width                6
#define param_rdlvl_begin_delay_0_addr       61
#define param_rdlvl_begin_delay_0_offset     8
#define param_rdlvl_begin_delay_0_width      16
#define param_rdlvl_begin_delay_1_addr       65
#define param_rdlvl_begin_delay_1_offset     0
#define param_rdlvl_begin_delay_1_width      16
#define param_rdlvl_begin_delay_en_addr      60
#define param_rdlvl_begin_delay_en_offset    16
#define param_rdlvl_begin_delay_en_width     1
#define param_rdlvl_cs_addr                  60
#define param_rdlvl_cs_offset                0
#define param_rdlvl_cs_width                 1
#define param_rdlvl_delay_0_addr             64
#define param_rdlvl_delay_0_offset           0
#define param_rdlvl_delay_0_width            16
#define param_rdlvl_delay_1_addr             67
#define param_rdlvl_delay_1_offset           8
#define param_rdlvl_delay_1_width            16
#define param_rdlvl_dq_zero_count_addr       103
#define param_rdlvl_dq_zero_count_offset     0
#define param_rdlvl_dq_zero_count_width      4
#define param_rdlvl_edge_addr                60
#define param_rdlvl_edge_offset              8
#define param_rdlvl_edge_width               1
#define param_rdlvl_en_addr                  101
#define param_rdlvl_en_offset                0
#define param_rdlvl_en_width                 1
#define param_rdlvl_end_delay_0_addr         62
#define param_rdlvl_end_delay_0_offset       0
#define param_rdlvl_end_delay_0_width        16
#define param_rdlvl_end_delay_1_addr         65
#define param_rdlvl_end_delay_1_offset       16
#define param_rdlvl_end_delay_1_width        16
#define param_rdlvl_error_status_addr        103
#define param_rdlvl_error_status_offset      16
#define param_rdlvl_error_status_width       10
#define param_rdlvl_gate_delay_0_addr        64
#define param_rdlvl_gate_delay_0_offset      16
#define param_rdlvl_gate_delay_0_width       16
#define param_rdlvl_gate_delay_1_addr        68
#define param_rdlvl_gate_delay_1_offset      0
#define param_rdlvl_gate_delay_1_width       16
#define param_rdlvl_gate_dq_zero_count_addr  103
#define param_rdlvl_gate_dq_zero_count_offset 8
#define param_rdlvl_gate_dq_zero_count_width 4
#define param_rdlvl_gate_en_addr             101
#define param_rdlvl_gate_en_offset           8
#define param_rdlvl_gate_en_width            1
#define param_rdlvl_gate_max_delay_addr      96
#define param_rdlvl_gate_max_delay_offset    16
#define param_rdlvl_gate_max_delay_width     16
#define param_rdlvl_gate_preamble_check_en_addr 101
#define param_rdlvl_gate_preamble_check_en_offset 16
#define param_rdlvl_gate_preamble_check_en_width 1
#define param_rdlvl_gate_refresh_interval_addr 104
#define param_rdlvl_gate_refresh_interval_offset 16
#define param_rdlvl_gate_refresh_interval_width 16
#define param_rdlvl_gate_reg_en_addr         61
#define param_rdlvl_gate_reg_en_offset       0
#define param_rdlvl_gate_reg_en_width        1
#define param_rdlvl_gate_req_addr            59
#define param_rdlvl_gate_req_offset          24
#define param_rdlvl_gate_req_width           1
#define param_rdlvl_gate_resp_mask_addr      100
#define param_rdlvl_gate_resp_mask_offset    16
#define param_rdlvl_gate_resp_mask_width     16
#define param_rdlvl_max_delay_addr           96
#define param_rdlvl_max_delay_offset         0
#define param_rdlvl_max_delay_width          16
#define param_rdlvl_midpoint_delay_0_addr    62
#define param_rdlvl_midpoint_delay_0_offset  16
#define param_rdlvl_midpoint_delay_0_width   16
#define param_rdlvl_midpoint_delay_1_addr    66
#define param_rdlvl_midpoint_delay_1_offset  0
#define param_rdlvl_midpoint_delay_1_width   16
#define param_rdlvl_offset_delay_0_addr      63
#define param_rdlvl_offset_delay_0_offset    0
#define param_rdlvl_offset_delay_0_width     16
#define param_rdlvl_offset_delay_1_addr      66
#define param_rdlvl_offset_delay_1_offset    16
#define param_rdlvl_offset_delay_1_width     16
#define param_rdlvl_offset_dir_0_addr        63
#define param_rdlvl_offset_dir_0_offset      16
#define param_rdlvl_offset_dir_0_width       1
#define param_rdlvl_offset_dir_1_addr        67
#define param_rdlvl_offset_dir_1_offset      0
#define param_rdlvl_offset_dir_1_width       1
#define param_rdlvl_refresh_interval_addr    104
#define param_rdlvl_refresh_interval_offset  0
#define param_rdlvl_refresh_interval_width   16
#define param_rdlvl_reg_en_addr              60
#define param_rdlvl_reg_en_offset            24
#define param_rdlvl_reg_en_width             1
#define param_rdlvl_req_addr                 59
#define param_rdlvl_req_offset               16
#define param_rdlvl_req_width                1
#define param_rdlvl_resp_mask_addr           100
#define param_rdlvl_resp_mask_offset         0
#define param_rdlvl_resp_mask_width          16
#define param_reduc_addr                     40
#define param_reduc_offset                   24
#define param_reduc_width                    1
#define param_refresh_per_zq_addr            34
#define param_refresh_per_zq_offset          0
#define param_refresh_per_zq_width           32
#define param_reg_dimm_enable_addr           13
#define param_reg_dimm_enable_offset         16
#define param_reg_dimm_enable_width          1
#define param_row_diff_addr                  35
#define param_row_diff_offset                24
#define param_row_diff_width                 3
#define param_rw_same_en_addr                38
#define param_rw_same_en_offset              0
#define param_rw_same_en_width               1
#define param_rw_same_page_en_addr           38
#define param_rw_same_page_en_offset         8
#define param_rw_same_page_en_width          1
#define param_srefresh_exit_no_refresh_addr  20
#define param_srefresh_exit_no_refresh_offset 8
#define param_srefresh_exit_no_refresh_width 1
#define param_start_addr                     0
#define param_start_offset                   0
#define param_start_width                    1
#define param_swap_en_addr                   39
#define param_swap_en_offset                 16
#define param_swap_en_width                  1
#define param_swlvl_exit_addr                54
#define param_swlvl_exit_offset              24
#define param_swlvl_exit_width               1
#define param_swlvl_load_addr                54
#define param_swlvl_load_offset              8
#define param_swlvl_load_width               1
#define param_swlvl_op_done_addr             55
#define param_swlvl_op_done_offset           0
#define param_swlvl_op_done_width            1
#define param_swlvl_resp_0_addr              55
#define param_swlvl_resp_0_offset            16
#define param_swlvl_resp_0_width             8
#define param_swlvl_resp_1_addr              55
#define param_swlvl_resp_1_offset            24
#define param_swlvl_resp_1_width             8
#define param_swlvl_start_addr               54
#define param_swlvl_start_offset             16
#define param_swlvl_start_width              1
#define param_sw_leveling_mode_addr          54
#define param_sw_leveling_mode_offset        0
#define param_sw_leveling_mode_width         2
#define param_tbst_int_interval_addr         7
#define param_tbst_int_interval_offset       8
#define param_tbst_int_interval_width        3
#define param_tccd_addr                      7
#define param_tccd_offset                    16
#define param_tccd_width                     5
#define param_tcke_addr                      10
#define param_tcke_offset                    24
#define param_tcke_width                     3
#define param_tckesr_addr                    11
#define param_tckesr_offset                  0
#define param_tckesr_width                   5
#define param_tcpd_addr                      5
#define param_tcpd_offset                    8
#define param_tcpd_width                     16
#define param_tdal_addr                      12
#define param_tdal_offset                    24
#define param_tdal_width                     6
#define param_tdfi_ctrlupd_interval_addr     89
#define param_tdfi_ctrlupd_interval_offset   0
#define param_tdfi_ctrlupd_interval_width    32
#define param_tdfi_ctrlupd_max_addr          85
#define param_tdfi_ctrlupd_max_offset        8
#define param_tdfi_ctrlupd_max_width         14
#define param_tdfi_ctrlupd_min_addr          85
#define param_tdfi_ctrlupd_min_offset        0
#define param_tdfi_ctrlupd_min_width         4
#define param_tdfi_ctrl_delay_addr           90
#define param_tdfi_ctrl_delay_offset         16
#define param_tdfi_ctrl_delay_width          4
#define param_tdfi_dram_clk_disable_addr     90
#define param_tdfi_dram_clk_disable_offset   24
#define param_tdfi_dram_clk_disable_width    4
#define param_tdfi_dram_clk_enable_addr      91
#define param_tdfi_dram_clk_enable_offset    0
#define param_tdfi_dram_clk_enable_width     4
#define param_tdfi_phyupd_resp_addr          88
#define param_tdfi_phyupd_resp_offset        0
#define param_tdfi_phyupd_resp_width         14
#define param_tdfi_phyupd_type0_addr         86
#define param_tdfi_phyupd_type0_offset       0
#define param_tdfi_phyupd_type0_width        16
#define param_tdfi_phyupd_type1_addr         86
#define param_tdfi_phyupd_type1_offset       16
#define param_tdfi_phyupd_type1_width        16
#define param_tdfi_phyupd_type2_addr         87
#define param_tdfi_phyupd_type2_offset       0
#define param_tdfi_phyupd_type2_width        16
#define param_tdfi_phyupd_type3_addr         87
#define param_tdfi_phyupd_type3_offset       16
#define param_tdfi_phyupd_type3_width        16
#define param_tdfi_phy_rdlat_addr            84
#define param_tdfi_phy_rdlat_offset          8
#define param_tdfi_phy_rdlat_width           6
#define param_tdfi_phy_wrlat_addr            83
#define param_tdfi_phy_wrlat_offset          24
#define param_tdfi_phy_wrlat_width           5
#define param_tdfi_rddata_en_addr            84
#define param_tdfi_rddata_en_offset          16
#define param_tdfi_rddata_en_width           6
#define param_tdfi_rdlvl_dll_addr            97
#define param_tdfi_rdlvl_dll_offset          8
#define param_tdfi_rdlvl_dll_width           8
#define param_tdfi_rdlvl_en_addr             97
#define param_tdfi_rdlvl_en_offset           0
#define param_tdfi_rdlvl_en_width            8
#define param_tdfi_rdlvl_load_addr           97
#define param_tdfi_rdlvl_load_offset         16
#define param_tdfi_rdlvl_load_width          8
#define param_tdfi_rdlvl_max_addr            102
#define param_tdfi_rdlvl_max_offset          0
#define param_tdfi_rdlvl_max_width           32
#define param_tdfi_rdlvl_resp_addr           99
#define param_tdfi_rdlvl_resp_offset         0
#define param_tdfi_rdlvl_resp_width          32
#define param_tdfi_rdlvl_resplat_addr        97
#define param_tdfi_rdlvl_resplat_offset      24
#define param_tdfi_rdlvl_resplat_width       8
#define param_tdfi_rdlvl_rr_addr             98
#define param_tdfi_rdlvl_rr_offset           0
#define param_tdfi_rdlvl_rr_width            10
#define param_tdfi_wrlvl_dll_addr            92
#define param_tdfi_wrlvl_dll_offset          0
#define param_tdfi_wrlvl_dll_width           8
#define param_tdfi_wrlvl_en_addr             91
#define param_tdfi_wrlvl_en_offset           24
#define param_tdfi_wrlvl_en_width            8
#define param_tdfi_wrlvl_load_addr           92
#define param_tdfi_wrlvl_load_offset         8
#define param_tdfi_wrlvl_load_width          8
#define param_tdfi_wrlvl_max_addr            95
#define param_tdfi_wrlvl_max_offset          0
#define param_tdfi_wrlvl_max_width           32
#define param_tdfi_wrlvl_resp_addr           94
#define param_tdfi_wrlvl_resp_offset         0
#define param_tdfi_wrlvl_resp_width          32
#define param_tdfi_wrlvl_resplat_addr        92
#define param_tdfi_wrlvl_resplat_offset      16
#define param_tdfi_wrlvl_resplat_width       8
#define param_tdfi_wrlvl_ww_addr             93
#define param_tdfi_wrlvl_ww_offset           0
#define param_tdfi_wrlvl_ww_width            10
#define param_tdll_addr                      6
#define param_tdll_offset                    0
#define param_tdll_width                     16
#define param_tfaw_addr                      9
#define param_tfaw_offset                    0
#define param_tfaw_width                     6
#define param_tinit_addr                     2
#define param_tinit_offset                   0
#define param_tinit_width                    24
#define param_tmod_addr                      9
#define param_tmod_offset                    24
#define param_tmod_width                     8
#define param_tmrd_addr                      9
#define param_tmrd_offset                    16
#define param_tmrd_width                     5
#define param_todth_rd_addr                  50
#define param_todth_rd_offset                0
#define param_todth_rd_width                 4
#define param_todth_wr_addr                  49
#define param_todth_wr_offset                24
#define param_todth_wr_width                 4
#define param_todtl_2cmd_addr                49
#define param_todtl_2cmd_offset              16
#define param_todtl_2cmd_width               5
#define param_tpdex_addr                     17
#define param_tpdex_offset                   0
#define param_tpdex_width                    16
#define param_tras_lockout_addr              12
#define param_tras_lockout_offset            16
#define param_tras_lockout_width             1
#define param_tras_max_addr                  10
#define param_tras_max_offset                0
#define param_tras_max_width                 17
#define param_tras_min_addr                  8
#define param_tras_min_offset                8
#define param_tras_min_width                 8
#define param_trc_addr                       8
#define param_trc_offset                     0
#define param_trc_width                      8
#define param_trcd_int_addr                  11
#define param_trcd_int_offset                16
#define param_trcd_int_width                 8
#define param_tref_addr                      15
#define param_tref_offset                    16
#define param_tref_width                     14
#define param_tref_enable_addr               14
#define param_tref_enable_offset             16
#define param_tref_enable_width              1
#define param_tref_interval_addr             16
#define param_tref_interval_offset           0
#define param_tref_interval_width            14
#define param_trfc_addr                      15
#define param_trfc_offset                    0
#define param_trfc_width                     10
#define param_trp_addr                       8
#define param_trp_offset                     24
#define param_trp_width                      5
#define param_trp_ab_addr                    13
#define param_trp_ab_offset                  8
#define param_trp_ab_width                   5
#define param_trrd_addr                      7
#define param_trrd_offset                    24
#define param_trrd_width                     8
#define param_trst_pwron_addr                3
#define param_trst_pwron_offset              0
#define param_trst_pwron_width               32
#define param_trtp_addr                      9
#define param_trtp_offset                    8
#define param_trtp_width                     4
#define param_twr_addr                       11
#define param_twr_offset                     24
#define param_twr_width                      6
#define param_twtr_addr                      8
#define param_twtr_offset                    16
#define param_twtr_width                     4
#define param_txard_addr                     18
#define param_txard_offset                   0
#define param_txard_width                    16
#define param_txards_addr                    18
#define param_txards_offset                  16
#define param_txards_width                   16
#define param_txpdll_addr                    17
#define param_txpdll_offset                  16
#define param_txpdll_width                   16
#define param_txsnr_addr                     19
#define param_txsnr_offset                   16
#define param_txsnr_width                    16
#define param_txsr_addr                      19
#define param_txsr_offset                    0
#define param_txsr_width                     16
#define param_update_error_status_addr       84
#define param_update_error_status_offset     0
#define param_update_error_status_width      7
#define param_user_def_reg_0_addr            106
#define param_user_def_reg_0_offset          0
#define param_user_def_reg_0_width           32
#define param_user_def_reg_1_addr            107
#define param_user_def_reg_1_offset          0
#define param_user_def_reg_1_width           32
#define param_user_def_reg_10_addr           116
#define param_user_def_reg_10_offset         0
#define param_user_def_reg_10_width          32
#define param_user_def_reg_11_addr           117
#define param_user_def_reg_11_offset         0
#define param_user_def_reg_11_width          32
#define param_user_def_reg_2_addr            108
#define param_user_def_reg_2_offset          0
#define param_user_def_reg_2_width           32
#define param_user_def_reg_3_addr            109
#define param_user_def_reg_3_offset          0
#define param_user_def_reg_3_width           32
#define param_user_def_reg_4_addr            110
#define param_user_def_reg_4_offset          0
#define param_user_def_reg_4_width           32
#define param_user_def_reg_5_addr            111
#define param_user_def_reg_5_offset          0
#define param_user_def_reg_5_width           32
#define param_user_def_reg_6_addr            112
#define param_user_def_reg_6_offset          0
#define param_user_def_reg_6_width           32
#define param_user_def_reg_7_addr            113
#define param_user_def_reg_7_offset          0
#define param_user_def_reg_7_width           32
#define param_user_def_reg_8_addr            114
#define param_user_def_reg_8_offset          0
#define param_user_def_reg_8_width           32
#define param_user_def_reg_9_addr            115
#define param_user_def_reg_9_offset          0
#define param_user_def_reg_9_width           32
#define param_user_def_reg_ro_0_addr         118
#define param_user_def_reg_ro_0_offset       0
#define param_user_def_reg_ro_0_width        32
#define param_user_def_reg_ro_1_addr         119
#define param_user_def_reg_ro_1_offset       0
#define param_user_def_reg_ro_1_width        32
#define param_user_def_reg_ro_2_addr         120
#define param_user_def_reg_ro_2_offset       0
#define param_user_def_reg_ro_2_width        32
#define param_user_def_reg_ro_3_addr         121
#define param_user_def_reg_ro_3_offset       0
#define param_user_def_reg_ro_3_width        32
#define param_user_def_reg_ro_4_addr         122
#define param_user_def_reg_ro_4_offset       0
#define param_user_def_reg_ro_4_width        32
#define param_user_def_reg_ro_5_addr         123
#define param_user_def_reg_ro_5_offset       0
#define param_user_def_reg_ro_5_width        32
#define param_user_def_reg_ro_6_addr         124
#define param_user_def_reg_ro_6_offset       0
#define param_user_def_reg_ro_6_width        32
#define param_user_def_reg_ro_7_addr         125
#define param_user_def_reg_ro_7_offset       0
#define param_user_def_reg_ro_7_width        32
#define param_user_def_reg_ro_8_addr         126
#define param_user_def_reg_ro_8_offset       0
#define param_user_def_reg_ro_8_width        32
#define param_user_def_reg_ro_9_addr         127
#define param_user_def_reg_ro_9_offset       0
#define param_user_def_reg_ro_9_width        32
#define param_version_addr                   0
#define param_version_offset                 16
#define param_version_width                  16
#define param_w2r_diffcs_dly_addr            52
#define param_w2r_diffcs_dly_offset          0
#define param_w2r_diffcs_dly_width           3
#define param_w2r_samecs_dly_addr            53
#define param_w2r_samecs_dly_offset          0
#define param_w2r_samecs_dly_width           3
#define param_w2r_split_en_addr              38
#define param_w2r_split_en_offset            24
#define param_w2r_split_en_width             1
#define param_w2w_diffcs_dly_addr            52
#define param_w2w_diffcs_dly_offset          8
#define param_w2w_diffcs_dly_width           3
#define param_w2w_samecs_dly_addr            53
#define param_w2w_samecs_dly_offset          8
#define param_w2w_samecs_dly_width           3
#define param_wldqsen_addr                   56
#define param_wldqsen_offset                 16
#define param_wldqsen_width                  6
#define param_wlmrd_addr                     56
#define param_wlmrd_offset                   24
#define param_wlmrd_width                    6
#define param_writeinterp_addr               11
#define param_writeinterp_offset             8
#define param_writeinterp_width              1
#define param_write_modereg_addr             25
#define param_write_modereg_offset           0
#define param_write_modereg_width            26
#define param_wrlat_addr                     7
#define param_wrlat_offset                   0
#define param_wrlat_width                    5
#define param_wrlat_adj_addr                 90
#define param_wrlat_adj_offset               8
#define param_wrlat_adj_width                5
#define param_wrlvl_cs_addr                  56
#define param_wrlvl_cs_offset                8
#define param_wrlvl_cs_width                 1
#define param_wrlvl_delay_0_addr             58
#define param_wrlvl_delay_0_offset           8
#define param_wrlvl_delay_0_width            16
#define param_wrlvl_delay_1_addr             59
#define param_wrlvl_delay_1_offset           0
#define param_wrlvl_delay_1_width            16
#define param_wrlvl_en_addr                  57
#define param_wrlvl_en_offset                0
#define param_wrlvl_en_width                 1
#define param_wrlvl_error_status_addr        57
#define param_wrlvl_error_status_offset      24
#define param_wrlvl_error_status_width       6
#define param_wrlvl_refresh_interval_addr    57
#define param_wrlvl_refresh_interval_offset  8
#define param_wrlvl_refresh_interval_width   16
#define param_wrlvl_reg_en_addr              58
#define param_wrlvl_reg_en_offset            0
#define param_wrlvl_reg_en_width             1
#define param_wrlvl_req_addr                 56
#define param_wrlvl_req_offset               0
#define param_wrlvl_req_width                1
#define param_zqcl_addr                      32
#define param_zqcl_offset                    0
#define param_zqcl_width                     12
#define param_zqcs_addr                      32
#define param_zqcs_offset                    16
#define param_zqcs_width                     12
#define param_zqcs_rotate_addr               35
#define param_zqcs_rotate_offset             8
#define param_zqcs_rotate_width              1
#define param_zqinit_addr                    31
#define param_zqinit_offset                  16
#define param_zqinit_width                   12
#define param_zq_in_progress_addr            35
#define param_zq_in_progress_offset          0
#define param_zq_in_progress_width           1
#define param_zq_on_sref_exit_addr           33
#define param_zq_on_sref_exit_offset         8
#define param_zq_on_sref_exit_width          2
#define param_zq_req_addr                    33
#define param_zq_req_offset                  0
#define param_zq_req_width                   2

/* denali parameter access */
#define denali_set(_name, _val)                               \
({                                                            \
	uint32_t msk = (1 << param_##_name##_width) - 1;      \
	uint32_t reg;                                         \
                                                              \
	reg = denali_readl(param_##_name##_addr);             \
	reg &= ~(msk << param_##_name##_offset);              \
	reg |= (_val) << param_##_name##_offset;              \
	denali_writel(reg, param_##_name##_addr);             \
})

#define denali_get(_name)                                     \
({                                                            \
	uint32_t msk = (1 << param_##_name##_width) - 1;      \
	uint32_t reg;                                         \
                                                              \
	reg = denali_readl(param_##_name##_addr);             \
	reg >>= param_##_name##_offset;                       \
	reg & msk;                                            \
})

static inline uint32_t denali_readl(int regno)
{
	return readl(DVF99_DENALI_BASE + regno * 4);
}

static inline void denali_writel(uint32_t val, int regno)
{
	writel(val, DVF99_DENALI_BASE + regno * 4);
}

static inline int denali_enabled(void)
{
	return readl(DVF99_CMU_BASE + 0x5C) & (1<<12);
}

void denali_activate_all_cs_for_selfrefresh(void)
{
	if (denali_enabled())
		denali_set(cs_map, 3);
}

int dram_init(void)
{
	char str[32];
	int dram_class;

#ifdef CONFIG_DVF99_RAM_SIZE_OVERRIDE
	/* override RAM size from board config */
	gd->ram_size = CONFIG_DVF99_RAM_SIZE_OVERRIDE;
#else
	if (denali_enabled()) {
		/* calculate size per chip select */
		gd->ram_size = 2UL << (
			denali_get(max_row_reg) - denali_get(row_diff) + /* rows */
			denali_get(max_col_reg) - denali_get(col_diff) + /* columns */
			3 - denali_get(bank_diff));                      /* banks */

		/* double if both chip selects are used */
		if (denali_get(cs_map) == 0x03)
			gd->ram_size *= 2;
	} else {
		unsigned long val;

		val = (readl(DVF99_MPMC_BASE + 0x120 /*MPMCDynamicConfig1*/) >> 9) & 0x7;
		switch (val) {
		case 0: gd->ram_size = 0x0200000UL; break;
		case 1: gd->ram_size = 0x0800000UL; break;
		case 2: gd->ram_size = 0x1000000UL; break;
		case 3: gd->ram_size = 0x2000000UL; break;
		case 4: gd->ram_size = 0x4000000UL; break;
		}
	}
#endif

	gd->bd->bi_dram[0].size = gd->ram_size;

	puts("MEM:   ");
	if (denali_enabled()) {
		switch (denali_get(dram_class)) {
		case 0:
		case 1:
			dram_class = 1;
			break;
		case 4:
			dram_class = 2;
			break;
		case 6:
			dram_class = 3;
			break;
		default:
			dram_class = 0;
		}

		sprintf(str, "DDR%d (%luMHz)\n", dram_class,
			dvf99_get_dramfreq()/1000000UL);
	} else {
		sprintf(str, "SDRAM\n");
	}
	puts(str);

	return 0;
}

