/*
 * (C) Copyright 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <command.h>

int do_cfg_mac_addr(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	char mac[20];
	unsigned long long addr = 0x009696969600ULL + simple_strtol(argv[1], NULL, 10);

	sprintf(mac, "%02llX:%02llX:%02llX:%02llX:%02llX:%02llX",
		(addr >> 40) & 0xff, (addr >> 32) & 0xff, (addr >> 24) & 0xff,
		(addr >> 16) & 0xff, (addr >>  8) & 0xff,  addr        & 0xff);
	setenv ("ethaddr", mac);

#ifndef CONFIG_ENV_IS_NOWHERE
	saveenv();
#endif

	return 0;
}

U_BOOT_CMD(cfg_mac_addr, 2, 0, do_cfg_mac_addr,
	"cfg_mac_addr - Configure Ethernet MAC address.\n",
	""
);
