#ifndef _INCLUDE_ASM_ARCH_HARDWARE_H
#define _INCLUDE_ASM_ARCH_HARDWARE_H

#define DVF99_SYSCFG_GCR1	0x04
#define DVF99_SYSCFG_CHIP_ID	0x1c
#define DVF99_SYSCFG_CHIP_REV	0x20
#define DVF99_CMU_RSTSR		0x48
#define DVF99_CMU_SWSYSRST	0x40

#define DVF99_CHIP_UNKNOWN	-1
#define DVF99_CHIP_DVF99	99

#define DVF99_BOOTROM_BASE	0x01200000
#define CONFIG_SYS_SYNDWC_BASE	0x00900000 // FIXME

#define DVF99_MPMC_SIZE_OFFSET	0x98

#define DVF99_DDR_4Gb_MASK	0x00000002
#define DVF99_DDR_2Gb_MASK	0x00000001

#define DVF99_ONCHIP_RAM	0x00200000
#define DVF99_INTRAM_BASE	0x00200000

#define DVF99_MPMC_BASE		0x01000000
#define DVF99_DENALI_BASE	0x00100000
#define DVF99_SDRAM_BASE	0xC8000000

#define DVF99_USB1_OTG_BASE	0x00300000
#define DVF99_USB2_OTG_BASE	0x00400000

#define DVF99_UART1_BASE	0x05A00000
#define DVF99_UART2_BASE	0x05B00000
#define DVF99_SYSCFG_BASE	0x05200000
#define DVF99_CMU_BASE		0x05300000
#define DVF99_NAND_LCD_BASE	0x05400000
#define DVF99_QSPI_BASE		0x05500000
#define DVF99_TIMER0_1_BASE	0x05800000
#define DVF99_TIMER2_3_BASE	0x05900020
#define DVF99_SPI1_BASE		0x05D00000
#define DVF99_SPI2_BASE		0x05E00000
#define DVF99_I2C1_BASE		0x06200000
#define DVF99_I2C2_BASE		0x06100000
#define DVF99_PMU_BASE		0x06300000
#define DVF99_CRYPTO_BASE	0x06C00000
#define DVF99_ETHERMAC_BASE	0x06E00000
#define DVF99_CCU0_BASE		0x07000000

#define DVF99_RECOVERY_INFOSIZE	64

#endif /* _INCLUDE_ASM_ARCH_HARDWARE_H */
