
#include <linux/err.h>
#include <linux/init.h>
#include <linux/sec.h>
#include <linux/kernel.h>

#include <mach/platform.h>

static struct sec_msg *pm_dram;
static struct sec_msg *pm_pdwn;

static void css_pm_dram_handler(int id, unsigned long data, void *context)
{
}

static void css_pm_pwdn_Handler(int id, unsigned long data, void *context)
{
}

static int __init pm_sec_init(void)
{
	pm_dram = sec_msg_register(css_pm_dram_handler, SEC_MSG_DRAM, SEC_FIQ,
				   NULL);
	if (IS_ERR(pm_dram))
		printk(KERN_ERR "failed to register CSS DRAM SEC handler: %ld\n",
			PTR_ERR(pm_dram));

	pm_pdwn = sec_msg_register(css_pm_pwdn_Handler, SEC_MSG_PWR_DOWN, SEC_FIQ,
				   NULL);
	if (IS_ERR(pm_pdwn))
		printk(KERN_ERR "failed to register CSS power down SEC handler: %ld\n",
			PTR_ERR(pm_pdwn));

	return 0;
}
late_initcall(pm_sec_init);
