/*
 *  linux/arch/arm/mach-dvf/pm.h
 *
 *  Copyright (C) 2013 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */

#ifndef __MACH_PM_H
#define __MACH_PM_H

#define SLEEP_DDR_LP_MODE		0x0100	/* Put DDR into low-power mode */
#define SLEEP_CPU_PLL_OFF		0x0200	/* Switch off PLL1 */
#define SLEEP_DDR_PLL_OFF		0x0400	/* Switch off PLL2 */

#define WFI				0x00
#define DDR_MODE_ACTIVE_PWRDWN		(0x00 | SLEEP_DDR_LP_MODE)
#define DDR_MODE_PRECHARGE_PWRDWN	(0x04 | SLEEP_DDR_LP_MODE)
#define DDR_MODE_SELF_REFRESH		(0x08 | SLEEP_DDR_LP_MODE)
#define DDR_MODE_MEM_CLK_GATING		0x20
#define DDR_MODE_CTL_CLK_GATING		0x40
#define DDR_MODE_MASK			0x6c

#define DDR_MODE_ENTER			(0x82 << 24)
#define DDR_MODE_LEAVE			(0x01 << 24)
#define DDR_MODE_LOCKED			0x20

#define DDR_MODE_SELF_REFRESH_GATING	(DDR_MODE_SELF_REFRESH   | \
					 DDR_MODE_MEM_CLK_GATING | \
					 DDR_MODE_CTL_CLK_GATING | \
					 SLEEP_DDR_PLL_OFF)

#ifndef __ASSEMBLER__

extern atomic_t dvf_active_bm_cnt; /* Number of active bus masters */
void dvf_clk_print_active(void);
void dvf_sleep_selfrefresh(int mode, unsigned long denali_base, unsigned long cmu_base);
void dvf_sleep_selfrefresh_end(void);

#endif

#endif
