#ifndef __GXP_EXT_H__
#define __GXP_EXT_H__

//=================
// Defines
//=================
#define I2C_DISCOVERY_ADDR 0x10
#define I2C_DISCOVERY_ADDR_NEW 0x40
#define I2C_DEVICE_ADDR_START 0x02
#define NUM_BOARDS 4
#define MAX_FILE_SIZE 0x400000

//=================
// Typedefs
//=================
typedef enum {
    EXT_PACKET_NOP,
    EXT_PACKET_DISCOVERY, /* Deprecated */
    EXT_PACKET_LINK,
    EXT_PACKET_NET, /* Deprecated */
    EXT_PACKET_DBUS,
    EXT_PACKET_FILE_REQUEST,
    EXT_PACKET_FILE_RESPONSE,
    EXT_PACKET_FILE_RELEASE,
    EXT_PACKET_CHUNK_REQUEST,
    EXT_PACKET_CHUNK_RESPONSE,
    EXT_PACKET_MAX,
} ext_packet_type;

struct ext_packet {
    u16 len;
    u8 type;
    u8 pad;
    u32 crc;
    union {
        u8 data;
        u8 addr;
        u8 link;
        struct {
            uint32_t offset;
            uint32_t checksum;
        } chunk;
        uint32_t filesize;
    } msg;
};


#endif

/* EOF */

