/*
 * include/linux/clksrc-dspg-rtc.h
 *
 * Copyright (C) 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LINUX_CLKSRC_DSPG_RTC_H
#define __LINUX_CLKSRC_DSPG_RTC_H

#include <linux/init.h>

struct dspg_rtc;
struct timespec;
struct device_node;

unsigned long dspg_rtc_read(struct dspg_rtc *rtc);
unsigned long dspg_rtc_rate(struct dspg_rtc *rtc);
void dspg_rtc_persistent_clock(struct dspg_rtc *rtc, struct timespec *ts);

struct dspg_rtc * __init dspg_rtc_init(struct device_node *node);
int __init dspg_rtc_register_clocksource(struct dspg_rtc *rtc);

#endif
