/****************************************************************************
 *
 * FILENAME:		$RCSfile: kgui.h,v $
 *
 * LAST REVISION:	$Revision: 1.2 $
 * LAST MODIFIED:   $Date: 2013/08/19 20:18:09 $
 *
 * DESCRIPTION:		
 *
 * vi: set ts=4:
 *
 * Copyright (c) 2005 by Grandstream Networks, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 * 
 ***************************************************************************/

#ifndef KGUI_H
#define KGUI_H

//=======================
//	Includes
//=======================
#include <linux/module.h>
#include <linux/ioctl.h>
#include <linux/fb.h>

//=======================
// 	Defines
//=======================
#define KGUI_IOC_MAGIC 'K'
#define KGUI_IOC_PROGRESS _IOW( KGUI_IOC_MAGIC, 0, int )
#define KGUI_IOC_OP _IOW( KGUI_IOC_MAGIC, 1, struct kgui_op )
#define KGUI_IOC_ACTIVATE _IO( KGUI_IOC_MAGIC, 2 )
#define KGUI_IOC_DEACTIVATE _IO( KGUI_IOC_MAGIC, 3 )
#define KGUI_IOC_FLIP _IO( KGUI_IOC_MAGIC, 4 )

#define LOCATION_TOP 0
#define LOCATION_MID 1
#define LOCATION_BOT 2
#define LOCATION_TRAIL 4

//=======================
// 	Globals
//=======================

//=======================
// 	Typedefs
//=======================
struct kgui_op {
    int sync;
    int clear;
    int logo;
    struct
    {
        int enabled;
        char string[128];
    } string;
    struct
    {
        int enabled;
        int percent;
    } progress;
    struct
    {   
        int enabled;
    } throbber;
};

//=======================
// 	Functions
//=======================
void
kgui_init(
    struct fb_info * info,
/*
    unsigned char * fb,
    unsigned int lcd_width,
    unsigned int lcd_height,
    unsigned int width,
    unsigned int height,
    unsigned int start,
    unsigned int depth,
*/
    void (*activate_fxn)(void),
    void (*deactivate_fxn)(void),
    void (*flip_fxn)(int),
    void (*update_screen_fxn)(void *, int, int, int, int)
);

#endif

