/*
 * dvf-tdm.h -- DVF ASoC CPU DAI driver
 *
 *  Copyright (C) 2011 DSPG Technologies GmbH
 *
 * 2nd Jan, 2013:
 * Adapted to kernel 3.4 by Sujan.S <sujan.somisetty@dspg.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __DVF_TDM_H
#define __DVF_TDM_H

#include <sound/soc.h>

extern int dvf_tdm_set_bits_per_sample(struct snd_soc_dai *cpu_dai, unsigned int bps);

extern void dvf_tdm_set_telephony(struct snd_soc_dai *cpu_dai, int tel_rqst);

extern void dvf_tdm_set_slots(struct snd_soc_dai *cpu_dai, int slots);

typedef void (*tdm_reset_fp_t)(int enable);

/* Platform data structure */
struct dvf_tdm_pdata {
	tdm_reset_fp_t reset;
};

#endif

