#ifndef __LINUX_INCLUDE_VIDEO_DSPGFB_H
#define __LINUX_INCLUDE_VIDEO_DSPGFB_H

#define LCDC_REG_INTR        0x0000
#define LCDC_REG_INTSR       0x0004
#define LCDC_REG_INTER       0x0008
#define LCDC_REG_LCDCCR      0x0010
#define LCDC_REG_INTMR       0x0020
#define LCDC_REG_DISPCR      0x0024
#define LCDC_REG_OSDMCR      0x0028
#define LCDC_REG_INDTR       0x0040
#define LCDC_REG_INDXSR      0x0044
#define LCDC_REG_INDYSR      0x0048
#define LCDC_REG_DISPXSPOSR  0x0050
#define LCDC_REG_DISPXEPOSR  0x0054
#define LCDC_REG_DISPYSPOS1R 0x0060
#define LCDC_REG_DISPYEPOS1R 0x0064
#define LCDC_REG_DISPYSPOS2R 0x0068
#define LCDC_REG_DISPYEPOS2R 0x006c
#define LCDC_REG_DISPIDXR    0x0090
#define LCDC_REG_MSBAHBA0R   0x00a0
#define LCDC_REG_LSBAHBA0R   0x00a4
#define LCDC_REG_OFFAR0      0x00a8
#define LCDC_REG_MSBAHBA1R   0x00B0
#define LCDC_REG_LSBAHBA1R   0x00B4
#define LCDC_REG_OFFAR1      0x00B8
#define LCDC_REG_PALR0       0x0100
#define LCDC_REG_PALR1       0x0104
#define LCDC_REG_PALR2       0x0108
#define LCDC_REG_PALR3       0x010c
#define LCDC_REG_BACKCPR     0x0140
#define LCDC_REG_RBCR        0x0150
#define LCDC_REG_GBCR        0x0154
#define LCDC_REG_BBCR        0x0158
#define LCDC_REG_GC0R        0x0160
#define LCDC_REG_GC1R        0x0164
#define LCDC_REG_GC2R        0x0168
#define LCDC_REG_GC3R        0x016c
#define LCDC_REG_GC4R        0x0170
#define LCDC_REG_GC5R        0x0174
#define LCDC_REG_GC6R        0x0178
#define LCDC_REG_GC7R        0x017c
#define LCDC_REG_GC8R        0x0180
#define LCDC_REG_GC9R        0x0184
#define LCDC_REG_GC10R       0x0188
#define LCDC_REG_GC11R       0x018c
#define LCDC_REG_GC12R       0x0190
#define LCDC_REG_GC13R       0x0194
#define LCDC_REG_GC14R       0x0198
#define LCDC_REG_GC15R       0x019c
#define LCDC_REG_GC16R       0x01a0
#define LCDC_REG_GCER        0x01a4
#define LCDC_REG_YCLPCR      0x0200
#define LCDC_REG_CCLPCR      0x0204
#define LCDC_REG_CLPER       0x0208
#define LCDC_REG_DISPIR      0x0240
#define LCDC_REG_PANCSR      0x0250
#define LCDC_REG_VSTR        0x0270
#define LCDC_REG_VFTR        0x0274
#define LCDC_REG_VATR        0x0278
#define LCDC_REG_VETR        0x027C
#define LCDC_REG_HSTR        0x0280
#define LCDC_REG_HFTR        0x0284
#define LCDC_REG_HADSTR      0x0288
#define LCDC_REG_HAPWR       0x028c
#define LCDC_REG_HETR        0x0290
#define LCDC_REG_CTLTR0      0x02a8
#define LCDC_REG_CMDFSR      0x02c0
#define LCDC_REG_CMDAR       0x02c4
#define LCDC_REG_TXDR        0x02c8
#define LCDC_REG_RXDR        0x02cc
#define LCDC_REG_GP0A_H_HI   0x0310
#define LCDC_REG_GP0A_V_ST   0x0314
#define LCDC_REG_GP0A_H_LO   0x0318
#define LCDC_REG_GP0A_V_END  0x031c
#define LCDC_REG_GP0ACNTR    0x0320
#define LCDC_REG_GP0B_H_HI   0x0330
#define LCDC_REG_GP0B_V_ST   0x0334
#define LCDC_REG_GP0B_H_LO   0x0338
#define LCDC_REG_GP0B_V_END  0x033c
#define LCDC_REG_GP0BCNTR    0x0340
#define LCDC_REG_GP1A_H_HI   0x0350
#define LCDC_REG_GP1A_V_ST   0x0354
#define LCDC_REG_GP1A_H_LO   0x0358
#define LCDC_REG_GP1A_V_END  0x035c
#define LCDC_REG_GP1ACNTR    0x0360
#define LCDC_REG_GP1B_H_HI   0x0370
#define LCDC_REG_GP1B_V_ST   0x0374
#define LCDC_REG_GP1B_H_LO   0x0378
#define LCDC_REG_GP1B_V_END  0x037c
#define LCDC_REG_GP1BCNTR    0x0380
#define LCDC_REG_GP2_H_HI    0x0390
#define LCDC_REG_GP2_V_ST    0x0394
#define LCDC_REG_GP2_H_LO    0x0398
#define LCDC_REG_GP2_V_END   0x039c
#define LCDC_REG_GP2_H_EX    0x03a0
#define LCDC_REG_GP2_V_EX    0x03a4
#define LCDC_REG_GP2CNTR     0x03a8
#define LCDC_REG_GP3_H_HI    0x03b0
#define LCDC_REG_GP3_V_ST    0x03b4
#define LCDC_REG_GP3_H_LO    0x03b8
#define LCDC_REG_GP3_V_END   0x03bc
#define LCDC_REG_GP3_H_EX    0x03c0
#define LCDC_REG_GP3_V_EX    0x03c4
#define LCDC_REG_GP3CNTR     0x03c8
#define LCDC_REG_GP4_H_HI    0x03d0
#define LCDC_REG_GP4_V_ST    0x03d4
#define LCDC_REG_GP4_H_LO    0x03d8
#define LCDC_REG_GP4_V_END   0x03dc
#define LCDC_REG_GP4CNTR     0x03e0
#define LCDC_REG_GP5_H_HI    0x03f0
#define LCDC_REG_GP5_V_ST    0x03f4
#define LCDC_REG_GP5_H_LO    0x03f8
#define LCDC_REG_GP5_V_END   0x03fc
#define LCDC_REG_GP5CNTR     0x0400
#define LCDC_REG_GP6_H_HI    0x0410
#define LCDC_REG_GP6_V_ST    0x0414
#define LCDC_REG_GP6_H_LO    0x0418
#define LCDC_REG_GP6_V_END   0x041c
#define LCDC_REG_GP6CNTR     0x0420
#define LCDC_REG_GP7_H_HI    0x0430
#define LCDC_REG_GP7_V_ST    0x0434
#define LCDC_REG_GP7_H_LO    0x0438
#define LCDC_REG_GP7_V_END   0x043c
#define LCDC_REG_GP7CNTR     0x0440
#define LCDC_REG_GP8A_H_HI   0x0450
#define LCDC_REG_GP8A_V_ST   0x0454
#define LCDC_REG_GP8A_H_LO   0x0458
#define LCDC_REG_GP8A_V_END  0x045c
#define LCDC_REG_GP8ACNTR    0x0460
#define LCDC_REG_GP8B_H_HI   0x0470
#define LCDC_REG_GP8B_V_ST   0x0474
#define LCDC_REG_GP8B_H_LO   0x0478
#define LCDC_REG_GP8B_V_END  0x047c
#define LCDC_REG_GP8BCNTR    0x0480
#define LCDC_REG_GP_HMAXR    0x0490
#define LCDC_REG_GP_VMAXR    0x0494
#define LCDC_REG_GPSELR      0x04a0
#define LCDC_REG_GP_FMR      0x04a4
#define LCDC_REG_PARUP       0x04d0
#define LCDC_REG_CDISPUPR    0x04d4
#define LCDC_REG_ISTAR0      0x04f0
#define LCDC_REG_ISTAR1      0x04f4
#define LCDC_REG_ISTAR2      0x04f8
#define LCDC_REG_ISTAR3      0x04fc
#define LCDC_REG_ISTAR4      0x0500
#define LCDC_REG_CMDFIFOR0   0x0528
#define LCDC_REG_CMDFIFOR1   0x052c
#define LCDC_REG_CMDFIFOR2   0x0530
#define LCDC_REG_CMDFIFOR3   0x0534
#define LCDC_REG_CMDFIFOR4   0x0538
#define LCDC_REG_CMDFIFOR5   0x053c
#define LCDC_REG_CMDFIFOR6   0x0540
#define LCDC_REG_CMDFIFOR7   0x0544
#define LCDC_REG_CMDFIFOR8   0x0548
#define LCDC_REG_CMDFIFOR9   0x054c
#define LCDC_REG_CMDFIFOR10  0x0550
#define LCDC_REG_CMDFIFOR11  0x0554
#define LCDC_REG_RSCMDR      0x0558
#define LCDC_REG_RWCMDR      0x055c
#define LCDC_REG_LCMDR       0x0560

#define LCDC_REG_CURCR0      0x0564
#define LCDC_REG_CURCR1      0x0568
#define LCDC_REG_CURXSPR     0x056c
#define LCDC_REG_CURYSPR     0x0570
#define LCDC_REG_CURPALR1    0x0574
#define LCDC_REG_CURPALR2    0x0578
#define LCDC_REG_CURPALR3    0x057c
#define LCDC_REG_CURBITMAP   0x1000

#define LCDC_SEQ_END         0xffffffff

#define CMDAR_BIT_CMD_LAST		(1 << 6)
#define CMDAR_BIT_CMD_WRITE		(1 << 5)
#define CMDAR_BIT_CMD_RS_1		(1 << 4)
#define CMDAR_BIT_CMD_ADDR(addr)	((addr) & 0xf)

struct dspgfb_seq {
	unsigned long addr;
	unsigned short value;
};

struct dspgfb_pdata {
	const char *name;
	int bits_per_pixel;
	int fb_bits_per_pixel;
	int cputype;
	int order;
	struct fb_videomode mode;
	struct dspgfb_seq *init_seq;
};

struct dspgfb;

unsigned long dspgfb_readl(struct dspgfb *dspgfb, unsigned long addr);
void dspgfb_writel(struct dspgfb *dspgfb, unsigned long addr, unsigned long val);

#define FBIOSET_BACKGROUND _IOW('W', 7, unsigned int)

#define CPUTYPE_VSYNC_TIME 0

#endif /* __LINUX_INCLUDE_VIDEO_DSPGFB_H */
