/*
 * snd-dvf99-evb.c -- Board-specific Asoc machine driver for DVF99
 *
 *  Copyright (C) 2011 DSPG Technologies GmbH
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <sound/soc.h>
#include <sound/soc-dapm.h>

static const struct snd_soc_dapm_widget board_dapm_widgets[] = {
	SND_SOC_DAPM_MIC("Handset-Mic", NULL),
	SND_SOC_DAPM_MIC("Headset-Mic", NULL),
	SND_SOC_DAPM_MIC("Onboard-Mic", NULL),
	SND_SOC_DAPM_SPK("Earpiece1", NULL),
	SND_SOC_DAPM_SPK("Earpiece2", NULL),
	SND_SOC_DAPM_SPK("Speaker", NULL)
};

static const struct snd_soc_dapm_route board_audio_route[] = {
	/* Handset mic is connected to differential input */
	{"Mic0 Bias", NULL, "Handset-Mic"},
	{"DIFFIN1P", NULL, "Mic0 Bias"},
	{"DIFFIN1N", NULL, "Mic0 Bias"},
	/* Headset mic is connected to the differential input 0 */
	{"Mic1 Bias", NULL, "Headset-Mic"},
	{"DIFFIN0P", NULL, "Mic1 Bias"},
	{"DIFFIN0N", NULL, "Mic1 Bias"},
	
	{"Mic1 Bias", NULL, "Onboard-Mic"},
	{"SINGIN0-SINGIN1_INP", NULL, "Mic1 Bias"},
	
	{"Earpiece1" , NULL, "AMPOUT0"},
	{"Earpiece1" , NULL, "AMPOUT1"},
	{"Earpiece2" , NULL, "AMPOUT2"},
	{"Earpiece2" , NULL, "AMPOUT3"},
	{"Speaker" ,   NULL, "DCLASS"},
};

/* Include the machine driver file */
#include "snd-dvf99.c"
