/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "config_grammar.y"

/*******************************************************************
 * Grammar for configuration file
 * 
 * Licensed under a dual GPL/BSD license.  (See LICENSE file for more info.)
 *
 * File: config_grammar.y
 *
 * Authors: bdpayne@cs.umd.edu, npetroni@cs.umd.edu, Chris.Hessing@utah.edu
 *
 * $Id: config_grammar.y,v 1.1 2010/06/29 08:23:32 xux Exp $
 * $Date: 2010/06/29 08:23:32 $
 * $Log: config_grammar.y,v $
 * Revision 1.1  2010/06/29 08:23:32  xux
 * Added.
 *
 * Revision 1.13  2006/10/05 22:23:49  chessing
 * Added new association option to the config file, and attempt to associate using methods other than open system.
 *
 * Revision 1.12  2006/06/01 22:49:49  galimorerpg
 * Converted all instances of u_char to uint8_t
 * Fixed a bad #include in the generic frame handler.
 *
 * Revision 1.11  2006/05/31 05:10:51  chessing
 * Beginnings of EAP-TTLS-EAP-MD5, and added internet draft for EAP-TTLS to doc/standards.
 *
 * Revision 1.10  2006/05/26 22:04:58  chessing
 * Fixed some memory access errors, and cleaned up some wext stuff that was causing issues with the madwifi driver in wext mode.
 *
 * Revision 1.9  2006/05/17 22:18:10  chessing
 * A couple of small changes to Xsupplicant, and some major changes to the GUI configuration/monitor tool.
 *
 * Revision 1.8  2006/05/13 05:56:44  chessing
 * Removed last pieces of code that relied on SIGALRM.  Active scan timeout is now configurable so that people that wish to hammer on their cards now have the option to do that. ;)
 *
 * Revision 1.7  2006/04/17 03:56:23  chessing
 * Added some support to enable/disable TNC support both via the configuration file, and via IPC.
 *
 * Revision 1.6  2006/03/08 00:16:04  chessing
 * Fixed EAP hints code to work correctly when the request ID packet is padded out with null bytes.  (Observed in Aruba APs.)  Some changes/fixes for the EAP-AKA module.
 *
 * Revision 1.5  2006/02/23 22:26:50  chessing
 * Fix for bug id #1415020.  'Building Xsupplicant 1.2.3 Fails on FC4'.
 *
 * Revision 1.4  2006/01/03 04:02:35  chessing
 * Added the ability to store the PEAP password in a hashed format.  (Basically, an MS-CHAPv1 hash.)  Also added an 'ntpwdhash' program to the tools directory that will convert a cleartext password in to a hash that can be copied to the configuration file.
 *
 * Revision 1.3  2005/11/10 04:56:54  chessing
 * Added patch from Ben Gardner to add support for setting a specific WEP key prior to attempting to associte.  (With a few slight modifications by me to make it fit in the current CVS code, and get it supported in config-parse.)  Added patch from Pekka Savola to fix some header ordering issues, and a potential buffer overflow.
 *
 * Revision 1.2  2005/10/26 18:56:12  chessing
 * Some build fixes and small updates.
 *
 * Revision 1.1  2005/10/17 00:15:55  chessing
 * Moved the config parsing routines out to a new library called libxsupconfig.a, so that it will be easier to create third-party tools that can easily parse a config.
 *
 * Revision 1.65  2005/10/14 02:26:17  shaftoe
 * - cleanup gcc 4 warnings
 * - (re)add support for a pid in the form of /var/run/xsupplicant.<iface>.pid
 *
 * -- Eric Evans <eevans@sym-link.com>
 *
 * Revision 1.64  2005/09/08 16:27:01  chessing
 * Some small updates to the new state machine code.  First attempt at an auto association mode.  (It mostly works. ;)
 *
 * Revision 1.63  2005/08/25 02:20:20  chessing
 * Some cleanup in xsup_debug.c, added the ability to wait for an interface to come up if it is down when Xsupplicant is started.  Roughed in the ability to choose between having Xsupplicant auto associate you, or allow you to set the ssid manually.  The stale key timer can now be set in the config file.  The association timeout can be set in the config file, and will also be used once the functionality is in place to attempt to guess the key settings needed for association, as well as the functionality to auto associate.
 *
 * Revision 1.62  2005/08/20 19:06:53  chessing
 * Patch from Carsten Grohmann to fix a few things in xsup_get_state.c.  Also added the ability to define an empty network clause, that will set the card in to encryption disabled mode.  From there, anything short of changing the SSID will be ignored by Xsupplicant.
 *
 * Revision 1.61  2005/08/18 03:19:04  chessing
 * Added the ability to define an SSID with static WEP keys.  When we switch to a network that has this type of configuration we will set the keys, and stop the various association timers.
 *
 * Revision 1.60  2005/08/12 03:34:06  chessing
 * Fix to the TLS implementation, should help avoid some of the weird 'block cipher pad' errors.  Also includes a partial implementation of the ability to use static WEP keys based on the SSID in use.
 *
 * Revision 1.59  2005/08/09 01:39:13  chessing
 * Cleaned out old commit notes from the released version.  Added a few small features including the ability to disable the friendly warnings that are spit out.  (Such as the warning that is displayed when keys aren't rotated after 10 minutes.)  We should also be able to start when the interface is down.  Last, but not least, we can handle empty network configs.  (This may be useful for situations where there isn't a good reason to have a default network defined.)
 *
 *******************************************************************/  
  
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
  
#include <profile.h>
#include "xsupconfig.h"
#include <xsup_err.h>
#include "xsup_debug.h"
#include "wpa.h"

#ifdef EAP_SIM_ENABLE
#include "winscard.h"
#endif

#ifdef USE_EFENCE
#include <efence.h>
#endif

#define CLEAN_EXIT cleanup_parse(); return XECONFIGPARSEFAIL

int yylex(void);  
int yyerror(char *err);

extern struct config_data *config_info;
extern int config_linenum;

extern int config_parse_debug;

struct config_data *tmp_config = NULL;

struct config_eap_tls *tmp_tls = NULL;
struct config_eap_md5 *tmp_md5 = NULL;
struct config_eap_ttls *tmp_ttls = NULL;
struct config_eap_leap *tmp_leap = NULL;
struct config_eap_mschapv2 *tmp_mschapv2 = NULL;
struct config_eap_peap *tmp_peap = NULL; 
struct config_eap_sim *tmp_sim = NULL;
struct config_eap_aka *tmp_aka = NULL;
struct config_wpa_psk *tmp_wpa_psk = NULL;
struct config_static_wep *tmp_static_wep = NULL;
struct config_static_wep *tmp_initial_wep = NULL;

struct config_pap *tmp_p2pap =NULL;
struct config_chap *tmp_p2chap = NULL;
struct config_mschap *tmp_p2mschap = NULL;
struct config_mschapv2 *tmp_p2mschapv2 = NULL;

struct config_network *tmp_network = NULL;



void set_current_tls() {
  if (tmp_tls == NULL) 
    initialize_config_eap_tls(&tmp_tls);
} 
void set_current_static_wep() {
  if (tmp_static_wep == NULL)
    initialize_config_static_wep(&tmp_static_wep);
}
void set_current_initial_wep() {
  if (tmp_initial_wep == NULL)
    initialize_config_static_wep(&tmp_initial_wep);
}
void set_current_md5() {
  if (tmp_md5 == NULL) 
    initialize_config_eap_md5(&tmp_md5);
} 
void set_current_ttls() {
  if (tmp_ttls == NULL) 
    initialize_config_eap_ttls(&tmp_ttls);
} 
void set_current_leap() {
  if (tmp_leap == NULL) 
    initialize_config_eap_leap(&tmp_leap);
} 
void set_current_mschapv2() {
  if (tmp_mschapv2 == NULL) 
    initialize_config_eap_mschapv2(&tmp_mschapv2);
} 
void set_current_peap() {
  if (tmp_peap == NULL) 
    initialize_config_eap_peap(&tmp_peap);
} 
void set_current_sim() {
  if (tmp_sim == NULL) 
    initialize_config_eap_sim(&tmp_sim);
} 

void set_current_aka() {
  if (tmp_aka == NULL)
    initialize_config_eap_aka(&tmp_aka);
}

void set_current_wpa_psk() {
  if (tmp_wpa_psk == NULL)
    initialize_config_wpa_psk(&tmp_wpa_psk);
}

void set_current_p2pap() {
  if (tmp_p2pap == NULL)
    initialize_config_pap(&tmp_p2pap);
}
void set_current_p2chap() {
  if (tmp_p2chap == NULL)
    initialize_config_chap(&tmp_p2chap);
}
void set_current_p2mschap() {
  if (tmp_p2mschap == NULL)
    initialize_config_mschap(&tmp_p2mschap);
}
void set_current_p2mschapv2() {
  if (tmp_p2mschapv2 == NULL)
    initialize_config_mschapv2(&tmp_p2mschapv2);
}

void set_current_config() {
  if (tmp_config == NULL) 
      initialize_config_data(&tmp_config);
} 

void set_current_globals() {
  set_current_config();
  if (!tmp_config->globals)
    initialize_config_globals(&(tmp_config->globals));
}   

void set_current_network() {
  if (tmp_network == NULL) 
    initialize_config_network(&tmp_network);
} 


void cleanup_parse()
{
  if (tmp_config)
    delete_config_data(&tmp_config);
  if (tmp_static_wep)
    delete_config_static_wep(&tmp_static_wep);
  if (tmp_initial_wep)
    delete_config_static_wep(&tmp_initial_wep);
  if (tmp_tls)
    delete_config_eap_tls(&tmp_tls);
  if (tmp_md5)
    delete_config_eap_md5(&tmp_md5);
  if (tmp_ttls)
    delete_config_eap_ttls(&tmp_ttls);
  if (tmp_leap)
    delete_config_eap_leap(&tmp_leap);
  if (tmp_mschapv2)
    delete_config_eap_mschapv2(&tmp_mschapv2);
  if (tmp_peap)
    delete_config_eap_peap(&tmp_peap);
  if (tmp_sim)
    delete_config_eap_sim(&tmp_sim);
  if (tmp_aka)
    delete_config_eap_aka(&tmp_aka);
  if (tmp_wpa_psk)
    delete_config_wpa_psk(&tmp_wpa_psk);
  if (tmp_p2pap)
    delete_config_pap(&tmp_p2pap);
  if (tmp_p2chap)
    delete_config_chap(&tmp_p2chap);
  if (tmp_p2mschap)
    delete_config_mschap(&tmp_p2mschap);
  if (tmp_p2mschapv2)
    delete_config_mschapv2(&tmp_p2mschapv2);
  if (tmp_network)
    delete_config_network(&tmp_network);
}



/* function to check if debug is on and if so print the message */
void parameter_debug(char *fmt, ...) {
  va_list ap;
  va_start(ap, fmt);
#ifndef PARSE_DEBUG
  return;
#endif
  vprintf(fmt, ap);
  va_end(ap);
}



/* Line 268 of yacc.c  */
#line 340 "config_grammar.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TK_NETWORK_LIST = 258,
     TK_DEFAULT_NETNAME = 259,
     TK_GENSTR = 260,
     TK_DEFAULT_INT = 261,
     TK_LOGFILE = 262,
     TK_LOG_FACILITY = 263,
     TK_AUTH_PERIOD = 264,
     TK_HELD_PERIOD = 265,
     TK_MAX_STARTS = 266,
     TK_STALE_KEY_TIMEOUT = 267,
     TK_ALLMULTI = 268,
     TK_IPC_GROUP = 269,
     TK_DESTINATION = 270,
     TK_BSSID = 271,
     TK_MULTICAST = 272,
     TK_SOURCE = 273,
     TK_AUTO = 274,
     TK_MANUAL = 275,
     TK_ASSOCIATION = 276,
     TK_ASSOC_TIMEOUT = 277,
     TK_ROAMING = 278,
     TK_FIRMWARE = 279,
     TK_XSUPPLICANT = 280,
     TK_PASSIVE_SCANNING = 281,
     TK_PASSIVE_TIMEOUT = 282,
     TK_SCAN_TIMEOUT = 283,
     TK_USE_EAP_HINTS = 284,
     TK_ALL = 285,
     TK_FRIENDLY_WARNINGS = 286,
     TK_TYPE = 287,
     TK_ALLOW_TYPES = 288,
     TK_FORCE_EAPOL_VER = 289,
     TK_WIRELESS = 290,
     TK_WIRED = 291,
     TK_CONTROL_WIRELESS = 292,
     TK_ASSOCIATION_TYPE = 293,
     TK_ASSOC_OPEN = 294,
     TK_ASSOC_SHARED = 295,
     TK_ASSOC_LEAP = 296,
     TK_WPA_GROUP_CRYPT = 297,
     TK_WPA_PAIRWISE_CRYPT = 298,
     TK_WEP40 = 299,
     TK_TKIP = 300,
     TK_WRAP = 301,
     TK_CCMP = 302,
     TK_WEP104 = 303,
     TK_ANY = 304,
     TK_PRIORITY = 305,
     TK_IDENTITY = 306,
     TK_IDENTITY_VAL = 307,
     TK_DEST_MAC = 308,
     TK_MACADDRESS = 309,
     TK_SSID = 310,
     TK_SSID_VAL = 311,
     TK_USE_TNC = 312,
     TK_WPA_PSK = 313,
     TK_WPA_PSK_KEY = 314,
     TK_WPA_PSK_HEX_KEY = 315,
     TK_EAP_TLS = 316,
     TK_USER_CERT = 317,
     TK_USER_KEY = 318,
     TK_USER_KEY_PASS = 319,
     TK_SESSION_RESUME = 320,
     TK_CNCHECK = 321,
     TK_CNEXACT = 322,
     TK_ROOT_CERT = 323,
     TK_ROOT_DIR = 324,
     TK_CRL_DIR = 325,
     TK_CHUNK_SIZE = 326,
     TK_RANDOM_FILE = 327,
     TK_EAP_MD5 = 328,
     TK_USERNAME = 329,
     TK_USERNAME_VAL = 330,
     TK_PASSWORD = 331,
     TK_EAP_LEAP = 332,
     TK_EAP_TTLS = 333,
     TK_PHASE2_TYPE = 334,
     TK_PAP = 335,
     TK_CHAP = 336,
     TK_MSCHAP = 337,
     TK_MSCHAPV2 = 338,
     TK_EAP_MSCHAPV2 = 339,
     TK_MSCHAPV2_HASH_PWD = 340,
     TK_IAS_QUIRK = 341,
     TK_EAP_PEAP = 342,
     TK_PEAPV1_PROPER_KEYING = 343,
     TK_INNER_ID = 344,
     TK_EAP_SIM = 345,
     TK_EAP_AKA = 346,
     TK_AUTO_REALM = 347,
     TK_YES = 348,
     TK_NO = 349,
     TK_EAP_GTC = 350,
     TK_EAP_OTP = 351,
     TK_SMARTCARD = 352,
     TK_ENGINE_ID = 353,
     TK_OPENSC_SO_PATH = 354,
     TK_KEYID = 355,
     TK_STATIC_WEP = 356,
     TK_INITIAL_WEP = 357,
     TK_STATIC_KEY1 = 358,
     TK_STATIC_KEY2 = 359,
     TK_STATIC_KEY3 = 360,
     TK_STATIC_KEY4 = 361,
     TK_WEP_TX_KEY = 362,
     TK_NUMBER = 363,
     TK_UNQUOTED_STR = 364,
     TK_PASS = 365,
     TK_COMMAND = 366,
     TK_QUOTED_STR = 367
   };
#endif
/* Tokens.  */
#define TK_NETWORK_LIST 258
#define TK_DEFAULT_NETNAME 259
#define TK_GENSTR 260
#define TK_DEFAULT_INT 261
#define TK_LOGFILE 262
#define TK_LOG_FACILITY 263
#define TK_AUTH_PERIOD 264
#define TK_HELD_PERIOD 265
#define TK_MAX_STARTS 266
#define TK_STALE_KEY_TIMEOUT 267
#define TK_ALLMULTI 268
#define TK_IPC_GROUP 269
#define TK_DESTINATION 270
#define TK_BSSID 271
#define TK_MULTICAST 272
#define TK_SOURCE 273
#define TK_AUTO 274
#define TK_MANUAL 275
#define TK_ASSOCIATION 276
#define TK_ASSOC_TIMEOUT 277
#define TK_ROAMING 278
#define TK_FIRMWARE 279
#define TK_XSUPPLICANT 280
#define TK_PASSIVE_SCANNING 281
#define TK_PASSIVE_TIMEOUT 282
#define TK_SCAN_TIMEOUT 283
#define TK_USE_EAP_HINTS 284
#define TK_ALL 285
#define TK_FRIENDLY_WARNINGS 286
#define TK_TYPE 287
#define TK_ALLOW_TYPES 288
#define TK_FORCE_EAPOL_VER 289
#define TK_WIRELESS 290
#define TK_WIRED 291
#define TK_CONTROL_WIRELESS 292
#define TK_ASSOCIATION_TYPE 293
#define TK_ASSOC_OPEN 294
#define TK_ASSOC_SHARED 295
#define TK_ASSOC_LEAP 296
#define TK_WPA_GROUP_CRYPT 297
#define TK_WPA_PAIRWISE_CRYPT 298
#define TK_WEP40 299
#define TK_TKIP 300
#define TK_WRAP 301
#define TK_CCMP 302
#define TK_WEP104 303
#define TK_ANY 304
#define TK_PRIORITY 305
#define TK_IDENTITY 306
#define TK_IDENTITY_VAL 307
#define TK_DEST_MAC 308
#define TK_MACADDRESS 309
#define TK_SSID 310
#define TK_SSID_VAL 311
#define TK_USE_TNC 312
#define TK_WPA_PSK 313
#define TK_WPA_PSK_KEY 314
#define TK_WPA_PSK_HEX_KEY 315
#define TK_EAP_TLS 316
#define TK_USER_CERT 317
#define TK_USER_KEY 318
#define TK_USER_KEY_PASS 319
#define TK_SESSION_RESUME 320
#define TK_CNCHECK 321
#define TK_CNEXACT 322
#define TK_ROOT_CERT 323
#define TK_ROOT_DIR 324
#define TK_CRL_DIR 325
#define TK_CHUNK_SIZE 326
#define TK_RANDOM_FILE 327
#define TK_EAP_MD5 328
#define TK_USERNAME 329
#define TK_USERNAME_VAL 330
#define TK_PASSWORD 331
#define TK_EAP_LEAP 332
#define TK_EAP_TTLS 333
#define TK_PHASE2_TYPE 334
#define TK_PAP 335
#define TK_CHAP 336
#define TK_MSCHAP 337
#define TK_MSCHAPV2 338
#define TK_EAP_MSCHAPV2 339
#define TK_MSCHAPV2_HASH_PWD 340
#define TK_IAS_QUIRK 341
#define TK_EAP_PEAP 342
#define TK_PEAPV1_PROPER_KEYING 343
#define TK_INNER_ID 344
#define TK_EAP_SIM 345
#define TK_EAP_AKA 346
#define TK_AUTO_REALM 347
#define TK_YES 348
#define TK_NO 349
#define TK_EAP_GTC 350
#define TK_EAP_OTP 351
#define TK_SMARTCARD 352
#define TK_ENGINE_ID 353
#define TK_OPENSC_SO_PATH 354
#define TK_KEYID 355
#define TK_STATIC_WEP 356
#define TK_INITIAL_WEP 357
#define TK_STATIC_KEY1 358
#define TK_STATIC_KEY2 359
#define TK_STATIC_KEY3 360
#define TK_STATIC_KEY4 361
#define TK_WEP_TX_KEY 362
#define TK_NUMBER 363
#define TK_UNQUOTED_STR 364
#define TK_PASS 365
#define TK_COMMAND 366
#define TK_QUOTED_STR 367




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 269 "config_grammar.y"

        char    *str;
        int     num;



/* Line 293 of yacc.c  */
#line 607 "config_grammar.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 619 "config_grammar.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  53
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   811

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  117
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  77
/* YYNRULES -- Number of rules.  */
#define YYNRULES  366
/* YYNRULES -- Number of states.  */
#define YYNSTATES  636

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   367

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   114,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   113,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   115,     2,   116,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     8,    10,    12,    15,    17,    20,
      22,    26,    30,    34,    38,    42,    46,    50,    54,    58,
      62,    66,    70,    74,    78,    82,    86,    90,    94,    98,
     102,   106,   110,   114,   118,   122,   126,   130,   134,   138,
     142,   146,   150,   154,   158,   162,   166,   170,   174,   178,
     182,   186,   190,   192,   196,   198,   203,   208,   213,   217,
     221,   225,   228,   231,   233,   235,   237,   239,   241,   243,
     245,   247,   249,   251,   253,   255,   257,   261,   265,   269,
     273,   277,   281,   285,   289,   293,   297,   301,   305,   309,
     313,   317,   321,   325,   329,   333,   337,   341,   345,   349,
     353,   357,   361,   365,   369,   373,   375,   377,   379,   381,
     383,   385,   387,   389,   391,   393,   395,   399,   401,   403,
     405,   407,   409,   411,   413,   415,   417,   419,   421,   426,
     430,   433,   435,   439,   443,   447,   451,   455,   460,   464,
     467,   469,   473,   477,   481,   485,   489,   494,   498,   501,
     503,   508,   511,   513,   517,   521,   525,   529,   533,   537,
     541,   545,   549,   553,   557,   561,   565,   569,   573,   577,
     581,   585,   589,   593,   597,   601,   605,   609,   611,   616,
     620,   623,   625,   629,   633,   637,   641,   645,   649,   654,
     658,   661,   663,   667,   671,   675,   679,   683,   687,   691,
     695,   699,   703,   707,   711,   715,   719,   723,   727,   731,
     735,   739,   743,   747,   751,   755,   759,   763,   767,   771,
     773,   775,   777,   779,   781,   783,   788,   791,   793,   797,
     801,   805,   809,   813,   817,   822,   825,   827,   831,   835,
     839,   843,   847,   851,   856,   859,   861,   865,   869,   873,
     877,   881,   885,   890,   893,   895,   899,   903,   907,   911,
     915,   919,   921,   926,   930,   933,   935,   939,   943,   947,
     951,   955,   959,   964,   968,   971,   973,   977,   981,   985,
     989,   993,   997,  1001,  1006,  1010,  1013,  1015,  1019,  1023,
    1027,  1031,  1035,  1039,  1043,  1047,  1051,  1055,  1059,  1063,
    1067,  1071,  1075,  1079,  1083,  1087,  1091,  1095,  1099,  1103,
    1107,  1111,  1115,  1119,  1123,  1127,  1131,  1135,  1139,  1143,
    1147,  1149,  1151,  1155,  1159,  1163,  1165,  1167,  1169,  1171,
    1173,  1175,  1177,  1179,  1181,  1186,  1190,  1193,  1195,  1199,
    1203,  1207,  1211,  1215,  1219,  1223,  1227,  1231,  1236,  1240,
    1243,  1245,  1249,  1253,  1257,  1261,  1265,  1269,  1273,  1277,
    1281,  1286,  1290,  1293,  1295,  1299,  1303
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     118,     0,    -1,   119,   120,    -1,   119,    -1,   120,    -1,
       1,    -1,   119,   121,    -1,   121,    -1,   120,   123,    -1,
     123,    -1,     3,   113,    30,    -1,     3,   113,   122,    -1,
       4,   113,   109,    -1,     4,   113,   112,    -1,    31,   113,
      93,    -1,    31,   113,    94,    -1,    31,   113,   109,    -1,
      23,   113,    24,    -1,    23,   113,    25,    -1,    23,   113,
     109,    -1,    26,   113,    93,    -1,    26,   113,    94,    -1,
      26,   113,   109,    -1,    29,   113,    93,    -1,    29,   113,
      94,    -1,    29,   113,   109,    -1,    27,   113,   108,    -1,
      28,   113,   108,    -1,     7,   113,   109,    -1,     7,   113,
     112,    -1,     6,   113,   109,    -1,    12,   113,   108,    -1,
      12,   113,   109,    -1,    21,   113,    19,    -1,    21,   113,
      20,    -1,    21,   113,   109,    -1,    22,   113,   108,    -1,
      22,   113,   109,    -1,     9,   113,   108,    -1,    10,   113,
     108,    -1,    11,   113,   108,    -1,    13,   113,    93,    -1,
      13,   113,    94,    -1,    13,   113,   109,    -1,    14,   113,
     109,    -1,    15,   113,    19,    -1,    15,   113,    16,    -1,
      15,   113,    17,    -1,    15,   113,    18,    -1,    15,   113,
     109,    -1,     8,   113,   109,    -1,   122,   114,   109,    -1,
     109,    -1,   122,   114,   112,    -1,   112,    -1,   109,   115,
     124,   116,    -1,   108,   115,   124,   116,    -1,   112,   115,
     124,   116,    -1,   109,   115,   116,    -1,   112,   115,   116,
      -1,   108,   115,   116,    -1,   124,   125,    -1,   124,   137,
      -1,   125,    -1,   137,    -1,   127,    -1,   126,    -1,   134,
      -1,   128,    -1,   129,    -1,   130,    -1,   133,    -1,   135,
      -1,   136,    -1,   131,    -1,   132,    -1,    50,   113,   108,
      -1,    32,   113,    35,    -1,    32,   113,    36,    -1,    32,
     113,   109,    -1,    42,   113,    44,    -1,    42,   113,    45,
      -1,    42,   113,    46,    -1,    42,   113,    47,    -1,    42,
     113,    48,    -1,    43,   113,    44,    -1,    43,   113,    45,
      -1,    43,   113,    46,    -1,    43,   113,    47,    -1,    43,
     113,    48,    -1,    34,   113,   108,    -1,    38,   113,    39,
      -1,    38,   113,    40,    -1,    38,   113,    41,    -1,    37,
     113,    93,    -1,    37,   113,    94,    -1,    37,   113,   109,
      -1,    51,   113,    52,    -1,    51,   113,   112,    -1,    51,
     113,   109,    -1,    57,   113,    93,    -1,    57,   113,    94,
      -1,    53,   113,    54,    -1,    33,   113,    30,    -1,    33,
     113,   138,    -1,   146,    -1,   152,    -1,   155,    -1,   140,
      -1,   143,    -1,   172,    -1,   175,    -1,   178,    -1,   185,
      -1,   188,    -1,   191,    -1,   138,   114,   139,    -1,   139,
      -1,    61,    -1,    73,    -1,    78,    -1,    77,    -1,    84,
      -1,    87,    -1,    90,    -1,    91,    -1,    95,    -1,    96,
      -1,   101,   115,   141,   116,    -1,   101,   115,   116,    -1,
     141,   142,    -1,   142,    -1,   103,   113,   112,    -1,   104,
     113,   112,    -1,   105,   113,   112,    -1,   106,   113,   112,
      -1,   107,   113,   108,    -1,   102,   115,   144,   116,    -1,
     102,   115,   116,    -1,   144,   145,    -1,   145,    -1,   103,
     113,   112,    -1,   104,   113,   112,    -1,   105,   113,   112,
      -1,   106,   113,   112,    -1,   107,   113,   108,    -1,    61,
     115,   147,   116,    -1,    61,   115,   116,    -1,   147,   151,
      -1,   151,    -1,    97,   115,   149,   116,    -1,   150,   149,
      -1,   150,    -1,    98,   113,   109,    -1,    99,   113,   109,
      -1,    99,   113,   112,    -1,   100,   113,   109,    -1,   100,
     113,   108,    -1,    62,   113,   109,    -1,    62,   113,   112,
      -1,    63,   113,   109,    -1,    63,   113,   112,    -1,    64,
     113,   110,    -1,    64,   113,   112,    -1,    64,   113,   109,
      -1,    65,   113,    93,    -1,    65,   113,    94,    -1,    65,
     113,   109,    -1,    68,   113,   109,    -1,    68,   113,   112,
      -1,    69,   113,   109,    -1,    69,   113,   112,    -1,    70,
     113,   109,    -1,    70,   113,   112,    -1,    71,   113,   108,
      -1,    72,   113,   109,    -1,    72,   113,   112,    -1,   148,
      -1,    73,   115,   153,   116,    -1,    73,   115,   116,    -1,
     153,   154,    -1,   154,    -1,    74,   113,    75,    -1,    74,
     113,   109,    -1,    74,   113,   112,    -1,    76,   113,   110,
      -1,    76,   113,   109,    -1,    76,   113,   112,    -1,    78,
     115,   156,   116,    -1,    78,   115,   116,    -1,   156,   157,
      -1,   157,    -1,    62,   113,   109,    -1,    62,   113,   112,
      -1,    63,   113,   109,    -1,    63,   113,   112,    -1,    64,
     113,   110,    -1,    64,   113,   109,    -1,    64,   113,   112,
      -1,    68,   113,   109,    -1,    68,   113,   112,    -1,    69,
     113,   109,    -1,    69,   113,   112,    -1,    70,   113,   109,
      -1,    70,   113,   112,    -1,    71,   113,   108,    -1,    72,
     113,   109,    -1,    72,   113,   112,    -1,    65,   113,    93,
      -1,    65,   113,    94,    -1,    65,   113,   109,    -1,    66,
     113,   109,    -1,    67,   113,    93,    -1,    67,   113,    94,
      -1,    79,   113,    80,    -1,    79,   113,    81,    -1,    79,
     113,    82,    -1,    79,   113,    83,    -1,    79,   113,    73,
      -1,   158,    -1,   159,    -1,   162,    -1,   165,    -1,   168,
      -1,   171,    -1,    80,   115,   160,   116,    -1,   160,   161,
      -1,   161,    -1,    74,   113,    75,    -1,    74,   113,   109,
      -1,    74,   113,   112,    -1,    76,   113,   110,    -1,    76,
     113,   109,    -1,    76,   113,   112,    -1,    81,   115,   163,
     116,    -1,   163,   164,    -1,   164,    -1,    74,   113,    75,
      -1,    74,   113,   109,    -1,    74,   113,   112,    -1,    76,
     113,   110,    -1,    76,   113,   109,    -1,    76,   113,   112,
      -1,    82,   115,   166,   116,    -1,   166,   167,    -1,   167,
      -1,    74,   113,    75,    -1,    74,   113,   109,    -1,    74,
     113,   112,    -1,    76,   113,   110,    -1,    76,   113,   109,
      -1,    76,   113,   112,    -1,    83,   115,   169,   116,    -1,
     169,   170,    -1,   170,    -1,    74,   113,    75,    -1,    74,
     113,   109,    -1,    74,   113,   112,    -1,    76,   113,   110,
      -1,    76,   113,   109,    -1,    76,   113,   112,    -1,   152,
      -1,    77,   115,   173,   116,    -1,    77,   115,   116,    -1,
     173,   174,    -1,   174,    -1,    74,   113,    75,    -1,    74,
     113,   109,    -1,    74,   113,   112,    -1,    76,   113,   110,
      -1,    76,   113,   109,    -1,    76,   113,   112,    -1,    84,
     115,   176,   116,    -1,    84,   115,   116,    -1,   176,   177,
      -1,   177,    -1,    74,   113,    75,    -1,    74,   113,   109,
      -1,    74,   113,   112,    -1,    76,   113,   110,    -1,    76,
     113,   109,    -1,    76,   113,   112,    -1,    85,   113,   109,
      -1,    87,   115,   179,   116,    -1,    87,   115,   116,    -1,
     179,   180,    -1,   180,    -1,    51,   113,    52,    -1,    51,
     113,   109,    -1,    51,   113,   112,    -1,    62,   113,   109,
      -1,    62,   113,   112,    -1,    63,   113,   109,    -1,    63,
     113,   112,    -1,    64,   113,   110,    -1,    64,   113,   109,
      -1,    64,   113,   112,    -1,    68,   113,   109,    -1,    68,
     113,   112,    -1,    69,   113,   109,    -1,    69,   113,   112,
      -1,    70,   113,   109,    -1,    70,   113,   112,    -1,    65,
     113,    93,    -1,    65,   113,    94,    -1,    65,   113,   109,
      -1,    88,   113,    93,    -1,    88,   113,    94,    -1,    88,
     113,   109,    -1,    89,   113,   109,    -1,    89,   113,   112,
      -1,    71,   113,   108,    -1,    66,   113,   109,    -1,    67,
     113,    93,    -1,    67,   113,    94,    -1,    72,   113,   109,
      -1,    72,   113,   112,    -1,    86,   113,    93,    -1,    86,
     113,    94,    -1,    86,   113,   109,    -1,   181,    -1,   184,
      -1,    33,   113,    30,    -1,    33,   113,   182,    -1,   182,
     114,   183,    -1,   183,    -1,    84,    -1,    73,    -1,    90,
      -1,    96,    -1,    95,    -1,   175,    -1,   152,    -1,   185,
      -1,    90,   115,   186,   116,    -1,    90,   115,   116,    -1,
     186,   187,    -1,   187,    -1,    74,   113,    75,    -1,    74,
     113,   109,    -1,    74,   113,   112,    -1,    76,   113,   110,
      -1,    76,   113,   109,    -1,    76,   113,   112,    -1,    92,
     113,    93,    -1,    92,   113,    94,    -1,    92,   113,   109,
      -1,    91,   115,   189,   116,    -1,    91,   115,   116,    -1,
     189,   190,    -1,   190,    -1,    74,   113,    75,    -1,    74,
     113,   109,    -1,    74,   113,   112,    -1,    76,   113,   110,
      -1,    76,   113,   109,    -1,    76,   113,   112,    -1,    92,
     113,    93,    -1,    92,   113,    94,    -1,    92,   113,   109,
      -1,    58,   115,   192,   116,    -1,    58,   115,   116,    -1,
     192,   193,    -1,   193,    -1,    59,   113,   109,    -1,    59,
     113,   112,    -1,    60,   113,   109,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   392,   392,   396,   400,   405,   411,   412,   415,   416,
     419,   424,   427,   435,   443,   449,   455,   464,   470,   476,
     484,   490,   496,   504,   510,   516,   524,   529,   534,   545,
     556,   567,   571,   577,   581,   585,   591,   595,   600,   607,
     614,   621,   626,   631,   637,   644,   648,   652,   656,   660,
     665,   674,   684,   694,   704,   716,   736,   758,   778,   799,
     820,   844,   845,   846,   847,   851,   852,   853,   854,   855,
     856,   857,   858,   859,   860,   861,   864,   871,   877,   883,
     890,   895,   900,   905,   910,   917,   922,   927,   932,   937,
     944,   951,   956,   961,   968,   974,   980,   987,   995,  1003,
    1013,  1018,  1025,  1052,  1057,  1060,  1072,  1083,  1094,  1102,
    1106,  1117,  1128,  1139,  1150,  1161,  1174,  1175,  1178,  1183,
    1188,  1193,  1198,  1203,  1208,  1213,  1218,  1223,  1230,  1231,
    1236,  1237,  1240,  1246,  1252,  1258,  1264,  1277,  1278,  1283,
    1284,  1287,  1293,  1299,  1305,  1311,  1325,  1326,  1331,  1332,
    1335,  1343,  1344,  1347,  1353,  1359,  1365,  1371,  1380,  1388,
    1396,  1404,  1412,  1420,  1428,  1436,  1442,  1448,  1453,  1461,
    1469,  1477,  1485,  1493,  1501,  1507,  1515,  1523,  1526,  1527,
    1532,  1533,  1536,  1544,  1552,  1560,  1568,  1576,  1586,  1587,
    1592,  1593,  1596,  1604,  1612,  1620,  1628,  1636,  1644,  1652,
    1660,  1668,  1676,  1684,  1692,  1700,  1706,  1714,  1722,  1728,
    1734,  1739,  1747,  1752,  1757,  1767,  1777,  1787,  1797,  1807,
    1810,  1811,  1812,  1813,  1814,  1817,  1830,  1831,  1834,  1842,
    1850,  1858,  1866,  1874,  1884,  1897,  1898,  1901,  1909,  1917,
    1925,  1933,  1941,  1951,  1964,  1965,  1968,  1976,  1984,  1992,
    2000,  2008,  2019,  2032,  2033,  2036,  2044,  2052,  2060,  2068,
    2076,  2086,  2099,  2100,  2105,  2106,  2109,  2117,  2125,  2133,
    2141,  2149,  2159,  2160,  2165,  2166,  2169,  2177,  2185,  2193,
    2201,  2209,  2217,  2227,  2228,  2233,  2234,  2237,  2245,  2253,
    2261,  2269,  2277,  2285,  2293,  2301,  2309,  2317,  2325,  2333,
    2341,  2349,  2357,  2365,  2371,  2377,  2382,  2388,  2394,  2398,
    2404,  2410,  2416,  2424,  2429,  2434,  2442,  2450,  2455,  2460,
    2466,  2467,  2470,  2475,  2478,  2479,  2482,  2487,  2492,  2497,
    2502,  2510,  2530,  2550,  2572,  2573,  2578,  2579,  2582,  2590,
    2598,  2606,  2614,  2622,  2630,  2635,  2640,  2647,  2648,  2653,
    2654,  2657,  2665,  2673,  2681,  2689,  2697,  2705,  2710,  2715,
    2721,  2722,  2727,  2728,  2731,  2739,  2747
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TK_NETWORK_LIST", "TK_DEFAULT_NETNAME",
  "TK_GENSTR", "TK_DEFAULT_INT", "TK_LOGFILE", "TK_LOG_FACILITY",
  "TK_AUTH_PERIOD", "TK_HELD_PERIOD", "TK_MAX_STARTS",
  "TK_STALE_KEY_TIMEOUT", "TK_ALLMULTI", "TK_IPC_GROUP", "TK_DESTINATION",
  "TK_BSSID", "TK_MULTICAST", "TK_SOURCE", "TK_AUTO", "TK_MANUAL",
  "TK_ASSOCIATION", "TK_ASSOC_TIMEOUT", "TK_ROAMING", "TK_FIRMWARE",
  "TK_XSUPPLICANT", "TK_PASSIVE_SCANNING", "TK_PASSIVE_TIMEOUT",
  "TK_SCAN_TIMEOUT", "TK_USE_EAP_HINTS", "TK_ALL", "TK_FRIENDLY_WARNINGS",
  "TK_TYPE", "TK_ALLOW_TYPES", "TK_FORCE_EAPOL_VER", "TK_WIRELESS",
  "TK_WIRED", "TK_CONTROL_WIRELESS", "TK_ASSOCIATION_TYPE",
  "TK_ASSOC_OPEN", "TK_ASSOC_SHARED", "TK_ASSOC_LEAP",
  "TK_WPA_GROUP_CRYPT", "TK_WPA_PAIRWISE_CRYPT", "TK_WEP40", "TK_TKIP",
  "TK_WRAP", "TK_CCMP", "TK_WEP104", "TK_ANY", "TK_PRIORITY",
  "TK_IDENTITY", "TK_IDENTITY_VAL", "TK_DEST_MAC", "TK_MACADDRESS",
  "TK_SSID", "TK_SSID_VAL", "TK_USE_TNC", "TK_WPA_PSK", "TK_WPA_PSK_KEY",
  "TK_WPA_PSK_HEX_KEY", "TK_EAP_TLS", "TK_USER_CERT", "TK_USER_KEY",
  "TK_USER_KEY_PASS", "TK_SESSION_RESUME", "TK_CNCHECK", "TK_CNEXACT",
  "TK_ROOT_CERT", "TK_ROOT_DIR", "TK_CRL_DIR", "TK_CHUNK_SIZE",
  "TK_RANDOM_FILE", "TK_EAP_MD5", "TK_USERNAME", "TK_USERNAME_VAL",
  "TK_PASSWORD", "TK_EAP_LEAP", "TK_EAP_TTLS", "TK_PHASE2_TYPE", "TK_PAP",
  "TK_CHAP", "TK_MSCHAP", "TK_MSCHAPV2", "TK_EAP_MSCHAPV2",
  "TK_MSCHAPV2_HASH_PWD", "TK_IAS_QUIRK", "TK_EAP_PEAP",
  "TK_PEAPV1_PROPER_KEYING", "TK_INNER_ID", "TK_EAP_SIM", "TK_EAP_AKA",
  "TK_AUTO_REALM", "TK_YES", "TK_NO", "TK_EAP_GTC", "TK_EAP_OTP",
  "TK_SMARTCARD", "TK_ENGINE_ID", "TK_OPENSC_SO_PATH", "TK_KEYID",
  "TK_STATIC_WEP", "TK_INITIAL_WEP", "TK_STATIC_KEY1", "TK_STATIC_KEY2",
  "TK_STATIC_KEY3", "TK_STATIC_KEY4", "TK_WEP_TX_KEY", "TK_NUMBER",
  "TK_UNQUOTED_STR", "TK_PASS", "TK_COMMAND", "TK_QUOTED_STR", "'='",
  "','", "'{'", "'}'", "$accept", "configfile", "global_section",
  "network_section", "global_statement", "network_list", "network_entry",
  "network_statements", "network_parameter", "network_priority",
  "network_type_parameter", "network_wpa_group_enc_type",
  "network_wpa_pairwise_enc_type", "network_force_eapol_ver",
  "network_assoc_type", "network_control_wireless",
  "network_identity_parameter", "network_use_tnc",
  "network_dest_mac_parameter", "network_allow_parameter",
  "eap_type_statement", "eap_type_list", "eap_type",
  "static_wep_statement", "static_wep_params", "static_wep_param",
  "initial_wep_statement", "initial_wep_params", "initial_wep_param",
  "eap_tls_statement", "eap_tls_params", "smartcard_section",
  "smartcard_params", "smartcard_param", "eap_tls_param",
  "eap_md5_statement", "eap_md5_params", "eap_md5_param",
  "eap_ttls_statement", "eap_ttls_params", "eap_ttls_param",
  "eap_ttls_phase2_statement", "phase2_pap_statement", "phase2_pap_params",
  "phase2_pap_param", "phase2_chap_statement", "phase2_chap_params",
  "phase2_chap_param", "phase2_mschap_statement", "phase2_mschap_params",
  "phase2_mschap_param", "phase2_mschapv2_statement",
  "phase2_mschapv2_params", "phase2_mschapv2_param",
  "eap_ttls_phase2_eap_statement", "eap_leap_statement", "eap_leap_params",
  "eap_leap_param", "eap_mschapv2_statement", "eap_mschapv2_params",
  "eap_mschapv2_param", "eap_peap_statement", "eap_peap_params",
  "eap_peap_param", "eap_peap_allow_parameter",
  "eap_peap_phase2_type_list", "eap_peap_phase2_type",
  "eap_peap_phase2_statement", "eap_sim_statement", "eap_sim_params",
  "eap_sim_param", "eap_aka_statement", "eap_aka_params", "eap_aka_param",
  "wpa_psk_statement", "wpa_psk_params", "wpa_psk_param", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,    61,    44,   123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   117,   118,   118,   118,   118,   119,   119,   120,   120,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   122,   122,   122,   122,   123,   123,   123,   123,   123,
     123,   124,   124,   124,   124,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   126,   127,   127,   127,
     128,   128,   128,   128,   128,   129,   129,   129,   129,   129,
     130,   131,   131,   131,   132,   132,   132,   133,   133,   133,
     134,   134,   135,   136,   136,   137,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   138,   138,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   140,   140,
     141,   141,   142,   142,   142,   142,   142,   143,   143,   144,
     144,   145,   145,   145,   145,   145,   146,   146,   147,   147,
     148,   149,   149,   150,   150,   150,   150,   150,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   152,   152,
     153,   153,   154,   154,   154,   154,   154,   154,   155,   155,
     156,   156,   157,   157,   157,   157,   157,   157,   157,   157,
     157,   157,   157,   157,   157,   157,   157,   157,   157,   157,
     157,   157,   157,   157,   157,   157,   157,   157,   157,   157,
     158,   158,   158,   158,   158,   159,   160,   160,   161,   161,
     161,   161,   161,   161,   162,   163,   163,   164,   164,   164,
     164,   164,   164,   165,   166,   166,   167,   167,   167,   167,
     167,   167,   168,   169,   169,   170,   170,   170,   170,   170,
     170,   171,   172,   172,   173,   173,   174,   174,   174,   174,
     174,   174,   175,   175,   176,   176,   177,   177,   177,   177,
     177,   177,   177,   178,   178,   179,   179,   180,   180,   180,
     180,   180,   180,   180,   180,   180,   180,   180,   180,   180,
     180,   180,   180,   180,   180,   180,   180,   180,   180,   180,
     180,   180,   180,   180,   180,   180,   180,   180,   180,   180,
     180,   180,   181,   181,   182,   182,   183,   183,   183,   183,
     183,   184,   184,   184,   185,   185,   186,   186,   187,   187,
     187,   187,   187,   187,   187,   187,   187,   188,   188,   189,
     189,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     191,   191,   192,   192,   193,   193,   193
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     1,     1,     1,     2,     1,     2,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     3,     1,     4,     4,     4,     3,     3,
       3,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       2,     1,     3,     3,     3,     3,     3,     4,     3,     2,
       1,     3,     3,     3,     3,     3,     4,     3,     2,     1,
       4,     2,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     4,     3,
       2,     1,     3,     3,     3,     3,     3,     3,     4,     3,
       2,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     4,     2,     1,     3,     3,
       3,     3,     3,     3,     4,     2,     1,     3,     3,     3,
       3,     3,     3,     4,     2,     1,     3,     3,     3,     3,
       3,     3,     4,     2,     1,     3,     3,     3,     3,     3,
       3,     1,     4,     3,     2,     1,     3,     3,     3,     3,
       3,     3,     4,     3,     2,     1,     3,     3,     3,     3,
       3,     3,     3,     4,     3,     2,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     1,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     2,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     3,     2,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     3,     2,     1,     3,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     5,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     3,     4,     7,     9,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     1,     2,     6,     8,    10,    52,    54,
      11,    12,    13,    30,    28,    29,    50,    38,    39,    40,
      31,    32,    41,    42,    43,    44,    46,    47,    48,    45,
      49,    33,    34,    35,    36,    37,    17,    18,    19,    20,
      21,    22,    26,    27,    23,    24,    25,    14,    15,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    60,     0,    63,    66,    65,    68,    69,    70,
      74,    75,    71,    67,    72,    73,    64,   108,   109,   105,
     106,   107,   110,   111,   112,   113,   114,   115,    58,     0,
      59,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    56,    61,    62,    55,    57,
      51,    53,    77,    78,    79,   103,   118,   119,   121,   120,
     122,   123,   124,   125,   126,   127,   104,   117,    90,    94,
      95,    96,    91,    92,    93,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    76,    97,    99,    98,   102,
     100,   101,     0,     0,   361,     0,   363,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   147,     0,   177,
     149,     0,     0,   179,     0,   181,     0,     0,   263,     0,
     265,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   189,   261,     0,
     191,   219,   220,   221,   222,   223,   224,     0,     0,     0,
     273,     0,   275,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   284,
     332,   331,     0,   286,   320,   321,   333,     0,     0,     0,
     335,     0,   337,     0,     0,     0,   348,     0,   350,     0,
       0,     0,     0,     0,   129,     0,   131,     0,     0,     0,
       0,     0,   138,     0,   140,     0,     0,     0,   360,   362,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   148,     0,     0,   178,   180,     0,     0,   262,   264,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,   190,     0,     0,
       0,   272,   274,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   283,
     285,     0,     0,     0,   334,   336,     0,     0,     0,   347,
     349,     0,     0,     0,     0,     0,   128,   130,     0,     0,
       0,     0,     0,   137,   139,   116,   364,   365,   366,   158,
     159,   160,   161,   164,   162,   163,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,     0,     0,
       0,     0,   152,   182,   183,   184,   186,   185,   187,   266,
     267,   268,   270,   269,   271,   192,   193,   194,   195,   197,
     196,   198,   208,   209,   210,   211,   212,   213,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   218,   214,   215,
     216,   217,     0,     0,     0,   227,     0,     0,     0,   236,
       0,     0,     0,   245,     0,     0,     0,   254,   276,   277,
     278,   280,   279,   281,   282,   322,   327,   326,   328,   330,
     329,   323,   325,   287,   288,   289,   290,   291,   292,   293,
     295,   294,   296,   303,   304,   305,   312,   313,   314,   297,
     298,   299,   300,   301,   302,   311,   315,   316,   317,   318,
     319,   306,   307,   308,   309,   310,   338,   339,   340,   342,
     341,   343,   344,   345,   346,   351,   352,   353,   355,   354,
     356,   357,   358,   359,   132,   133,   134,   135,   136,   141,
     142,   143,   144,   145,     0,     0,     0,   150,   151,     0,
       0,   225,   226,     0,     0,   234,   235,     0,     0,   243,
     244,     0,     0,   252,   253,     0,   153,   154,   155,   157,
     156,   228,   229,   230,   232,   231,   233,   237,   238,   239,
     241,   240,   242,   246,   247,   248,   250,   249,   251,   255,
     256,   257,   259,   258,   260,   324
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    25,    26,    27,    28,    60,    29,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   196,   197,   137,   325,   326,   138,   333,   334,   139,
     238,   239,   451,   452,   240,   140,   244,   245,   141,   269,
     270,   271,   272,   494,   495,   273,   498,   499,   274,   502,
     503,   275,   506,   507,   276,   142,   249,   250,   143,   281,
     282,   144,   302,   303,   304,   521,   522,   305,   145,   311,
     312,   146,   317,   318,   147,   225,   226
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -170
static const yytype_int16 yypact[] =
{
       3,  -170,   -94,   -80,   -76,   -49,   -45,   -36,    25,    45,
      52,    62,    79,    92,   121,   149,   153,   169,   203,   210,
     214,   218,   -29,   -15,    -6,   116,    32,    12,  -170,  -170,
     -22,   -27,   110,    75,   178,    46,    80,   193,    40,   -37,
     233,     4,     8,   141,    27,   -13,   240,   253,    -5,    59,
      41,   113,   174,  -170,    12,  -170,  -170,  -170,  -170,  -170,
     268,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
     271,   275,   300,   316,   330,   344,   378,   400,   404,   411,
     413,   429,   431,   455,   457,   463,   496,   511,   513,   514,
     572,   574,  -170,   235,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,   296,
    -170,   357,    84,    13,   355,   475,   209,   331,   408,   452,
     508,   -47,   467,   216,     7,   517,   105,   144,   468,    21,
     398,    85,    86,   320,   373,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,   526,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,   535,   539,  -170,    10,  -170,   543,   575,   577,
     578,   579,   580,   581,   582,   583,   584,  -170,   528,  -170,
    -170,   585,   587,  -170,   164,  -170,   588,   589,  -170,   167,
    -170,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,  -170,  -170,   494,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,   608,   609,   610,
    -170,   154,  -170,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,  -170,
    -170,  -170,   439,  -170,  -170,  -170,  -170,   627,   628,   629,
    -170,    93,  -170,   630,   631,   632,  -170,   106,  -170,   633,
     634,   635,   636,   637,  -170,   499,  -170,   638,   639,   640,
     641,   642,  -170,   516,  -170,   540,   101,   606,  -170,  -170,
     114,   182,   136,   211,   202,   246,   269,   576,   284,   454,
    -170,  -170,    -4,   328,  -170,  -170,    18,   406,  -170,  -170,
     500,   525,   410,   266,   607,   381,   551,   553,   555,   648,
     557,   412,   180,   335,   346,   407,  -170,  -170,    64,   433,
     649,  -170,  -170,    99,    -2,   559,   561,   459,   270,   650,
     501,   563,   565,   567,   652,   569,   283,   308,   571,  -170,
    -170,   124,   529,   310,  -170,  -170,   162,   533,   312,  -170,
    -170,   645,   651,   653,   654,   656,  -170,  -170,   655,   657,
     658,   659,   660,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,   661,   662,
     663,   570,   454,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,   664,   665,   168,  -170,   666,   667,   179,  -170,
     668,   669,   183,  -170,   670,   671,   205,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,   647,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,   676,   573,   257,  -170,  -170,   188,
     537,  -170,  -170,   223,   541,  -170,  -170,   231,   545,  -170,
    -170,   232,   549,  -170,  -170,   272,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -170,  -170,  -170,   736,   746,  -170,    49,   556,   166,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
     201,  -170,   362,  -170,  -170,   448,  -170,  -170,   453,  -170,
    -170,  -170,   336,  -170,   552,  -168,  -170,   547,  -170,  -170,
     518,  -170,  -170,  -170,   295,  -170,  -170,   294,  -170,  -170,
     291,  -170,  -170,   288,  -170,  -170,  -170,   546,  -169,  -170,
     515,  -170,  -170,   495,  -170,  -170,   194,  -170,  -167,  -170,
     487,  -170,  -170,   483,  -170,  -170,   586
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
     268,   301,   300,   306,     1,   216,     2,     3,    57,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    30,
      76,    77,    78,    79,    14,    15,    16,    81,    82,    17,
      18,    19,    20,    31,    21,     2,     3,    32,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,   182,   183,
     523,    86,    87,    14,    15,    16,    72,    73,    17,    18,
      19,    20,   217,    21,    33,   218,   222,   223,    34,   222,
     223,   453,    74,   100,   101,   102,    56,    35,   103,   104,
      89,    90,    61,   105,   106,    62,    50,    58,    94,    95,
      59,   107,   108,   459,   109,   277,    91,   278,   110,   111,
      51,   268,   112,    56,    96,   454,   279,   524,   455,    52,
     525,    22,    23,    80,   113,    24,    53,    83,   114,   115,
      22,    23,   184,   224,    24,   116,   338,   460,   117,   515,
     461,   118,   119,   301,   300,   306,    88,   280,    36,   508,
      22,    23,   120,   121,    24,   100,   101,   102,    70,    71,
     103,   104,    97,    98,    67,   105,   106,   122,    37,   307,
     313,   308,   314,   107,   108,    38,   109,   307,    99,   308,
     110,   111,   516,   509,   112,    39,   510,   309,   315,   241,
     313,   242,   314,   517,    64,   309,   113,    65,    68,   518,
     114,   115,    40,   180,   519,   520,   181,   116,   315,   556,
     117,   310,   316,   118,   119,    41,   100,   101,   102,   404,
     426,   103,   104,   427,   120,   121,   105,   106,   246,    63,
     247,   243,   409,   429,   107,   108,   430,   109,   277,   148,
     278,   110,   111,   557,    42,   112,   558,   565,   241,   279,
     242,   246,   492,   247,   493,   433,   434,   113,   435,    84,
      85,   114,   115,   496,   492,   497,   493,   500,   116,   501,
     248,   117,    43,   611,   118,   119,    44,   100,   101,   102,
     381,   566,   103,   104,   567,   120,   121,   105,   106,   504,
     354,   505,    45,   358,   591,   107,   108,    66,   109,   176,
     150,   431,   110,   111,   432,   595,   112,   612,   617,   599,
     613,    69,   199,   200,   436,   437,   623,   629,   113,   220,
     221,   439,   114,   115,   440,   176,    46,   176,   201,   116,
     438,   603,   117,    47,   177,   118,   119,    48,   100,   101,
     102,    49,   618,   103,   104,   619,   120,   121,   105,   106,
     624,   630,    75,   625,   631,   516,   107,   108,    92,   109,
     177,   175,   177,   110,   111,   441,   517,   112,   442,   472,
     473,    93,   518,   533,   534,   609,   610,   519,   520,   113,
     202,   203,   204,   114,   115,   474,   548,   549,   443,   535,
     116,   444,   152,   117,   153,   185,   118,   119,   154,   100,
     101,   102,   550,   446,   103,   104,   447,   120,   121,   105,
     106,   551,   552,   562,   563,   571,   572,   107,   108,   496,
     109,   497,   178,   155,   110,   111,   186,   553,   112,   564,
     500,   573,   501,   319,   320,   321,   322,   323,   187,   156,
     113,   283,   188,   189,   114,   115,   324,   456,   457,   190,
     458,   116,   191,   157,   117,   192,   193,   118,   119,   284,
     194,   195,   205,   206,   207,   208,   209,   158,   120,   121,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   113,   283,   179,   476,   477,   327,   328,   329,   330,
     331,   504,   116,   505,   296,   487,   297,   298,   118,   332,
     284,   159,   488,   489,   490,   491,   210,   211,   212,   213,
     214,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   113,   160,   299,   462,   463,   161,   464,   469,
     470,   219,   471,   116,   162,   296,   163,   297,   298,   118,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   113,   511,   512,   164,   513,   165,   262,   263,   264,
     265,   266,   448,   449,   450,   399,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   113,   530,   531,
     166,   532,   167,   262,   263,   264,   265,   266,   168,   227,
     228,   229,   230,   198,   267,   231,   232,   233,   234,   235,
     227,   228,   229,   230,   537,   538,   231,   232,   233,   234,
     235,   186,   319,   320,   321,   322,   323,   149,   151,   465,
     376,   169,   466,   187,   236,   416,   215,   188,   189,   327,
     328,   329,   330,   331,   190,   236,   170,   191,   171,   172,
     192,   193,   423,   237,   467,   194,   195,   468,   559,   560,
     335,   561,   568,   569,   350,   570,   614,   615,   336,   616,
     620,   621,   337,   622,   626,   627,   340,   628,   632,   633,
     478,   634,   480,   479,   482,   481,   485,   483,   526,   486,
     528,   527,   539,   529,   541,   540,   543,   542,   546,   544,
     554,   547,   607,   555,   445,   608,   587,   173,   341,   174,
     342,   343,   344,   345,   346,   347,   348,   425,   352,   349,
     353,   356,   357,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   428,   475,   372,   373,   374,
     375,   378,   379,   380,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     401,   402,   403,   406,   407,   408,   411,   412,   413,   414,
     415,   418,   419,   420,   421,   422,   484,   574,   514,   536,
     545,   605,    54,   575,   578,   576,   577,   579,   583,   580,
     581,   582,    55,   417,   584,   585,   586,   589,   590,   593,
     594,   597,   598,   601,   602,   606,   424,   377,   588,   592,
     351,   355,   596,   600,   604,   359,   382,   400,   405,   635,
     410,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   339
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-170))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
     168,   170,   170,   170,     1,    52,     3,     4,    30,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,   113,
      16,    17,    18,    19,    21,    22,    23,    19,    20,    26,
      27,    28,    29,   113,    31,     3,     4,   113,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    35,    36,
      52,    24,    25,    21,    22,    23,    93,    94,    26,    27,
      28,    29,   109,    31,   113,   112,    59,    60,   113,    59,
      60,    75,   109,    32,    33,    34,    27,   113,    37,    38,
      93,    94,   109,    42,    43,   112,   115,   109,    93,    94,
     112,    50,    51,    75,    53,    74,   109,    76,    57,    58,
     115,   269,    61,    54,   109,   109,    85,   109,   112,   115,
     112,   108,   109,   109,    73,   112,     0,   109,    77,    78,
     108,   109,   109,   116,   112,    84,   116,   109,    87,    30,
     112,    90,    91,   302,   302,   302,   109,   116,   113,    75,
     108,   109,   101,   102,   112,    32,    33,    34,   108,   109,
      37,    38,    93,    94,   108,    42,    43,   116,   113,    74,
      74,    76,    76,    50,    51,   113,    53,    74,   109,    76,
      57,    58,    73,   109,    61,   113,   112,    92,    92,    74,
      74,    76,    76,    84,   109,    92,    73,   112,   108,    90,
      77,    78,   113,   109,    95,    96,   112,    84,    92,    75,
      87,   116,   116,    90,    91,   113,    32,    33,    34,   116,
     109,    37,    38,   112,   101,   102,    42,    43,    74,   109,
      76,   116,   116,   109,    50,    51,   112,    53,    74,   116,
      76,    57,    58,   109,   113,    61,   112,    75,    74,    85,
      76,    74,    74,    76,    76,   109,   110,    73,   112,   108,
     109,    77,    78,    74,    74,    76,    76,    74,    84,    76,
     116,    87,   113,    75,    90,    91,   113,    32,    33,    34,
     116,   109,    37,    38,   112,   101,   102,    42,    43,    74,
     116,    76,   113,   116,   116,    50,    51,   109,    53,   123,
     116,   109,    57,    58,   112,   116,    61,   109,    75,   116,
     112,   108,    93,    94,    93,    94,    75,    75,    73,    93,
      94,   109,    77,    78,   112,   149,   113,   151,   109,    84,
     109,   116,    87,   113,   123,    90,    91,   113,    32,    33,
      34,   113,   109,    37,    38,   112,   101,   102,    42,    43,
     109,   109,   109,   112,   112,    73,    50,    51,   108,    53,
     149,   116,   151,    57,    58,   109,    84,    61,   112,    93,
      94,   108,    90,    93,    94,   108,   109,    95,    96,    73,
      39,    40,    41,    77,    78,   109,    93,    94,   109,   109,
      84,   112,   114,    87,   113,    30,    90,    91,   113,    32,
      33,    34,   109,   109,    37,    38,   112,   101,   102,    42,
      43,    93,    94,    93,    94,    93,    94,    50,    51,    74,
      53,    76,   116,   113,    57,    58,    61,   109,    61,   109,
      74,   109,    76,   103,   104,   105,   106,   107,    73,   113,
      73,    33,    77,    78,    77,    78,   116,   109,   110,    84,
     112,    84,    87,   113,    87,    90,    91,    90,    91,    51,
      95,    96,    44,    45,    46,    47,    48,   113,   101,   102,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    33,   116,    93,    94,   103,   104,   105,   106,
     107,    74,    84,    76,    86,    73,    88,    89,    90,   116,
      51,   113,    80,    81,    82,    83,    44,    45,    46,    47,
      48,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,   113,   116,   109,   110,   113,   112,   109,
     110,    54,   112,    84,   113,    86,   113,    88,    89,    90,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,   109,   110,   115,   112,   115,    79,    80,    81,
      82,    83,    98,    99,   100,   116,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,   109,   110,
     115,   112,   115,    79,    80,    81,    82,    83,   115,    62,
      63,    64,    65,   108,   116,    68,    69,    70,    71,    72,
      62,    63,    64,    65,    93,    94,    68,    69,    70,    71,
      72,    61,   103,   104,   105,   106,   107,    51,    52,   109,
     116,   115,   112,    73,    97,   116,   108,    77,    78,   103,
     104,   105,   106,   107,    84,    97,   115,    87,   115,   115,
      90,    91,   116,   116,   109,    95,    96,   112,   109,   110,
     114,   112,   109,   110,   116,   112,   109,   110,   113,   112,
     109,   110,   113,   112,   109,   110,   113,   112,   109,   110,
     109,   112,   109,   112,   109,   112,   109,   112,   109,   112,
     109,   112,   109,   112,   109,   112,   109,   112,   109,   112,
     109,   112,   109,   112,   108,   112,   116,   115,   113,   115,
     113,   113,   113,   113,   113,   113,   113,   335,   113,   115,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   109,   109,   115,   115,   115,
     115,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   113,   108,   112,   109,   109,
     108,   114,    26,   112,   108,   112,   112,   112,   108,   112,
     112,   112,    26,   325,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   109,   333,   269,   452,   494,
     238,   244,   498,   502,   506,   249,   281,   302,   311,   605,
     317,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   225
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     4,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    21,    22,    23,    26,    27,    28,
      29,    31,   108,   109,   112,   118,   119,   120,   121,   123,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     115,   115,   115,     0,   120,   121,   123,    30,   109,   112,
     122,   109,   112,   109,   109,   112,   109,   108,   108,   108,
     108,   109,    93,    94,   109,   109,    16,    17,    18,    19,
     109,    19,    20,   109,   108,   109,    24,    25,   109,    93,
      94,   109,   108,   108,    93,    94,   109,    93,    94,   109,
      32,    33,    34,    37,    38,    42,    43,    50,    51,    53,
      57,    58,    61,    73,    77,    78,    84,    87,    90,    91,
     101,   102,   116,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   140,   143,   146,
     152,   155,   172,   175,   178,   185,   188,   191,   116,   124,
     116,   124,   114,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   116,   125,   137,   116,   116,
     109,   112,    35,    36,   109,    30,    61,    73,    77,    78,
      84,    87,    90,    91,    95,    96,   138,   139,   108,    93,
      94,   109,    39,    40,    41,    44,    45,    46,    47,    48,
      44,    45,    46,    47,    48,   108,    52,   109,   112,    54,
      93,    94,    59,    60,   116,   192,   193,    62,    63,    64,
      65,    68,    69,    70,    71,    72,    97,   116,   147,   148,
     151,    74,    76,   116,   153,   154,    74,    76,   116,   173,
     174,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    79,    80,    81,    82,    83,   116,   152,   156,
     157,   158,   159,   162,   165,   168,   171,    74,    76,    85,
     116,   176,   177,    33,    51,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    86,    88,    89,   116,
     152,   175,   179,   180,   181,   184,   185,    74,    76,    92,
     116,   186,   187,    74,    76,    92,   116,   189,   190,   103,
     104,   105,   106,   107,   116,   141,   142,   103,   104,   105,
     106,   107,   116,   144,   145,   114,   113,   113,   116,   193,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   115,
     116,   151,   113,   113,   116,   154,   113,   113,   116,   174,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   115,   115,   115,   115,   116,   157,   113,   113,
     113,   116,   177,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   116,
     180,   113,   113,   113,   116,   187,   113,   113,   113,   116,
     190,   113,   113,   113,   113,   113,   116,   142,   113,   113,
     113,   113,   113,   116,   145,   139,   109,   112,   109,   109,
     112,   109,   112,   109,   110,   112,    93,    94,   109,   109,
     112,   109,   112,   109,   112,   108,   109,   112,    98,    99,
     100,   149,   150,    75,   109,   112,   109,   110,   112,    75,
     109,   112,   109,   110,   112,   109,   112,   109,   112,   109,
     110,   112,    93,    94,   109,   109,    93,    94,   109,   112,
     109,   112,   109,   112,   108,   109,   112,    73,    80,    81,
      82,    83,    74,    76,   160,   161,    74,    76,   163,   164,
      74,    76,   166,   167,    74,    76,   169,   170,    75,   109,
     112,   109,   110,   112,   109,    30,    73,    84,    90,    95,
      96,   182,   183,    52,   109,   112,   109,   112,   109,   112,
     109,   110,   112,    93,    94,   109,   109,    93,    94,   109,
     112,   109,   112,   109,   112,   108,   109,   112,    93,    94,
     109,    93,    94,   109,   109,   112,    75,   109,   112,   109,
     110,   112,    93,    94,   109,    75,   109,   112,   109,   110,
     112,    93,    94,   109,   112,   112,   112,   112,   108,   112,
     112,   112,   112,   108,   113,   113,   113,   116,   149,   113,
     113,   116,   161,   113,   113,   116,   164,   113,   113,   116,
     167,   113,   113,   116,   170,   114,   109,   109,   112,   108,
     109,    75,   109,   112,   109,   110,   112,    75,   109,   112,
     109,   110,   112,    75,   109,   112,   109,   110,   112,    75,
     109,   112,   109,   110,   112,   183
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 392 "config_grammar.y"
    {
                     config_info = tmp_config;
                     tmp_config = NULL;
                  }
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 396 "config_grammar.y"
    { 
                      printf("Error: No networks defined.\n"); 
		      CLEAN_EXIT;
		    }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 400 "config_grammar.y"
    {
		      printf("Error: No globals defined.\n"); 
		      cleanup_parse();
		      return XECONFIGPARSEFAIL;
                    }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 405 "config_grammar.y"
    {
		    printf("General Parse error!\n");
 		      cleanup_parse();
		      return XECONFIGPARSEFAIL; }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 419 "config_grammar.y"
    {
                      set_current_globals();
                      parameter_debug("network_list: all\n");
		      // do nothing. leave null
                    }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 424 "config_grammar.y"
    {
		    // done below. nothing to do here
  		    }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 427 "config_grammar.y"
    {
 		     set_current_globals();
		     parameter_debug("Default network: \"%s\"\n", (yyvsp[(3) - (3)].str));
		     if (tmp_config->globals->default_net)
		       free((yyvsp[(3) - (3)].str));
		     else
		       tmp_config->globals->default_net = (yyvsp[(3) - (3)].str);
		  }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 435 "config_grammar.y"
    {
 		     set_current_globals();
		     parameter_debug("Default network: \"%s\"\n", (yyvsp[(3) - (3)].str));
		     if (tmp_config->globals->default_net)
		       free((yyvsp[(3) - (3)].str));
		     else
		       tmp_config->globals->default_net = (yyvsp[(3) - (3)].str);
		  }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 443 "config_grammar.y"
    {
		    set_current_globals();
		    parameter_debug("Friendly Warnings: YES\n");
		    UNSET_FLAG(tmp_config->globals->flags, 
			     CONFIG_GLOBALS_NO_FRIENDLY_WARNINGS);
                    }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 449 "config_grammar.y"
    {
		    set_current_globals();
		    parameter_debug("Friendly Warnings: NO\n");
		    SET_FLAG(tmp_config->globals->flags,
			     CONFIG_GLOBALS_NO_FRIENDLY_WARNINGS);
                    }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 455 "config_grammar.y"
    {
		    set_current_globals();
		    printf("Invalid vale for \"friendly_warnings\" option! "
			   "defaulting to YES.\n");
		    parameter_debug("Friendly Warnings: Defaulting to YES"
				    " (Invalid value \"%s\")\n", (yyvsp[(3) - (3)].str));
                    UNSET_FLAG(tmp_config->globals->flags,
		             CONFIG_GLOBALS_NO_FRIENDLY_WARNINGS);
                    }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 464 "config_grammar.y"
    {
                    set_current_globals();
                    parameter_debug("Firmware roaming.\n");
                    SET_FLAG(tmp_config->globals->flags, 
			     CONFIG_GLOBALS_FIRMWARE_ROAM);
                    }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 470 "config_grammar.y"
    {
                    set_current_globals();      
                    parameter_debug("Xsupplicant roaming.\n");
                    UNSET_FLAG(tmp_config->globals->flags, 
			       CONFIG_GLOBALS_FIRMWARE_ROAM);
                    }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 476 "config_grammar.y"
    {
                    set_current_globals();
                    parameter_debug("Xsupplicant roaming.\n");
                    printf("Invalid setting for 'roaming' value.  "
                    	       "Defaulting to Xsupplicant based roaming.\n");
                    UNSET_FLAG(tmp_config->globals->flags, 
			       CONFIG_GLOBALS_FIRMWARE_ROAM);
                    }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 484 "config_grammar.y"
    {
                    set_current_globals();
                    parameter_debug("Passive Scanning : Yes\n");
                    SET_FLAG(tmp_config->globals->flags,
                             CONFIG_GLOBALS_PASSIVE_SCAN);
                    }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 490 "config_grammar.y"
    {
                    set_current_globals();
                    parameter_debug("Passive Scanning : No\n");
                    UNSET_FLAG(tmp_config->globals->flags,
	                       CONFIG_GLOBALS_PASSIVE_SCAN);
                    }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 496 "config_grammar.y"
    {
                    set_current_globals();
                    parameter_debug("Passive Scanning : Yes\n");
                    printf("Invalid setting for 'passive_scanning'."
	                         " Defaulting to yes.\n");
		    SET_FLAG(tmp_config->globals->flags,
			     CONFIG_GLOBALS_PASSIVE_SCAN);
                    }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 504 "config_grammar.y"
    {
                    set_current_globals();
                    parameter_debug("Use EAP Hints : Yes\n");
                    UNSET_FLAG(tmp_config->globals->flags,
			       CONFIG_GLOBALS_NO_EAP_HINTS);
                    }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 510 "config_grammar.y"
    {
                    set_current_globals();
                    parameter_debug("Use EAP Hints : No\n");
                    SET_FLAG(tmp_config->globals->flags,
			     CONFIG_GLOBALS_NO_EAP_HINTS);
                    }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 516 "config_grammar.y"
    {
                    set_current_globals();
                    parameter_debug("Use EAP Hints : Yes\n");
                    printf("Invalid setting for 'use_eap_hints'."
	                         " Defaulting to yes.\n");
		    UNSET_FLAG(tmp_config->globals->flags,
			       CONFIG_GLOBALS_NO_EAP_HINTS);
                    }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 524 "config_grammar.y"
    {
                    set_current_globals();
                    parameter_debug("Passive Scan Timer: %d\n", (yyvsp[(3) - (3)].num));
                    tmp_config->globals->passive_timeout = (yyvsp[(3) - (3)].num);
                    }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 529 "config_grammar.y"
    {
		    set_current_globals();
		    parameter_debug("Scan timeout: %d\n", (yyvsp[(3) - (3)].num));
		    tmp_config->globals->active_timeout = (yyvsp[(3) - (3)].num);
		  }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 534 "config_grammar.y"
    {
		     set_current_globals();
		     parameter_debug("Logfile: \"%s\"\n", (yyvsp[(3) - (3)].str));
		     if (tmp_config->globals->logfile)
		       {
			 free((yyvsp[(3) - (3)].str));
			 tmp_config->globals->logfile = NULL;
		       }
		     else
		       tmp_config->globals->logfile = (yyvsp[(3) - (3)].str);
		    }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 545 "config_grammar.y"
    {
		    set_current_globals();
		    parameter_debug("Logfile: \"%s\"\n", (yyvsp[(3) - (3)].str));
		    if (tmp_config->globals->logfile)
		      {
			free((yyvsp[(3) - (3)].str));
			tmp_config->globals->logfile = NULL;
		      }
		    else
		      tmp_config->globals->logfile = (yyvsp[(3) - (3)].str);
		  }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 556 "config_grammar.y"
    {
		    set_current_globals();
                    parameter_debug("Default Interface: \"%s\"\n", (yyvsp[(3) - (3)].str));
		    if (tmp_config->globals->default_int)
		      {
			free((yyvsp[(3) - (3)].str));
			tmp_config->globals->default_int = NULL;
		      }
		    else
		      tmp_config->globals->default_int = (yyvsp[(3) - (3)].str);
		    }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 567 "config_grammar.y"
    {
		    set_current_globals();
		    tmp_config->globals->stale_key_timeout = (yyvsp[(3) - (3)].num);
		    }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 571 "config_grammar.y"
    {
		    set_current_globals();
		    printf("Invalid value for stale key "
				 "timer.  Leaving at the default of 10 minutes"
				 "!\n");
		    }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 577 "config_grammar.y"
    {
                    set_current_globals();
                    SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_ASSOC_AUTO);
                  }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 581 "config_grammar.y"
    {
                    set_current_globals();
                    UNSET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_ASSOC_AUTO);
                  }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 585 "config_grammar.y"
    {
                    set_current_globals();
                    printf("Invalid setting for 'association'! "
	                         "Leaving at default setting.\n");
                    UNSET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_ASSOC_AUTO);
                  }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 591 "config_grammar.y"
    {
                    set_current_globals();
                    tmp_config->globals->assoc_timeout = (yyvsp[(3) - (3)].num);
                  }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 595 "config_grammar.y"
    {
                    set_current_globals();
                    printf("Invalid setting for association_timeout."
	                         " We will use the default setting.\n");
                  }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 600 "config_grammar.y"
    {
		     set_current_globals();
		     if (!TEST_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_AUTH_PER)) {
		       SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_AUTH_PER);
		       tmp_config->globals->auth_period = (yyvsp[(3) - (3)].num);
		     }
                    }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 607 "config_grammar.y"
    {
		     set_current_globals();
		     if (!TEST_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_HELD_PER)) {
		       SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_HELD_PER);
		       tmp_config->globals->held_period = (yyvsp[(3) - (3)].num);
		     }
                    }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 614 "config_grammar.y"
    {
		     set_current_globals();
		     if (!TEST_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_MAX_STARTS)) {
		       SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_MAX_STARTS);
		       tmp_config->globals->max_starts = (yyvsp[(3) - (3)].num);
		     }
                    }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 621 "config_grammar.y"
    {
		     set_current_globals();
		     SET_FLAG(tmp_config->globals->flags,
			      CONFIG_GLOBALS_ALLMULTI);
                    }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 626 "config_grammar.y"
    {
		     set_current_globals();
		     UNSET_FLAG(tmp_config->globals->flags,
				CONFIG_GLOBALS_ALLMULTI);
                    }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 631 "config_grammar.y"
    {
                     printf("Unknown value for ALLMULTI = \"%s\"! Defaulting to YES! (Line : %d)\n", (yyvsp[(3) - (3)].str), config_linenum);
		     set_current_globals();
		     SET_FLAG(tmp_config->globals->flags,
			      CONFIG_GLOBALS_ALLMULTI);
                    }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 637 "config_grammar.y"
    {
		    set_current_globals();
		    if (!tmp_config->globals->ipc_group_name)
			  tmp_config->globals->ipc_group_name = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
                      }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 644 "config_grammar.y"
    {
		    set_current_globals();
		    tmp_config->globals->destination = DEST_AUTO;
                      }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 648 "config_grammar.y"
    {
		    set_current_globals();
		    tmp_config->globals->destination = DEST_BSSID;
                      }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 652 "config_grammar.y"
    {
		    set_current_globals();
		    tmp_config->globals->destination = DEST_MULTICAST;
                      }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 656 "config_grammar.y"
    {
		    set_current_globals();
		    tmp_config->globals->destination = DEST_SOURCE;
                      }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 660 "config_grammar.y"
    {
		    printf("Invalid destination value = \"%s\"!  Defaulting to AUTO! (Line : %d)\n", (yyvsp[(3) - (3)].str), config_linenum);
                    set_current_globals();
                    tmp_config->globals->destination = DEST_AUTO;
                      }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 665 "config_grammar.y"
    {
                    set_current_globals();
                    if (!tmp_config->globals->log_facility)
                          tmp_config->globals->log_facility = (yyvsp[(3) - (3)].str);
                    else
                      free((yyvsp[(3) - (3)].str));
                    }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 674 "config_grammar.y"
    {
                       parameter_debug("network_list: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    (yyvsp[(3) - (3)].str)))
			 free((yyvsp[(3) - (3)].str));
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     (yyvsp[(3) - (3)].str));
                    }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 684 "config_grammar.y"
    { 
                       parameter_debug("network_list: \"%s\"\n", (yyvsp[(1) - (1)].str));
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    (yyvsp[(1) - (1)].str)))
			 free((yyvsp[(1) - (1)].str));
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     (yyvsp[(1) - (1)].str));
                    }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 694 "config_grammar.y"
    {
                       parameter_debug("network_list: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    (yyvsp[(3) - (3)].str)))
			 free((yyvsp[(3) - (3)].str));
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     (yyvsp[(3) - (3)].str));
                    }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 704 "config_grammar.y"
    { 
                       parameter_debug("network_list: \"%s\"\n", (yyvsp[(1) - (1)].str));
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    (yyvsp[(1) - (1)].str)))
			 free((yyvsp[(1) - (1)].str));
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     (yyvsp[(1) - (1)].str));
                    }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 716 "config_grammar.y"
    {
                      set_current_config();
		      tmp_network->name = (yyvsp[(1) - (4)].str);

		      // check if there is a networks field and that 
		      // the current tmp is not already listed
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      // if we don't need it, delete it
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
                    }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 736 "config_grammar.y"
    {
                      set_current_config();

		      tmp_network->name = (char *)malloc(100);
		      sprintf(tmp_network->name, "%d", (yyvsp[(1) - (4)].num));

		      // check if there is a networks field and that 
		      // the current tmp is not already listed
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      // if we don't need it, delete it
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
                    }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 758 "config_grammar.y"
    {
		    set_current_config();
		    tmp_network->name = (yyvsp[(1) - (4)].str);

		      // check if there is a networks field and that 
		      // the current tmp is not already listed
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      // if we don't need it, delete it
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
		    }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 778 "config_grammar.y"
    {
		    set_current_config();
		      set_current_network();

		      tmp_network->name = (yyvsp[(1) - (3)].str);
		      // check if there is a networks field and that 
		      // the current tmp is not already listed
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      // if we don't need it, delete it
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
                    }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 799 "config_grammar.y"
    {
                      set_current_config();
		      set_current_network();

		      tmp_network->name = (yyvsp[(1) - (3)].str);
		      // check if there is a networks field and that 
		      // the current tmp is not already listed
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      // if we don't need it, delete it
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
		    }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 820 "config_grammar.y"
    {
                      set_current_config();
		      set_current_network();

		      tmp_network->name = (char *)malloc(100);
		      sprintf(tmp_network->name, "%d", (yyvsp[(1) - (3)].num));
		      // check if there is a networks field and that 
		      // the current tmp is not already listed
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      // if we don't need it, delete it
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
		    }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 864 "config_grammar.y"
    {
                           parameter_debug("Priority : %d\n", (yyvsp[(3) - (3)].num));
                           set_current_network();
                           tmp_network->priority = (yyvsp[(3) - (3)].num);
                         }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 871 "config_grammar.y"
    {
                           parameter_debug("Type: Wireless\n");
			   set_current_network();
			   if (tmp_network->type == UNSET)
			     tmp_network->type = WIRELESS;
                         }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 877 "config_grammar.y"
    {
                           parameter_debug("Type: Wired\n");
			   set_current_network();
			   if (tmp_network->type == UNSET)
			     tmp_network->type = WIRED;
                         }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 883 "config_grammar.y"
    {
			   set_current_network();
			   tmp_network->type = UNSET;
			   printf("Unknown interface type = \"%s\"!  Defaulting to UNSET! (Line : %d)\n", (yyvsp[(3) - (3)].str), config_linenum);
			 }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 890 "config_grammar.y"
    {
                              parameter_debug("WPA Group Crypt : WEP40\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_WEP40;
			      }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 895 "config_grammar.y"
    {
			      parameter_debug("WPA Group Crypt : TKIP\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_TKIP;
			      }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 900 "config_grammar.y"
    {
			      parameter_debug("WPA Group Crypt : WRAP\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_WRAP;
			      }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 905 "config_grammar.y"
    {
			      parameter_debug("WPA Group Crypt : CCMP\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_CCMP;
			      }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 910 "config_grammar.y"
    {
			      parameter_debug("WPA Group Crypt : WEP104\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_WEP104;
			      }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 917 "config_grammar.y"
    {
                                 parameter_debug("WPA Pairwise Crypt : WEP40\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_WEP40;
                                 }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 922 "config_grammar.y"
    {
				 parameter_debug("WPA Pairwise Crypt : TKIP\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_TKIP;
			         }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 927 "config_grammar.y"
    {
				 parameter_debug("WPA Pairwise Crypt : WRAP\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_WRAP;
	      		         }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 932 "config_grammar.y"
    {
				 parameter_debug("WPA Pairwise Crypt : CCMP\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_CCMP;
			         }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 937 "config_grammar.y"
    {
				 parameter_debug("WPA Pairwise Crypt : WEP104\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_WEP104;
			         }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 944 "config_grammar.y"
    {
                           parameter_debug("Force EAPOL Version : %d\n", (yyvsp[(3) - (3)].num));
                           set_current_network();
                           tmp_network->force_eapol_ver = (yyvsp[(3) - (3)].num);
                         }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 951 "config_grammar.y"
    {
                           parameter_debug("Association Type : Open\n");
			   set_current_network();
			   tmp_network->assoc_type = ASSOC_OPEN;
                        }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 956 "config_grammar.y"
    {
			   parameter_debug("Association Type : Shared\n");
			   set_current_network();
			   tmp_network->assoc_type = ASSOC_SHARED;
			 }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 961 "config_grammar.y"
    {
			  parameter_debug("Association Type : LEAP\n");
			  set_current_network();
			  tmp_network->assoc_type = ASSOC_LEAP;
			}
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 968 "config_grammar.y"
    {
                           parameter_debug("Control Wireless = YES\n");
			   set_current_network();
			   if (tmp_network->wireless_ctrl == CTL_UNSET)
			     tmp_network->wireless_ctrl = CTL_YES;
                         }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 974 "config_grammar.y"
    {
			   parameter_debug("Control Wireless = NO\n");
			   set_current_network();
			   if (tmp_network->wireless_ctrl == CTL_UNSET)
			     tmp_network->wireless_ctrl = CTL_NO;
			 }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 980 "config_grammar.y"
    {
			   set_current_network();
			   tmp_network->wireless_ctrl = CTL_UNSET;
			   printf("Unknown option for Control Wireless = \"%s\"!  Defaulting to UNSET! (Line : %d)\n", (yyvsp[(3) - (3)].str), config_linenum);
			 }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 987 "config_grammar.y"
    {
                            parameter_debug("ID: \"%s\"\n", (yyvsp[(3) - (3)].str));
			    set_current_network();
			    if (!tmp_network->identity)
			      tmp_network->identity = (yyvsp[(3) - (3)].str);
			    else
			      free((yyvsp[(3) - (3)].str));
                          }
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 995 "config_grammar.y"
    {
			    parameter_debug("ID: \"%s\"\n", (yyvsp[(3) - (3)].str));
			    set_current_network();
			    if (!tmp_network->identity)
			      tmp_network->identity = (yyvsp[(3) - (3)].str);
			    else
			      free((yyvsp[(3) - (3)].str));
			  }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 1003 "config_grammar.y"
    {
			    parameter_debug("ID: \"%s\"\n", (yyvsp[(3) - (3)].str));
			    set_current_network();
			    if (!tmp_network->identity)
			      tmp_network->identity = (yyvsp[(3) - (3)].str);
			    else
			      free((yyvsp[(3) - (3)].str));
			  }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 1013 "config_grammar.y"
    {
                          parameter_debug("Use TNC : Yes");
                          set_current_network();
                          SET_FLAG(tmp_network->flags, CONFIG_NET_USE_TNC);
                        }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 1018 "config_grammar.y"
    {
                          parameter_debug("Use TNC : No");
                          set_current_network();
                          UNSET_FLAG(tmp_network->flags, CONFIG_NET_USE_TNC);
                        }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 1025 "config_grammar.y"
    {
                            parameter_debug("Dest Mac: %s\n", (yyvsp[(3) - (3)].str));
			    set_current_network();
			    if (TEST_FLAG(tmp_network->flags, CONFIG_NET_DEST_MAC)) {
			      free((yyvsp[(3) - (3)].str));
			    }
			    else {
			      int tmp_dst_mac[CONFIG_MAC_LEN];
			      int retval;
			      SET_FLAG(tmp_network->flags, CONFIG_NET_DEST_MAC);
			      retval = sscanf((yyvsp[(3) - (3)].str), "%2x:%2x:%2x:%2x:%2x:%2x", 
				     &tmp_dst_mac[0], 
				     &tmp_dst_mac[1], 
				     &tmp_dst_mac[2], 
				     &tmp_dst_mac[3], 
				     &tmp_dst_mac[4], 
				     &tmp_dst_mac[5]);
			      tmp_network->dest_mac[0] = tmp_dst_mac[0];
			      tmp_network->dest_mac[1] = tmp_dst_mac[1];
			      tmp_network->dest_mac[2] = tmp_dst_mac[2];
			      tmp_network->dest_mac[3] = tmp_dst_mac[3];
			      tmp_network->dest_mac[4] = tmp_dst_mac[4];
			      tmp_network->dest_mac[5] = tmp_dst_mac[5];
			    }
                         }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 1052 "config_grammar.y"
    {
                           parameter_debug("Allow Types: ALL\n");
			   set_current_network();
			   SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_ALL);
                       }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 1060 "config_grammar.y"
    {
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_TLS)) {
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_TLS,
					       tmp_tls);
		       }
		       else 
			 delete_config_eap_tls(&tmp_tls);
		       tmp_tls = NULL;
                      }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 1072 "config_grammar.y"
    {
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_MD5))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_MD5,
					       tmp_md5);
		       else 
			 delete_config_eap_md5(&tmp_md5);
		       tmp_md5 = NULL;
                      }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 1083 "config_grammar.y"
    {
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_TTLS))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_TTLS,
					       tmp_ttls);
		       else 
			 delete_config_eap_ttls(&tmp_ttls);
		       tmp_ttls = NULL;
                      }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 1094 "config_grammar.y"
    {
		      set_current_network();
		      if (!config_eap_method_contains_method(tmp_network->methods,
							     STATIC_WEP_METHOD))
			add_config_eap_method(&(tmp_network->methods),
					      STATIC_WEP_METHOD,
					      tmp_static_wep);
		      }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 1102 "config_grammar.y"
    {
		      set_current_network();
                      tmp_network->initial_wep = tmp_initial_wep;
		    }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 1106 "config_grammar.y"
    {
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_LEAP))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_LEAP,
					       tmp_leap);
		       else 
			 delete_config_eap_leap(&tmp_leap);
		       tmp_leap = NULL;
                      }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 1117 "config_grammar.y"
    {
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_MSCHAPV2))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_MSCHAPV2,
					       tmp_mschapv2);
		       else 
			 delete_config_eap_mschapv2(&tmp_mschapv2);
		       tmp_mschapv2 = NULL;
                      }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 1128 "config_grammar.y"
    {
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_PEAP))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_PEAP,
					       tmp_peap);
		       else 
			 delete_config_eap_peap(&tmp_peap);
		       tmp_peap = NULL;
                      }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 1139 "config_grammar.y"
    {
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_SIM))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_SIM,
					       tmp_sim);
		       else 
			 delete_config_eap_sim(&tmp_sim);
		       tmp_sim = NULL;
                      }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 1150 "config_grammar.y"
    {
		      set_current_network();
		      if (!config_eap_method_contains_method(tmp_network->methods,
							     EAP_TYPE_AKA))
			add_config_eap_method(&(tmp_network->methods),
					      EAP_TYPE_AKA,
					      tmp_aka);
		      else
			delete_config_eap_aka(&tmp_aka);
		      tmp_aka = NULL;
                      }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 1161 "config_grammar.y"
    {
		      set_current_network();
		      if (!config_eap_method_contains_method(tmp_network->methods,
							     WPA_PSK))
			add_config_eap_method(&(tmp_network->methods),
					      WPA_PSK,
					      tmp_wpa_psk);
		      else
			delete_config_wpa_psk(&tmp_wpa_psk);
		      tmp_wpa_psk = NULL;
                      }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 1178 "config_grammar.y"
    {
                        parameter_debug("Allow Type: TLS\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_TLS);
                      }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 1183 "config_grammar.y"
    {
                        parameter_debug("Allow Type: MD5\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_MD5);
                      }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 1188 "config_grammar.y"
    {
                        parameter_debug("Allow Type: TTLS\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_TTLS);
                      }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 1193 "config_grammar.y"
    {
                        parameter_debug("Allow Type: LEAP\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_LEAP);
                      }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 1198 "config_grammar.y"
    {
                        parameter_debug("Allow Type: MSCHAPV2\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_MSCV2);
                      }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 1203 "config_grammar.y"
    {
                        parameter_debug("Allow Type: PEAP\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_PEAP);
                      }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 1208 "config_grammar.y"
    {
                        parameter_debug("Allow Type: SIM\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_SIM);
                      }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 1213 "config_grammar.y"
    {
		        parameter_debug("Allow Type: AKA\n");
		        set_current_network();
		        SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_AKA);
		      }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 1218 "config_grammar.y"
    {
                        parameter_debug("Allow Type: GTC\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_GTC);
                      }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 1223 "config_grammar.y"
    {
                        parameter_debug("Allow Type: OTP\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_OTP);
                      }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 1231 "config_grammar.y"
    {
                        set_current_static_wep();  
                      }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 1240 "config_grammar.y"
    {
                        set_current_static_wep();
                        parameter_debug("Static Key 1 : %s\n", (yyvsp[(3) - (3)].str));
			if (!tmp_static_wep->key[1])
			  tmp_static_wep->key[1] = (uint8_t *) (yyvsp[(3) - (3)].str);
                      }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 1246 "config_grammar.y"
    {
		        set_current_static_wep();
		        parameter_debug("Static Key 2 : %s\n", (yyvsp[(3) - (3)].str));
		        if (!tmp_static_wep->key[2])
			  tmp_static_wep->key[2] = (uint8_t *) (yyvsp[(3) - (3)].str);
		    }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 1252 "config_grammar.y"
    {
		        set_current_static_wep();
                        parameter_debug("Static Key 3 : %s\n", (yyvsp[(3) - (3)].str));
                        if (!tmp_static_wep->key[3])
                          tmp_static_wep->key[3] = (uint8_t *) (yyvsp[(3) - (3)].str);
                    }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 1258 "config_grammar.y"
    {
		        set_current_static_wep();
                        parameter_debug("Static Key 4 : %s\n", (yyvsp[(3) - (3)].str));
                        if (!tmp_static_wep->key[4])
                          tmp_static_wep->key[4] = (uint8_t *) (yyvsp[(3) - (3)].str);
                    }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 1264 "config_grammar.y"
    {
                        set_current_static_wep();
                        parameter_debug("TX Key : %d\n", (yyvsp[(3) - (3)].num));
			if (((yyvsp[(3) - (3)].num)>4) || ((yyvsp[(3) - (3)].num)<1))
			  {
			    printf("Static WEP key index is out of range!  It must be a number in the range 1..4!  Defaulting to 1.\n");
			    tmp_static_wep->tx_key = 1;
			  } else {
			    tmp_static_wep->tx_key = (yyvsp[(3) - (3)].num);
			  }
                    }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 1278 "config_grammar.y"
    {
                        set_current_initial_wep();
                      }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 1287 "config_grammar.y"
    {
                        set_current_initial_wep();
                        parameter_debug("Initial Key 1 : %s\n", (yyvsp[(3) - (3)].str));
			if (!tmp_initial_wep->key[1])
			  tmp_initial_wep->key[1] = (uint8_t *) (yyvsp[(3) - (3)].str);
                    }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 1293 "config_grammar.y"
    {
		        set_current_initial_wep();
		        parameter_debug("Initial Key 2 : %s\n", (yyvsp[(3) - (3)].str));
		        if (!tmp_initial_wep->key[2])
			  tmp_initial_wep->key[2] = (uint8_t *) (yyvsp[(3) - (3)].str);
		    }
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 1299 "config_grammar.y"
    {
		        set_current_initial_wep();
                        parameter_debug("Initial Key 3 : %s\n", (yyvsp[(3) - (3)].str));
                        if (!tmp_initial_wep->key[3])
                          tmp_initial_wep->key[3] = (uint8_t *) (yyvsp[(3) - (3)].str);
                    }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 1305 "config_grammar.y"
    {
		        set_current_initial_wep();
                        parameter_debug("Initial Key 4 : %s\n", (yyvsp[(3) - (3)].str));
                        if (!tmp_initial_wep->key[4])
                          tmp_initial_wep->key[4] = (uint8_t *) (yyvsp[(3) - (3)].str);
                    }
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 1311 "config_grammar.y"
    {
                        set_current_initial_wep();
                        parameter_debug("Initial TX Key : %d\n", (yyvsp[(3) - (3)].num));
			if (((yyvsp[(3) - (3)].num)>4) || ((yyvsp[(3) - (3)].num)<1))
			  {
			    printf("Initial WEP key index is out of range!  It must be a number in the range 1..4!  Defaulting to 1.\n");
			    tmp_initial_wep->tx_key = 1;
			  } else {
			    tmp_initial_wep->tx_key = (yyvsp[(3) - (3)].num);
                     }
                    }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 1326 "config_grammar.y"
    {
                        set_current_tls(); /* define an empty tls struct*/
                      }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 1335 "config_grammar.y"
    {
		    	set_current_tls();
			parameter_debug("Using Engine: \"%s\"\n", 
						tmp_tls->sc.engine_id);
		      }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 1347 "config_grammar.y"
    {
                        set_current_tls();
			tmp_tls->sc.engine_id = strdup((yyvsp[(3) - (3)].str));
		        parameter_debug("engine: \"%s\"\n", 
						tmp_tls->sc.engine_id);
		      }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 1353 "config_grammar.y"
    {
                        set_current_tls();
			tmp_tls->sc.opensc_so_path = (yyvsp[(3) - (3)].str);
                        parameter_debug("opensc_so_path: \"%s\"\n", 
						tmp_tls->sc.opensc_so_path);
                      }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 1359 "config_grammar.y"
    {
		        set_current_tls();
			tmp_tls->sc.opensc_so_path = (yyvsp[(3) - (3)].str);
			parameter_debug("opensc_so_path: \"%s\"\n",
					tmp_tls->sc.opensc_so_path);
		    }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 1365 "config_grammar.y"
    {
                        set_current_tls();
			tmp_tls->sc.key_id = (yyvsp[(3) - (3)].str);
                        parameter_debug("cert_id: \"%s\"\n", 
						tmp_tls->sc.key_id);
                      }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 1371 "config_grammar.y"
    {
                        set_current_tls();
			tmp_tls->sc.key_id = (char *)malloc(5);
			sprintf(tmp_tls->sc.key_id, "%d", (yyvsp[(3) - (3)].num));
                        parameter_debug("cert_id: \"%s\"\n", 
						tmp_tls->sc.key_id);
                      }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 1380 "config_grammar.y"
    {
                        parameter_debug("tls user cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->user_cert)
			  tmp_tls->user_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
                      }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 1388 "config_grammar.y"
    {
  		        parameter_debug("tls user cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->user_cert)
			  tmp_tls->user_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
		      }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 1396 "config_grammar.y"
    {
	 	        parameter_debug("tls user key: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->user_key)
			  tmp_tls->user_key = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 1404 "config_grammar.y"
    {
 		        parameter_debug("tls user key: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->user_key)
			  tmp_tls->user_key = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
		      }
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 1412 "config_grammar.y"
    {
	 	        parameter_debug("tls user pass: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->user_key_pass)
			  tmp_tls->user_key_pass = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 1420 "config_grammar.y"
    {
		        parameter_debug("tls user pass: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->user_key_pass)
			  tmp_tls->user_key_pass = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
		      }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 1428 "config_grammar.y"
    {
		        parameter_debug("tls user pass: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->user_key_pass)
			  tmp_tls->user_key_pass = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
		      }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 1436 "config_grammar.y"
    {
		        parameter_debug("Session Resumption = YES\n");
		        set_current_tls();
		        if (tmp_tls->session_resume == RES_UNSET)
			  tmp_tls->session_resume = RES_YES;
		      }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 1442 "config_grammar.y"
    {
			parameter_debug("Session Resumption = NO\n");
			set_current_tls();
			if (tmp_tls->session_resume == RES_UNSET)
			  tmp_tls->session_resume = RES_NO;
		      }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 1448 "config_grammar.y"
    {
		      set_current_tls();
		      tmp_tls->session_resume = RES_NO;
		      printf("Invalid value for session resumption = \"%s\"!  Defaulting to NO! (Line : %d)\n", (yyvsp[(3) - (3)].str), config_linenum);
		    }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 1453 "config_grammar.y"
    {
	 	        parameter_debug("tls root_cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->root_cert)
			  tmp_tls->root_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 1461 "config_grammar.y"
    {
		        parameter_debug("tls root_cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->root_cert)
			  tmp_tls->root_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
		      }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 1469 "config_grammar.y"
    {
	 	        parameter_debug("tls root_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->root_dir)
			  tmp_tls->root_dir = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 1477 "config_grammar.y"
    {
		        parameter_debug("tls root_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->root_dir)
			  tmp_tls->root_dir = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
		      }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 1485 "config_grammar.y"
    {
	 	        parameter_debug("tls crl_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->crl_dir)
			  tmp_tls->crl_dir = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 1493 "config_grammar.y"
    {
		        parameter_debug("tls crl_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->crl_dir)
			  tmp_tls->crl_dir = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
		      }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 1501 "config_grammar.y"
    {
 		        parameter_debug("tls chunk: %d\n", (yyvsp[(3) - (3)].num));
			set_current_tls();
			if (tmp_tls->chunk_size == 0)
			  tmp_tls->chunk_size = (yyvsp[(3) - (3)].num);
  		      }
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 1507 "config_grammar.y"
    {
	 	        parameter_debug("tls rand: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->random_file)
			  tmp_tls->random_file = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 1515 "config_grammar.y"
    {
		        parameter_debug("tls rand: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_tls();
			if (!tmp_tls->random_file)
			  tmp_tls->random_file = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
		    }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 1527 "config_grammar.y"
    {
                        set_current_md5(); /* define an empty md5 struct*/
                      }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 1536 "config_grammar.y"
    {
                       parameter_debug("md5 username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_md5();
		       if (!tmp_md5->username)
			 tmp_md5->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 1544 "config_grammar.y"
    {
		       parameter_debug("md5 username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_md5();
		       if (!tmp_md5->username)
			 tmp_md5->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 1552 "config_grammar.y"
    {
		       parameter_debug("md5 username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_md5();
		       if (!tmp_md5->username)
			 tmp_md5->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 1560 "config_grammar.y"
    {
		       parameter_debug("md5 password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_md5();
		       if (!tmp_md5->password)
			 tmp_md5->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 1568 "config_grammar.y"
    {
		       parameter_debug("md5 password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_md5();
		       if (!tmp_md5->password)
			 tmp_md5->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 1576 "config_grammar.y"
    {
		       parameter_debug("md5 password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_md5();
		       if (!tmp_md5->password)
			 tmp_md5->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1587 "config_grammar.y"
    {
                        set_current_ttls(); /* define an empty ttls struct*/
                      }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1596 "config_grammar.y"
    {
                        parameter_debug("ttls user cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->user_cert)
			  tmp_ttls->user_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
                      }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1604 "config_grammar.y"
    {
		        parameter_debug("ttls user cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->user_cert)
			  tmp_ttls->user_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
		      }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1612 "config_grammar.y"
    {
	 	        parameter_debug("ttls user key: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->user_key)
			  tmp_ttls->user_key = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1620 "config_grammar.y"
    {
	 	        parameter_debug("ttls user key: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->user_key)
			  tmp_ttls->user_key = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1628 "config_grammar.y"
    {
	 	        parameter_debug("ttls user pass: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->user_key_pass)
			  tmp_ttls->user_key_pass = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1636 "config_grammar.y"
    {
	 	        parameter_debug("ttls user pass: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->user_key_pass)
			  tmp_ttls->user_key_pass = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1644 "config_grammar.y"
    {
	 	        parameter_debug("ttls user pass: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->user_key_pass)
			  tmp_ttls->user_key_pass = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1652 "config_grammar.y"
    {
	 	        parameter_debug("ttls root_cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->root_cert)
			  tmp_ttls->root_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 1660 "config_grammar.y"
    {
	 	        parameter_debug("ttls root_cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->root_cert)
			  tmp_ttls->root_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1668 "config_grammar.y"
    {
	 	        parameter_debug("ttls root_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->root_dir)
			  tmp_ttls->root_dir = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 1676 "config_grammar.y"
    {
	 	        parameter_debug("ttls root_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->root_dir)
			  tmp_ttls->root_dir = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1684 "config_grammar.y"
    {
	 	        parameter_debug("ttls crl_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->crl_dir)
			  tmp_ttls->crl_dir = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 1692 "config_grammar.y"
    {
	 	        parameter_debug("ttls crl_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->crl_dir)
			  tmp_ttls->crl_dir = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 1700 "config_grammar.y"
    {
 		        parameter_debug("ttls chunk: %d\n", (yyvsp[(3) - (3)].num));
			set_current_ttls();
			if (tmp_ttls->chunk_size == 0)
			  tmp_ttls->chunk_size = (yyvsp[(3) - (3)].num);
  		      }
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 1706 "config_grammar.y"
    {
	 	        parameter_debug("ttls rand: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->random_file)
			  tmp_ttls->random_file = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 1714 "config_grammar.y"
    {
	 	        parameter_debug("ttls rand: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_ttls();
			if (!tmp_ttls->random_file)
			  tmp_ttls->random_file = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 1722 "config_grammar.y"
    {
		        parameter_debug("Session Resumption = YES\n");
		        set_current_ttls();
		        if (tmp_ttls->session_resume == RES_UNSET)
			  tmp_ttls->session_resume = RES_YES;
		      }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 1728 "config_grammar.y"
    {
			parameter_debug("Session Resumption = NO\n");
			set_current_ttls();
			if (tmp_ttls->session_resume == RES_UNSET)
			  tmp_ttls->session_resume = RES_NO;
		      }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 1734 "config_grammar.y"
    {
		      set_current_ttls();
		      tmp_ttls->session_resume = RES_NO;
		      printf("Invalid value for session resume = \"%s\"!  Defaulting to NO!  (Line : %d)\n", (yyvsp[(3) - (3)].str), config_linenum);
		    }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 1739 "config_grammar.y"
    {
		        parameter_debug("ttls CN check : \"%s\"\n", (yyvsp[(3) - (3)].str));
                        set_current_ttls();
                        if (!tmp_ttls->cncheck)
                          tmp_ttls->cncheck = (yyvsp[(3) - (3)].str);
                        else
                          free((yyvsp[(3) - (3)].str));
		      }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 1747 "config_grammar.y"
    {
  		        parameter_debug("match CN exactly : \"yes\"\n");
		        set_current_ttls();
		        tmp_ttls->cnexact = 1;
		    }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 1752 "config_grammar.y"
    {
  		        parameter_debug("match CN exactly : \"no\"\n");
		        set_current_ttls();
		        tmp_ttls->cnexact = 0;
		    }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 1757 "config_grammar.y"
    {
	 	        parameter_debug("ttls phase2_type 'pap'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_PAP;
        	      }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 1767 "config_grammar.y"
    {
	 	        parameter_debug("ttls phase2_type 'chap'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_CHAP;
        	      }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 1777 "config_grammar.y"
    {
	 	        parameter_debug("ttls phase2_type 'mschap'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_MSCHAP;
        	      }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 1787 "config_grammar.y"
    {
	 	        parameter_debug("ttls phase2_type 'mschapv2'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_MSCHAPV2;
        	      }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 1797 "config_grammar.y"
    {
                        parameter_debug("ttls phase2_type 'eap_md5'\n");
                        if (tmp_ttls &&
                            tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
                          cleanup_parse();
                          return XECONFIGPARSEFAIL;
                        }
                        set_current_ttls();
                        tmp_ttls->phase2_type = TTLS_PHASE2_EAP_MD5;
                     }
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1817 "config_grammar.y"
    {
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_PAP))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_PAP,
						tmp_p2pap);
		       else
			 delete_config_pap(&tmp_p2pap);
		       tmp_p2pap = NULL;
                      }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1834 "config_grammar.y"
    {
                       parameter_debug("pap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2pap();
		       if (!tmp_p2pap->username)
			 tmp_p2pap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 1842 "config_grammar.y"
    {
                       parameter_debug("pap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2pap();
		       if (!tmp_p2pap->username)
			 tmp_p2pap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 1850 "config_grammar.y"
    {
                       parameter_debug("pap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2pap();
		       if (!tmp_p2pap->username)
			 tmp_p2pap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1858 "config_grammar.y"
    {
		       parameter_debug("pap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2pap();
		       if (!tmp_p2pap->password)
			 tmp_p2pap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1866 "config_grammar.y"
    {
		       parameter_debug("pap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2pap();
		       if (!tmp_p2pap->password)
			 tmp_p2pap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1874 "config_grammar.y"
    {
		       parameter_debug("pap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2pap();
		       if (!tmp_p2pap->password)
			 tmp_p2pap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1884 "config_grammar.y"
    {
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_CHAP))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_CHAP,
						tmp_p2chap);
		       else
			 delete_config_chap(&tmp_p2chap);
		       tmp_p2chap = NULL;
                      }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1901 "config_grammar.y"
    {
                       parameter_debug("chap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2chap();
		       if (!tmp_p2chap->username)
			 tmp_p2chap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1909 "config_grammar.y"
    {
                       parameter_debug("chap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2chap();
		       if (!tmp_p2chap->username)
			 tmp_p2chap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1917 "config_grammar.y"
    {
                       parameter_debug("chap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2chap();
		       if (!tmp_p2chap->username)
			 tmp_p2chap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 1925 "config_grammar.y"
    {
		       parameter_debug("chap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2chap();
		       if (!tmp_p2chap->password)
			 tmp_p2chap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 1933 "config_grammar.y"
    {
		       parameter_debug("chap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2chap();
		       if (!tmp_p2chap->password)
			 tmp_p2chap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1941 "config_grammar.y"
    {
		       parameter_debug("chap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2chap();
		       if (!tmp_p2chap->password)
			 tmp_p2chap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1951 "config_grammar.y"
    {
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_MSCHAP))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_MSCHAP,
						tmp_p2mschap);
		       else
			 delete_config_mschap(&tmp_p2mschap);
		       tmp_p2mschap = NULL;
                      }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1968 "config_grammar.y"
    {
                       parameter_debug("mschap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschap();
		       if (!tmp_p2mschap->username)
			 tmp_p2mschap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1976 "config_grammar.y"
    {
                       parameter_debug("mschap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschap();
		       if (!tmp_p2mschap->username)
			 tmp_p2mschap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1984 "config_grammar.y"
    {
                       parameter_debug("mschap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschap();
		       if (!tmp_p2mschap->username)
			 tmp_p2mschap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1992 "config_grammar.y"
    {
		       parameter_debug("mschap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschap();
		       if (!tmp_p2mschap->password)
			 tmp_p2mschap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 2000 "config_grammar.y"
    {
		       parameter_debug("mschap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschap();
		       if (!tmp_p2mschap->password)
			 tmp_p2mschap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 2008 "config_grammar.y"
    {
		       parameter_debug("mschap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschap();
		       if (!tmp_p2mschap->password)
			 tmp_p2mschap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 2019 "config_grammar.y"
    {
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_MSCHAPV2))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_MSCHAPV2,
						tmp_p2mschapv2);
		       else
			 delete_config_mschapv2(&tmp_p2mschapv2);
		       tmp_p2mschapv2 = NULL;
                      }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 2036 "config_grammar.y"
    {
                       parameter_debug("mschapv2 username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->username)
			 tmp_p2mschapv2->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 2044 "config_grammar.y"
    {
                       parameter_debug("mschapv2 username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->username)
			 tmp_p2mschapv2->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 2052 "config_grammar.y"
    {
                       parameter_debug("mschapv2 username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->username)
			 tmp_p2mschapv2->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 2060 "config_grammar.y"
    {
		       parameter_debug("mschapv2 password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->password)
			 tmp_p2mschapv2->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 2068 "config_grammar.y"
    {
		       parameter_debug("mschapv2 password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->password)
			 tmp_p2mschapv2->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 2076 "config_grammar.y"
    {
		       parameter_debug("mschapv2 password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->password)
			 tmp_p2mschapv2->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 2086 "config_grammar.y"
    {
		       set_current_ttls();
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
                                                                 TTLS_PHASE2_EAP_MD5))
		         add_config_ttls_phase2(&(tmp_ttls->phase2),
			  	  	        TTLS_PHASE2_EAP_MD5,
					        tmp_md5);
		       else
		         delete_config_eap_md5(&tmp_md5);
		       tmp_p2mschapv2 = NULL;
                     }
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 2100 "config_grammar.y"
    {
                        set_current_leap(); /* define an empty leap struct*/
                      }
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 2109 "config_grammar.y"
    {
                       parameter_debug("leap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_leap();
		       if (!tmp_leap->username)
			 tmp_leap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 2117 "config_grammar.y"
    {
                       parameter_debug("leap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_leap();
		       if (!tmp_leap->username)
			 tmp_leap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 2125 "config_grammar.y"
    {
                       parameter_debug("leap username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_leap();
		       if (!tmp_leap->username)
			 tmp_leap->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 2133 "config_grammar.y"
    {
		       parameter_debug("leap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_leap();
		       if (!tmp_leap->password)
			 tmp_leap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 2141 "config_grammar.y"
    {
		       parameter_debug("leap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_leap();
		       if (!tmp_leap->password)
			 tmp_leap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 2149 "config_grammar.y"
    {
		       parameter_debug("leap password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_leap();
		       if (!tmp_leap->password)
			 tmp_leap->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 2160 "config_grammar.y"
    {
                        set_current_mschapv2(); /* define an empty mschapv2 struct*/
                      }
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 2169 "config_grammar.y"
    {
                       parameter_debug("mschapv2 username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_mschapv2();
		       if (!tmp_mschapv2->username)
			 tmp_mschapv2->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 2177 "config_grammar.y"
    {
                       parameter_debug("mschapv2 username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_mschapv2();
		       if (!tmp_mschapv2->username)
			 tmp_mschapv2->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 2185 "config_grammar.y"
    {
		       parameter_debug("mschapv2 username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_mschapv2();
		       if (!tmp_mschapv2->username)
			 tmp_mschapv2->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 2193 "config_grammar.y"
    {
		       parameter_debug("mschapv2 password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_mschapv2();
		       if (!tmp_mschapv2->password)
			 tmp_mschapv2->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 2201 "config_grammar.y"
    {
		       parameter_debug("mschapv2 password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_mschapv2();
		       if (!tmp_mschapv2->password)
			 tmp_mschapv2->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 2209 "config_grammar.y"
    {
		       parameter_debug("mschapv2 password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_mschapv2();
		       if (!tmp_mschapv2->password)
			 tmp_mschapv2->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 2217 "config_grammar.y"
    {
                       parameter_debug("mschapv2 NT password hash: \"%s\"\n", (yyvsp[(3) - (3)].str));
                       set_current_mschapv2();
                       if (!tmp_mschapv2->nthash)
                         tmp_mschapv2->nthash = (yyvsp[(3) - (3)].str);
                       else
                         free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 2228 "config_grammar.y"
    {
                        set_current_peap(); /* define an empty peap struct*/
                      }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 2237 "config_grammar.y"
    {
                            parameter_debug("ID: \"%s\"\n", (yyvsp[(3) - (3)].str));
			    set_current_peap();
			    if (!tmp_peap->identity)
			      tmp_peap->identity = (yyvsp[(3) - (3)].str);
			    else
			      free((yyvsp[(3) - (3)].str));
                          }
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 2245 "config_grammar.y"
    {
                            parameter_debug("ID: \"%s\"\n", (yyvsp[(3) - (3)].str));
			    set_current_peap();
			    if (!tmp_peap->identity)
			      tmp_peap->identity = (yyvsp[(3) - (3)].str);
			    else
			      free((yyvsp[(3) - (3)].str));
                          }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 2253 "config_grammar.y"
    {
                            parameter_debug("ID: \"%s\"\n", (yyvsp[(3) - (3)].str));
			    set_current_peap();
			    if (!tmp_peap->identity)
			      tmp_peap->identity = (yyvsp[(3) - (3)].str);
			    else
			      free((yyvsp[(3) - (3)].str));
                          }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 2261 "config_grammar.y"
    {
                        parameter_debug("peap user cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->user_cert)
			  tmp_peap->user_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
                      }
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 2269 "config_grammar.y"
    {
                        parameter_debug("peap user cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->user_cert)
			  tmp_peap->user_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
                      }
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 2277 "config_grammar.y"
    {
	 	        parameter_debug("peap user key: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->user_key)
			  tmp_peap->user_key = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 2285 "config_grammar.y"
    {
	 	        parameter_debug("peap user key: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->user_key)
			  tmp_peap->user_key = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 2293 "config_grammar.y"
    {
	 	        parameter_debug("peap user pass: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->user_key_pass)
			  tmp_peap->user_key_pass = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 2301 "config_grammar.y"
    {
	 	        parameter_debug("peap user pass: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->user_key_pass)
			  tmp_peap->user_key_pass = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 2309 "config_grammar.y"
    {
	 	        parameter_debug("peap user pass: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->user_key_pass)
			  tmp_peap->user_key_pass = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 2317 "config_grammar.y"
    {
	 	        parameter_debug("peap root_cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->root_cert)
			  tmp_peap->root_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 2325 "config_grammar.y"
    {
	 	        parameter_debug("peap root_cert: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->root_cert)
			  tmp_peap->root_cert = (yyvsp[(3) - (3)].str);
			else
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 2333 "config_grammar.y"
    {
	 	        parameter_debug("peap root_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->root_dir)
			  tmp_peap->root_dir = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 2341 "config_grammar.y"
    {
	 	        parameter_debug("peap root_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->root_dir)
			  tmp_peap->root_dir = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 2349 "config_grammar.y"
    {
	 	        parameter_debug("peap crl_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->crl_dir)
			  tmp_peap->crl_dir = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 2357 "config_grammar.y"
    {
	 	        parameter_debug("peap crl_dir: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->crl_dir)
			  tmp_peap->crl_dir = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 2365 "config_grammar.y"
    {
		        parameter_debug("Session Resumption = YES\n");
		        set_current_peap();
		        if (tmp_peap->session_resume == RES_UNSET)
			  tmp_peap->session_resume = RES_YES;
		      }
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 2371 "config_grammar.y"
    {
			parameter_debug("Session Resumption = NO\n");
			set_current_peap();
			if (tmp_peap->session_resume == RES_UNSET)
			  tmp_peap->session_resume = RES_NO;
		      }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 2377 "config_grammar.y"
    {
		      set_current_peap();
		      tmp_peap->session_resume = RES_NO;
		      printf("Invalid setting for PEAP session resumption = \"%s\"!  Defaulting to NO! (Line : %d)\n", (yyvsp[(3) - (3)].str), config_linenum);
		    }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 2382 "config_grammar.y"
    {
		      parameter_debug("Proper PEAPv1 Keying = YES\n");
		      set_current_peap();
		      if (tmp_peap->proper_peapv1 == 0)
			tmp_peap->proper_peapv1 = 1;
		    }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 2388 "config_grammar.y"
    {
		      parameter_debug("Proper PEAPv1 Keying = NO\n");
		      set_current_peap();
		      if (tmp_peap->proper_peapv1 == 1)
			tmp_peap->proper_peapv1 = 0;
		    }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 2394 "config_grammar.y"
    {
		      parameter_debug("Unknown 'Proper PEAPv1 Keying' setting!\n");
		      printf("Unknown value for 'proper_peap_v1_keying'!\n");
		    }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 2398 "config_grammar.y"
    {
                      parameter_debug("inner id : %s\n", (yyvsp[(3) - (3)].str));
                      set_current_peap();
                      if (!tmp_peap->identity)
			tmp_peap->identity = (yyvsp[(3) - (3)].str);
                    }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 2404 "config_grammar.y"
    {
		      parameter_debug("inner id : %s\n", (yyvsp[(3) - (3)].str));
		      set_current_peap();
		      if (!tmp_peap->identity)
			tmp_peap->identity = (yyvsp[(3) - (3)].str);
		    }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 2410 "config_grammar.y"
    {
 		        parameter_debug("peap chunk: %d\n", (yyvsp[(3) - (3)].num));
			set_current_peap();
			if (tmp_peap->chunk_size == 0)
			  tmp_peap->chunk_size = (yyvsp[(3) - (3)].num);
  		      }
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 2416 "config_grammar.y"
    {
		        parameter_debug("peap CN check : \"%s\"\n", (yyvsp[(3) - (3)].str));
                        set_current_peap();
                        if (!tmp_peap->cncheck)
                          tmp_peap->cncheck = (yyvsp[(3) - (3)].str);
                        else
                          free((yyvsp[(3) - (3)].str));
		      }
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 2424 "config_grammar.y"
    {
  		        parameter_debug("match CN exactly : \"yes\"\n");
		        set_current_peap();
		        tmp_peap->cnexact = 1;
		    }
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 2429 "config_grammar.y"
    {
  		        parameter_debug("match CN exactly : \"no\"\n");
		        set_current_peap();
		        tmp_peap->cnexact = 0;
       		    }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 2434 "config_grammar.y"
    {
	 	        parameter_debug("peap rand: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->random_file)
			  tmp_peap->random_file = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 2442 "config_grammar.y"
    {
	 	        parameter_debug("peap rand: \"%s\"\n", (yyvsp[(3) - (3)].str));
			set_current_peap();
			if (!tmp_peap->random_file)
			  tmp_peap->random_file = (yyvsp[(3) - (3)].str);
			else 
			  free((yyvsp[(3) - (3)].str));
        	      }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 2450 "config_grammar.y"
    {
		       parameter_debug("peap ias quirk: YES\n");
		       set_current_peap();
		       tmp_peap->ias_quirk=1;
		     }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 2455 "config_grammar.y"
    {
		       parameter_debug("peap ias quirk: NO\n");
		       set_current_peap();
		       tmp_peap->ias_quirk=0;
		     }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 2460 "config_grammar.y"
    {
		       parameter_debug("peap ias quirk: %s\n", (yyvsp[(3) - (3)].str));
		       parameter_debug("Defaulting to NO!\n");
		       set_current_peap();
		       tmp_peap->ias_quirk=0;
		     }
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 2466 "config_grammar.y"
    {}
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 2467 "config_grammar.y"
    {}
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 2470 "config_grammar.y"
    {
                           parameter_debug("PEAP Allow Types: ALL\n");
			   set_current_peap();
			   SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_ALL);
                       }
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 2482 "config_grammar.y"
    {
                          parameter_debug("PEAP Allow Type: MSCHAPV2\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_MSCV2);
                        }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 2487 "config_grammar.y"
    {
                          parameter_debug("PEAP Allow Type: MD5\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_MD5);
                        }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 2492 "config_grammar.y"
    {
                          parameter_debug("PEAP Allow Type: SIM\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_SIM);
                        }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 2497 "config_grammar.y"
    {
                          parameter_debug("PEAP Allow Type: OTP\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_OTP);
                        }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 2502 "config_grammar.y"
    {
                          parameter_debug("PEAP Allow Type: GTC\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_GTC);
                        }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 2510 "config_grammar.y"
    {
                             set_current_peap(); 
	   	             if (!config_eap_method_contains_method(tmp_peap->phase2,
								    EAP_TYPE_MSCHAPV2))
			       {
			       add_config_eap_method(&(tmp_peap->phase2),
						     EAP_TYPE_MSCHAPV2,
						     tmp_mschapv2);

			       // If we don't have an identity, then copy this
			       // one.
			       if (!tmp_peap->identity)
				 {
				   tmp_peap->identity = strdup(tmp_mschapv2->username);
				 }
			       }
			     else
			       delete_config_eap_mschapv2(&tmp_mschapv2);
			     tmp_mschapv2 = NULL;
                            }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 2530 "config_grammar.y"
    {
                             set_current_peap(); 
	   	             if (!config_eap_method_contains_method(tmp_peap->phase2,
								    EAP_TYPE_MD5))
			       {
			       add_config_eap_method(&(tmp_peap->phase2),
						     EAP_TYPE_MD5,
						     tmp_md5);

			       // If we don't have an identity, then copy this
			       // one.
			       if (!tmp_peap->identity)
				 {
				   tmp_peap->identity = strdup(tmp_md5->username);
				 }
			       }
			     else
			       delete_config_eap_md5(&tmp_md5);
			     tmp_md5 = NULL;
                            }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 2550 "config_grammar.y"
    {
                             set_current_peap(); 
	   	             if (!config_eap_method_contains_method(tmp_peap->phase2,
								    EAP_TYPE_SIM))
			       {
			       add_config_eap_method(&(tmp_peap->phase2),
						     EAP_TYPE_SIM,
						     tmp_sim);
			       
			       // If we don't have an identity, then copy this
			       // one.
			       if (!tmp_peap->identity)
				 {
				   tmp_peap->identity = strdup(tmp_sim->username);
				 }
			       }
			     else
			       delete_config_eap_sim(&tmp_sim);
			     tmp_sim = NULL;
                            }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 2573 "config_grammar.y"
    {
                        set_current_sim(); /* define an empty sim struct*/
                      }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 2582 "config_grammar.y"
    {
                       parameter_debug("sim username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_sim();
		       if (!tmp_sim->username)
			 tmp_sim->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 2590 "config_grammar.y"
    {
                       parameter_debug("sim username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_sim();
		       if (!tmp_sim->username)
			 tmp_sim->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 2598 "config_grammar.y"
    {
                       parameter_debug("sim username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_sim();
		       if (!tmp_sim->username)
			 tmp_sim->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 2606 "config_grammar.y"
    {
		       parameter_debug("sim password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_sim();
		       if (!tmp_sim->password)
			 tmp_sim->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 2614 "config_grammar.y"
    {
		       parameter_debug("sim password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_sim();
		       if (!tmp_sim->password)
			 tmp_sim->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 2622 "config_grammar.y"
    {
		       parameter_debug("sim password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_sim();
		       if (!tmp_sim->password)
			 tmp_sim->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 2630 "config_grammar.y"
    {
  		       parameter_debug("sim auto_realm: \"yes\"\n");
		       set_current_sim();
		       tmp_sim->auto_realm = 1;
		   }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 2635 "config_grammar.y"
    {
  		       parameter_debug("sim auto_realm: \"no\"\n");
		       set_current_sim();
		       tmp_sim->auto_realm = 0;
		   }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 2640 "config_grammar.y"
    {
		       parameter_debug("sim auto_realm: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       parameter_debug("Defaulting to NO!\n");
		       set_current_sim();
		       tmp_sim->auto_realm = 0;
		   }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 2648 "config_grammar.y"
    {
                        set_current_aka(); /* define an empty aka struct*/
                      }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 2657 "config_grammar.y"
    {
                       parameter_debug("aka username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_aka();
		       if (!tmp_aka->username)
			 tmp_aka->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 2665 "config_grammar.y"
    {
                       parameter_debug("aka username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_aka();
		       if (!tmp_aka->username)
			 tmp_aka->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 2673 "config_grammar.y"
    {
                       parameter_debug("aka username: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_aka();
		       if (!tmp_aka->username)
			 tmp_aka->username = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                     }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 2681 "config_grammar.y"
    {
		       parameter_debug("aka password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_aka();
		       if (!tmp_aka->password)
			 tmp_aka->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 2689 "config_grammar.y"
    {
		       parameter_debug("aka password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_aka();
		       if (!tmp_aka->password)
			 tmp_aka->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 2697 "config_grammar.y"
    {
		       parameter_debug("aka password: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_aka();
		       if (!tmp_aka->password)
			 tmp_aka->password = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
		     }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 2705 "config_grammar.y"
    {
  		       parameter_debug("aka auto_realm: \"yes\"\n");
		       set_current_aka();
		       tmp_aka->auto_realm = 1;
		   }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 2710 "config_grammar.y"
    {
  		       parameter_debug("aka auto_realm: \"no\"\n");
		       set_current_aka();
		       tmp_aka->auto_realm = 0;
		   }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 2715 "config_grammar.y"
    {
		       parameter_debug("aka auto_realm: \"%s\"\n", (yyvsp[(3) - (3)].str));
		       set_current_aka();
		       tmp_aka->auto_realm = 0;
		   }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 2722 "config_grammar.y"
    {
                       set_current_wpa_psk(); /* define an empty wpa psk struct*/
                   }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 2731 "config_grammar.y"
    {
                       parameter_debug("ascii key : \"%s\"\n", (yyvsp[(3) - (3)].str));
                       set_current_wpa_psk();
		       if (!tmp_wpa_psk->key)
			 tmp_wpa_psk->key = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                   }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 2739 "config_grammar.y"
    {
                       parameter_debug("ascii key : \"%s\"\n", (yyvsp[(3) - (3)].str));
                       set_current_wpa_psk();
		       if (!tmp_wpa_psk->key)
			 tmp_wpa_psk->key = (yyvsp[(3) - (3)].str);
		       else
			 free((yyvsp[(3) - (3)].str));
                   }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 2747 "config_grammar.y"
    {
                       parameter_debug("hex key : \"%s\"\n", (yyvsp[(3) - (3)].str));
                       set_current_wpa_psk();
                       if (!tmp_wpa_psk->hex_key)
                         tmp_wpa_psk->hex_key = (yyvsp[(3) - (3)].str);
                       else
                         free((yyvsp[(3) - (3)].str));
                   }
    break;



/* Line 1806 of yacc.c  */
#line 6418 "config_grammar.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 2756 "config_grammar.y"


